*DECK EDIADF
      SUBROUTINE EDIADF(IPEDIT,IPFLUX,NGROUP,NSUR  ,NVOL  ,NGCOND,
     >                  IPRINT,FLXNOR,
     >                  IGCOND,MATALB,KEYMRG,VOLSUR,FUNSUR)
C
C-------------------------    EDIADF    -------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME     : EDIADF
C      USE      : COMPUTE INTEGRATED SURFACE FLUX
C      MODIFIED : 2003/09/15 (CREATED BY P. DUFOUR)
C
C  2- ROUTINE PARAMETERS:
C      IPEDIT   : POINTER TO THE EDIT                I
C      IPFLUX   : POINTER TO THE SOLUTION            I
C      NGROUP   : NUMBER OF GROUPS                   I
C      NSUR     : NUMBER OF SURFACES BEFORE MERGE    I
C      NVOL     : NUMBER OF REGIONS BEFORE MERGE     I
C      NGCOND   : NUMBER OF CONDENSED GROUPS         I
C      IPRINT   : PRINT INDEX                        I
C      FLXNOR   : FLUX NORMALIZATION FACTOR          R
C      IGCOND   : CONDENSED GROUPS LIMITS            I(NGCOND)
C      MATALB   : ALBEDO/MIXTURE INDEX               I(-NSUR:NVOL)
C      KEYMRG   : SURFACE/REGION MERGE INDEX         I(-NSUR:NVOL)
C      VOLSUR   : AREA/VOLUME OF REGION              R(-NSUR:NVOL)
C      FUNSUR   : SURFACE FLUXES                     R(NSUR)
C
C---------------------------   EDIADF  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT,NTC,ILCMUP,ILCMDN,MAXS
      PARAMETER  (IOUT=6,NTC=3,ILCMUP=1,ILCMDN=2,MAXS=6)
      CHARACTER   NAMSBR*6
      PARAMETER  (NAMSBR='EDIADF')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPEDIT,IPFLUX,NGROUP,NSUR,NVOL,NGCOND,IPRINT
      REAL        FLXNOR
      INTEGER     IGCOND(NGCOND),MATALB(-NSUR:NVOL),
     >            KEYMRG(-NSUR:NVOL)
      REAL        VOLSUR(-NSUR:NVOL),FUNSUR(NSUR)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CGRPNM*12,CFLUNM*12
      INTEGER     KCHAR(NTC)
      REAL        FLUSUR(MAXS),AREA(MAXS),FLUINT(MAXS)
      REAL        VOLMRG,FLXINT
      INTEGER     IGRC,IGRDEB,IGRFIN,IGROUP,ISUR,I
C----
C  PRISE DE L'INFORMATION
C----
      CALL LCMGET(IPEDIT,'VOLUME',VOLMRG)
C----
C  CALCUL DES SURFACES HOMOGENISES
C----
      DO  I=1,MAXS
        AREA(I)=0.0
      ENDDO
      DO ISUR=1,NSUR
        AREA(-MATALB(-ISUR))=AREA(-MATALB(-ISUR))+VOLSUR(-ISUR)
      ENDDO
C----
C  - INTEGRATION DES FLUX DE SURFACES
C    SUR CHACUNE DES SURFACES EXTERNES;
C  - CONDENSATION EN ENERGIE
C----
      IGRFIN=0
      DO IGRC=1,NGCOND
        IGRDEB=IGRFIN+1
        IGRFIN=IGCOND(IGRC)
        WRITE(CGRPNM,1000) IGRC,NGCOND
        CALL LCMSIX(IPEDIT,CGRPNM,ILCMUP)
        CALL LCMGET(IPEDIT,'FLUX-INTG',FLXINT)
        CALL XDRSET(FLUINT,6,0.0)
        DO IGROUP=IGRDEB,IGRFIN
          WRITE(CFLUNM,2000) IGROUP
          CALL LCMGET(IPFLUX,CFLUNM,FUNSUR)
          DO ISUR=1,NSUR
            FLUINT(-MATALB(-ISUR))=FLUINT(-MATALB(-ISUR))
     >      +FUNSUR(-KEYMRG(-ISUR))*VOLSUR(-ISUR)
         ENDDO
        ENDDO
C----
C  - NORMALISATION DES FLUX DE SURFACES
C    INTEGRES ET CONDENSES;
C  - DIVISION PAR LE FLUX DE VOLUME AFIN D'OBTENIR
C    LES FACTEURS DE DISCONTINUITES APPROXIMES (ADF);
C  - ON DIVISE LES FLUX DE SURFACES INTEGRES PAR
C    LEUR SURFACES CORRESPONDANTES AFIN D'OBTENIR UN FLUX; 
C----
        DO I=1,MAXS
          IF(AREA(I) .GT. 0.0) THEN
            FLUSUR(I)=FLXNOR*FLUINT(I)*VOLMRG/(AREA(I)*FLXINT)
          ELSE
            FLUSUR(I)=1.0
          ENDIF
        ENDDO
        CALL LCMPUT(IPEDIT,'ADFGENERAL  ',MAXS,2,FLUSUR)        
        CALL LCMSIX(IPEDIT,CGRPNM,ILCMDN)
      ENDDO
      RETURN
C----
C  FORMAT
C----
 1000 FORMAT('GROUP',I3,'/',I3)
 2000 FORMAT('FUNSUR',I3)
      END
