*DECK EDIRAT
      SUBROUTINE EDIRAT(IOPERA,NREGIO,NMERGE,IMERGE,MATCOD,
     >                  FLXINT,SIGMAX,RATES )
C
C---------------------------  EDIRAT  ---------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME      : EDIRAT
C      USE       : EVALUATE REACTION RATES FROM X-SECTIONS
C      MODIFIED  : 97-02-10 (G.M.)
C                  91-04-08
C      AUTHOR    : G.MARLEAU
C
C  2- ROUTINE PARAMETERS:
C    INPUT
C      IOPERA    : TYPE OF ACTION TAKEN               I
C                  = 2  ADD CROSS SECTION (NO FLUX)
C                  = 1  ADD REACTION RATES
C                  = 0  EVALUATE INTEGRATED FLUX
C                  =-1  SUBTRACT REACTION RATES
C      NREGIO    : NUMBER OF REGIONS                  I
C      NMERGE    : NUMBER OF MERGED REGIONS           I
C      IMERGE    : REGION MERGING MATRIX              I(NREGIO)
C      MATCOD    : MATERIAL PER REGION                I(NREGIO)
C      FLXINT    : INTEGRATED FLUXES                  R(NREGIO)
C      SIGMAX    : CROSS SECTIONS                     R(0:NMERGE)
C                  (NBMIX=MAX(MATCOD(I)))
C    INPUT/OUTPUT
C      RATES     : INITIAL AND FINAL RATES            D(0:NMERGE)
C
C---------------------------   EDIRAT  --------------------------------
C
      IMPLICIT         NONE
      INTEGER          IOUT
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,NAMSBR='EDIRAT')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER          IOPERA,NREGIO,NMERGE
      INTEGER          IMERGE(NREGIO),MATCOD(NREGIO)
      REAL             FLXINT(NREGIO),SIGMAX(0:NMERGE)
      DOUBLE PRECISION RATES(0:NMERGE)
C----
C  LOCAL PARAMETERS
C----
      INTEGER          IREG,IRATME,MATNUM
C----
C  PROCESS CROSS SECTIONS AND FLUX
C----
      IF(IOPERA .EQ. 0) THEN
C----
C  INTEGRATED FLUXES
C----
        DO 100 IREG=1,NREGIO
          IRATME=IMERGE(IREG)
          RATES(IRATME)=RATES(IRATME)+DBLE(FLXINT(IREG))
 100    CONTINUE
      ELSE IF(IOPERA .EQ. 1) THEN
C----
C  SUM REACTION RATES
C----
        DO 110 IREG=1,NREGIO
          IRATME=IMERGE(IREG)
          MATNUM=MATCOD(IREG)
          RATES(IRATME)=RATES(IRATME)+DBLE(FLXINT(IREG))
     >                 *DBLE(SIGMAX(MATNUM))
 110    CONTINUE
      ELSE IF(IOPERA .EQ. -1) THEN
C----
C  SUBSTRACT REACTION RATES
C----
        DO 120 IREG=1,NREGIO
          IRATME=IMERGE(IREG)
          MATNUM=MATCOD(IREG)
          RATES(IRATME)=RATES(IRATME)-DBLE(FLXINT(IREG))
     >                 *DBLE(SIGMAX(MATNUM))
 120    CONTINUE
      ELSE
C----
C  ADD CROSS SECTIONS
C----
        DO 130 IREG=1,NREGIO
          IRATME=IMERGE(IREG)
          MATNUM=MATCOD(IREG)
          RATES(IRATME)=RATES(IRATME)+DBLE(SIGMAX(MATNUM))
 130    CONTINUE
      ENDIF
      RETURN
      END
