*DECK FLUAQF
      SUBROUTINE FLUAQF(IPMACR,NGROUP,NBMIX ,NREGIO,NIFISS,NUNKNO,
     >                  MATCOD,KEYFLX,FUNKNO,EIGENK,SUNKNO,SIGF  ,
     >                  QTOTL )
*
*---------------------------  FLUAQF  ---------------------------------
*
*   1- PROGRAMME STATISTICS:
*      NAME     : FLUAQF
*      USE      : ADD TO SOURCE $Q$ CONTRIBUTIONS FROM FISSION 
*      MODIFIED : 2003/03/12 (G. MARLEAU)
*
*   2- ROUTINE PARAMETERS:
*    INPUT:
*      IPMACR   : POINTER TO THE MACROLIB              I
*      NGROUP   : NUMBER OF GROUPS.                    I
*      NBMIX    : NUMBER OF MIXTURES.                  I
*      NREGIO   : NUMBER OF REGIONS.                   I
*      NIFISS   : NUMBER OF FISSILE ISOTOPES.          I
*      NUNKNO   : NUMBER OF UNKNOWN IN THE SYSTEM.     I
*      MATCOD   : MATERIAL CODE IN REGIONS.            I(NREGIO)
*      KEYFLX   : FLUX ELEMENTS IN UNKNOWN SYSTEM.     I(NREGIO)
*      FUNKNO   : UNKNOWN VECTOR SOLVED FOR.           R(NUNKNO,NGROUP)
*      EIGENK   : \keff{} and \kinf{} EIGENVALUES      R(2)
*    OUTPUT:
*      SUNKNO   : SOURCE FOR SYSTEM OF UNKNOWN.        R(NUNKNO,NGROUP)
*    WORK:
*      SIGF     : NUSIGF AND CHI STORAGE VECTOR        R(NBMIX,NIFISS)
*      QTOTL    : TOTAL FISSION SOURCE                 D(NREGIO,NIFISS)
*
*---------------------------   FLUAQF  --------------------------------
*
      IMPLICIT         NONE
      INTEGER          IOUT,ILCMUP,ILCMDN
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='FLUAQF')
*----
*  ROUTINE PARAMETERS
*----
      INTEGER          IPMACR,NGROUP,NBMIX,NREGIO,NIFISS,NUNKNO
      INTEGER          MATCOD(NREGIO),KEYFLX(NREGIO)
      REAL             FUNKNO(NUNKNO,NGROUP),EIGENK(2)
      REAL             SUNKNO(NUNKNO,NGROUP)
      REAL             SIGF(NBMIX,NIFISS)
      DOUBLE PRECISION QTOTL(NREGIO,NIFISS)
*----
*  LOCAL PARAMETERS
*---
      CHARACTER        CGRPNM*12,CXSNAM*12
      INTEGER          IGR,IREG,IMIX,IRLOC,IFIS,IPRINT
      INTEGER          ILCMLN,ILCMTY
      DOUBLE PRECISION FACTNO
*----
*  COMPUTE TOTAL FISSION SOURCE 
*  QTOTL=NUSIGF*FLUX
*---- 
      CXSNAM='NUSIGF      '
      IPRINT=0
      CALL XDDSET(QTOTL,NREGIO*NIFISS,0.0D0)
      DO 100 IGR=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
        CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
        CALL LCMGET(IPMACR,CXSNAM,SIGF)
        CALL LCMSIX(IPMACR,CGRPNM,ILCMDN)
        DO 101 IREG=1,NREGIO
          IMIX=MATCOD(IREG)
          IF(IMIX .GT. 0) THEN
            IRLOC=KEYFLX(IREG)
            DO 102 IFIS=1,NIFISS
              QTOTL(IREG,IFIS)=QTOTL(IREG,IFIS)
     >           +DBLE(FUNKNO(IRLOC,IGR)*SIGF(IMIX,IFIS))
 102        CONTINUE
          ENDIF
 101    CONTINUE
 100  CONTINUE
      CXSNAM='CHI         '
      FACTNO=DBLE(1.0/EIGENK(1))
      CALL FLUQFS(IPMACR,IPRINT,NGROUP,NBMIX ,NREGIO,NUNKNO,
     >            NIFISS,MATCOD,KEYFLX,CXSNAM,FACTNO,QTOTL ,
     >            SUNKNO,SIGF  )
      RETURN
      END
