*DECK FLUAQL
      SUBROUTINE FLUAQL(IPFLUX,IPSYS ,NGROUP,NREGIO,NUNKNO,ILEAK ,
     >                  KEYFLX,FUNKNO,B2    ,SUNKNO,DIFF  )
*
*---------------------------  FLUAQL  ---------------------------------
*
*   1- PROGRAMME STATISTICS:
*      NAME     : FLUAQL
*      USE      : ADD TO SOURCE $Q$ CONTRIBUTIONS FROM LEAKAGE 
*      MODIFIED : 2003/03/12 (G. MARLEAU)
*
*   2- ROUTINE PARAMETERS:
*    INPUT:
*      IPFLUX   : POINTER TO THE FLUX DATA STRUCTURE   I
*      IPSYS    : POINTER TO THE PIJ                   I
*      NGROUP   : NUMBER OF GROUPS.                    I
*      NREGIO   : NUMBER OF REGIONS.                   I
*      NUNKNO   : NUMBER OF UNKNOWN IN THE SYSTEM.     I
*      ILEAK    : METHOD USED TO INCLUDE DB2 EFFECT    I
*                 =  0 NO DB2 EFFECT
*                 =  1, 2 AND 3 SUBSTRACT DB2*FLUX 
*                 =  4 INVALID
*                 >= 5 HETEROGENEOUS CASE
*      KEYFLX   : FLUX ELEMENTS IN UNKNOWN SYSTEM.     I(NREGIO)
*      FUNKNO   : UNKNOWN VECTOR SOLVED FOR.           R(NUNKNO,NGROUP)
*      B2       :  X, Y, Z, HOMO BUCKLINGS             R(4)
*    OUTPUT:
*      SUNKNO   : SOURCE FOR SYSTEM OF UNKNOWN.        R(NUNKNO,NGROUP)
*    WORK:
*      DIFF     : STORAGE FOR HOMOGENEOUS DIFFUSION    R(NGROUP)
*                 COEFFICIENTS
*
*---------------------------   FLUAQL  --------------------------------
*
      IMPLICIT         NONE
      INTEGER          IOUT,ILCMUP,ILCMDN
      CHARACTER        NAMSBR*6
      PARAMETER       (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='FLUAQL')
*----
*  ROUTINE PARAMETERS
*----
      INTEGER          IPFLUX,IPSYS,NGROUP,NREGIO,NUNKNO,ILEAK
      INTEGER          KEYFLX(NREGIO)
      REAL             FUNKNO(NUNKNO,NGROUP),B2(4)
      REAL             SUNKNO(NUNKNO,NGROUP)
      REAL             DIFF(NGROUP)
C----
C  MEMORY ALLOCATION
C----
      INTEGER          IBASE(1)
      REAL             RBASE
      COMMON           RBASE(1)
      EQUIVALENCE     (RBASE(1),IBASE(1))
      INTEGER          IPPP
*----
*  LOCAL PARAMETERS
*---
      CHARACTER        CGRPNM*12,CXSNAM*12
      INTEGER          IGR,IREG,IRLOC,IPRINT
      INTEGER          ILCMLN,ILCMTY
*----
*  READ DIFFUSION COEFFICIENTS
*---- 
      IPRINT=0
      CXSNAM='DIFFB1HOM   '
      IF(ILEAK .GE. 5) THEN 
        CALL SETARA(RBASE,NREGIO*NREGIO*3,IPPP)
        CALL FLUQFB(IPSYS ,IPRINT,NGROUP,NREGIO,NUNKNO,
     >              B2    ,FUNKNO,SUNKNO,RBASE(IPPP)  )
        CALL RLSARA(RBASE(IPPP))
      ELSE IF(ILEAK .GE. 1) THEN
        CALL LCMGET(IPFLUX,CXSNAM,DIFF)
        DO 100 IGR=1,NGROUP
          DO 101 IREG=1,NREGIO
            IRLOC=KEYFLX(IREG)
            SUNKNO(IRLOC,IGR)=SUNKNO(IRLOC,IGR)
     >        +B2(4)*DIFF(IGR)*FUNKNO(IRLOC,IGR)
 101      CONTINUE
 100    CONTINUE
      ENDIF 
      RETURN
      END
