*DECK FLURFL
      SUBROUTINE FLURFL(NGROUP,NREGIO,NUNKNO,KEYFLX,FUNKNO)
C
C---------------------------  FLURFL  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : FLURFL
C       USE      : READ FLUX FOR INITIALIZATION ON INPUT
C       MODIFIED : MODIFY DEFINITION OF ITYPEC
C                  2000-01-20  (T. COURAU, G. MARLEAU)
C                  91-03-15  (G. MARLEAU)
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT:
C      NGROUP  : NUMBER OF GROUPS.                    I
C      NREGIO  : NUMBER OF REGIONS.                   I
C      NUNKNO  : NUMBER OF UNKNOWN IN THE SYSTEM.     I
C      KEYFLX  : FLUX ELEMENTS IN UNKNOWN SYSTEM      I(NREGIO)
C      FUNKNO  : UNKNOWN VECTOR SOLVED FOR.           R(NUNKNO,NGROUP)
C
C---------------------------   FLURFL  --------------------------------
C
      IMPLICIT    NONE
      CHARACTER   NAMSBR*6
      PARAMETER  (NAMSBR='FLURFL')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     NGROUP,NREGIO,NUNKNO
      INTEGER     KEYFLX(NREGIO)
      REAL        FUNKNO(NUNKNO,NGROUP)
C----
C  LOCAL PARAMETERS
C----
      CHARACTER   CARLIR*4
      INTEGER     IGROUP,IREGIO,IPOSIT,ITYPLU,INTLIR
      REAL        REALIR
      DOUBLE PRECISION DBLINP
C----
C  READ FLUXES FROM INPUT AND STORE UNKNOWN VECTOR
C----
      CALL XDRSET(FUNKNO,NUNKNO*NGROUP,0.0)
      DO 100 IGROUP=1,NGROUP
        DO 110 IREGIO=1,NREGIO
          IPOSIT=KEYFLX(IREGIO)
          CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLINP)
          IF(ITYPLU.NE.2) CALL XABORT(NAMSBR//
     >      ': READ ERROR - REAL FLUX REQUIRED')
          FUNKNO(IPOSIT,IGROUP)=REALIR
 110    CONTINUE
 100  CONTINUE
      RETURN
      END
