*DECK JPMPRF
      SUBROUTINE JPMPRF (IMPX,NMBLK,IFR,NMERGE,IJAT,INUM,MIX,NGEN,IGEN,
     1 ISURF,MU1,IMA,IGAT)
*
*-----------------------------------------------------------------------
*
* COMPUTE THE COMPRESSED STORAGE PARAMETERS FOR THE (I-WSS*A) MATRIX.
*
*   IMPX   : PRINT FLAG. EQUAL TO ZERO FOR NO PRINT.
*
* INPUT PARAMETERS RELATED TO BLOCKS DEFINITION:
*   NMBLK  : TOTAL NUMBER OF BLOCKS IN THE DOMAIN.
*   IFR    : INDEX-NUMBER OF IN-CURRENTS. DIMENSION IFR(IJAS) WHERE
*            IJAS IS THE TOTAL NUMBER OF IN-CURRENTS SURROUNDING ALL
*            THE BLOCKS.
*
* INPUT PARAMETERS RELATED TO THE MERGED BLOCKS DEFINITION:
*   NMERGE : TOTAL NUMBER OF MERGED BLOCKS FOR WHICH SPECIFIC VALUES
*            OF THE NEUTRON FLUX AND REACTIONS RATES ARE REQUIRED.
*            MANY BLOCKS WITH DIFFERENT POSITION IN THE DOMAIN CAN
*            BE MERGED BEFORE THE NEUTRON FLUX CALCULATION IF THEY
*            OWN THE SAME GENERATING BLOCK. THIS ALLOWS SOME REDUCTION
*            IN CPU TIME AND MEMORY. NMERGE.LE.NMBLK
*   IJAT   : TOTAL NUMBER OF DISTINCT OUT-CURRENTS.
*   INUM   : INDEX-NUMBER OF THE MERGED BLOCK ASSOCIATED TO EACH
*            BLOCK. DIMENSION INUM(NMBLK)
*   MIX    : INDEX-NUMBER OF OUT-CURRENTS. DIMENSION MIX(IJAR) WHERE
*            IJAR IS THE TOTAL NUMBER OF OUT-CURRENTS BELONGING TO THE
*            MERGED BLOCKS.
*
* INPUT PARAMETERS RELATED TO THE GENERATING BLOCKS DEFINITION:
*   NGEN   : TOTAL NUMBER OF GENERATING BLOCKS. A GENERATING BLOCK IS
*            DEFINED BY ITS MIXTURE AND DIMENSIONS IRRESPECTIVE OF
*            ITS POSITION IN THE DOMAIN. NGEN.LE.NMERGE
*   IGEN   : INDEX-NUMBER OF THE GENERATING BLOCK ASSOCIATED WITH EACH
*            MERGED BLOCK. DIMENSION IGEN(NMERGE)
*   ISURF  : NUMBER OF SURFACES ASSOCIATED WITH EACH GENERATING BLOCK.
*            DIMENSION ISURF(NGEN)
*
* OUTPUT PARAMETERS:
*   MU1    : POSITION OF EACH DIAGONAL ELEMENT IN MATRIX (I-WSS*A).
*   IMA    : POSITION OF THE FIRST NON-ZERO COLUMN ELEMENT IN MATRIX
*            (I-WSS*A). DIMENSION MU1(IJAT),IMA(IJAT)
*
* SCRATCH STORAGE:
*   IGAT   : DIMENSION IGAT(NMERGE)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 19/09/89 ---
*
      DIMENSION IFR(*),INUM(*),MIX(*),IGEN(*),ISURF(*),MU1(*),IMA(*),
     1 IGAT(*)
*
      IJAR=0
      DO 10 I=1,NMERGE
      IGAT(I)=IJAR
   10 IJAR=IJAR+ISURF(IGEN(I))
      DO 20 I=1,IJAT
      MU1(I)=1
   20 IMA(I)=1
      IS=0
      DO 50 ICEL=1,NMBLK
      IKK=INUM(ICEL)
      IKG=IGEN(IKK)
      NCOUR=ISURF(IKG)
      IT=IGAT(IKK)
      DO 40 IP=1,NCOUR
      J1=MIX(IT+IP)
      DO 40 JP=1,NCOUR
      J2=IFR(IS+JP)
      MU1(J1)=MAX(MU1(J1),J1-J2+1)
   40 IMA(J2)=MAX(IMA(J2),J2-J1+1)
   50 IS=IS+NCOUR
*
      MAXROW=1
      MAXCOL=1
      II=0
      DO 60 I=1,IJAT
      MAXROW=MAX(MAXROW,MU1(I))
      MAXCOL=MAX(MAXCOL,IMA(I))
      II=II+MU1(I)
      MU1(I)=II
      II=II+IMA(I)-1
   60 IMA(I)=II
      IF (IMPX.GT.1) THEN
         WRITE (6,'(/39H JPMPRF: MAXIMUM ROW PROFILE WIDTH    =,I5/9X,
     1   30HMAXIMUM COLUMN PROFILE WIDTH =,I5)') MAXROW,MAXCOL
      ENDIF
      RETURN
      END
