*DECK LIBDEP
      SUBROUTINE LIBDEP(IPLIB,IMPX,NDEPL)
C
C-----------------------------------------------------------------------
C
C READ THE INFORMATION RELATED TO THE DEPLETION CALCULATION.
C
C INPUT PARAMETERS:
C  IPLIB  : POINTER TO THE INTERNAL MICROSCOPIC CROSS SECTION LIBRARY
C           (L_LIBRARY SIGNATURE).
C  IMPX   : PRINT FLAG.
C OUTPUT PARAMETERS:
C  NDEPL  : NUMBER OF DEPLETING ISOTOPES.
C
C-------------------------------------- AUTHOR: A. HEBERT  01/11/94 ----
C                                     MODIFIED: G. MARLEAU 97/01/08 ----
C
      IMPLICIT NONE
C----
C PARAMETERS
C----
      INTEGER          IOUT,NSTATE,MAXR,MAXDIM
      PARAMETER       (IOUT=6,NSTATE=40,MAXR=5,MAXDIM=4)
C----
C MEMORY ALLOCATION
C----
      INTEGER          IBASE(1)
      REAL             RBASE(1)
      COMMON           RBASE
      EQUIVALENCE     (RBASE(1),IBASE(1))
      INTEGER          ITNAM,ITZEA,MATNO,JKPAX,JBPAX,IDCR,IKPAR,IBPAR,
     1                 IKFISS,IYIELD,IQF,INAM,IIZAE,IDR,IRR
C----
C LOCAL VARIABLES
C----
      INTEGER          INDIC,ITEXT4,NITMA,IEVOT,IPDRL,NSUPL,NSUPF,NEL,
     1                 NAXPAR,NFISS,NDEPL,ITYLCM,NDFI,NDFP,
     2                 NHEAVY,NLIGHT,NOTHER,NBXR,LENGT,IMPX,IPLIB,ISTA
C
      INTEGER          ISTATE(NSTATE),IDIM(MAXDIM)
C
      REAL             FLOTT
C
      CHARACTER        TEXT4*4,HSMG*131,CFILNA*8,HHLIB*6
C
      DOUBLE PRECISION DBLINP
C----
C  READ INFORMATION AVAILABLE ON INPUT
C----
      TEXT4='    '
      READ(TEXT4,'(A4)') ITEXT4
      CALL REDGET(INDIC,NEL,FLOTT,TEXT4,DBLINP)
      IF(INDIC.EQ.1) THEN
         IEVOT=0
      ELSE IF((INDIC.EQ.3).AND.(TEXT4.EQ.'LIB:')) THEN
        CALL REDGET(INDIC,NITMA,FLOTT,HHLIB,DBLINP)
        IF(INDIC.NE.3) THEN
          CALL XABORT('LIBDEP: CHARACTER LIBRARY NAME REQUIRED.')
        ELSE IF((HHLIB.NE.'DRAGON  ') .AND.
     >          (HHLIB.NE.'WIMS    ') .AND.
     >          (HHLIB.NE.'WIMSAECL') .AND.
     >          (HHLIB.NE.'WIMSD4  ')       ) THEN
          WRITE(HSMG,'(30HLIBDEP: INVALID EVOL LIB TYPE ,A6)') HHLIB
          CALL XABORT(HSMG)
        ENDIF
        CALL REDGET(INDIC,NITMA,FLOTT,TEXT4,DBLINP)
        IF((INDIC.NE.3).OR.(TEXT4.NE.'FIL:'))
     >    CALL XABORT('LIBDEP: FIL: EXPECTED.')
        CALL REDGET(INDIC,NITMA,FLOTT,CFILNA,DBLINP)
        IF(INDIC.NE.3) CALL XABORT('LIBDEP: CHARACTER DATA EXPECTED.')
        IF(HHLIB.EQ.'DRAGON') THEN
          CALL LCMOP(IPDRL,CFILNA,2,2,0)
          CALL LCMSIX(IPDRL,'DEPL-CHAIN',1)
          CALL LCMGET(IPDRL,'IDIM',IDIM)
          NSUPL=IDIM(1)
          NSUPF=IDIM(2)
          NAXPAR=IDIM(3)
          NFISS=IDIM(4)
          NDEPL=NSUPL+NSUPF
          NEL=NDEPL
          CALL XDRSET(ISTATE,NSTATE,0)
C----
C  ALLOCATE MEMORY AND INITIALIZE LIBRARY DEPLETION INFORMATION
C----
          CALL SETARA(IBASE,2*NEL,ITNAM)
          CALL SETARA(IBASE,NEL,ITZEA)
          CALL SETARA(IBASE,NEL,MATNO)
          CALL SETARA(IBASE,(NEL+MAXR)*NEL,JKPAX)
          CALL SETARA(RBASE,(NEL+MAXR)*NEL,JBPAX)
          CALL XDRSET(IBASE(ITNAM),2*NEL,ITEXT4)
          CALL XDRSET(IBASE(ITZEA),NEL,0)
          CALL XDRSET(IBASE(MATNO),NEL,0)
          CALL XDRSET(IBASE(JKPAX),(NEL+MAXR)*NEL,0)
          CALL XDRSET(RBASE(JBPAX),(NEL+MAXR)*NEL,0.0)
C----
C  ALLOCATE MEMORY AND INITIALIZE DRAGLIB INFORMATION
C----
          CALL SETARA(RBASE,NDEPL,IDCR)
          CALL SETARA(IBASE,NDEPL*NAXPAR,IKPAR)
          CALL SETARA(RBASE,NDEPL*NAXPAR,IBPAR)
          CALL SETARA(IBASE,NFISS,IKFISS)
          CALL SETARA(RBASE,NFISS*NSUPF,IYIELD)
          CALL SETARA(RBASE,NFISS,IQF)
          CALL LCMGET(IPDRL,'HNADPL',IBASE(ITNAM))
          CALL LCMLEN(IPDRL,'IZAE',LENGT,ITYLCM)
          IF(LENGT.GT.0) CALL LCMGET(IPDRL,'IZAE',IBASE(ITZEA))
          CALL LCMGET(IPDRL,'DCR',RBASE(IDCR))
          CALL LCMGET(IPDRL,'KPAR',IBASE(IKPAR))
          CALL LCMGET(IPDRL,'BPAR',RBASE(IBPAR))
          CALL LCMGET(IPDRL,'KFISS',IBASE(IKFISS))
          CALL LCMGET(IPDRL,'YIELD',RBASE(IYIELD))
          CALL LCMGET(IPDRL,'MEV',RBASE(IQF))
          CALL LCMCL(IPDRL,1)
          CALL LIBEDR(MAXR  ,NAXPAR,NDEPL ,NFISS ,NSUPF ,
     >                RBASE(IDCR)  ,IBASE(IKPAR) ,RBASE(IBPAR) ,
     >                IBASE(IKFISS),RBASE(IYIELD),RBASE(IQF)   ,
     >                IBASE(JKPAX) ,RBASE(JBPAX))
          CALL RLSARA(RBASE(IQF))
          CALL RLSARA(RBASE(IYIELD))
          CALL RLSARA(IBASE(IKFISS))
          CALL RLSARA(RBASE(IBPAR))
          CALL RLSARA(IBASE(IKPAR))
          CALL RLSARA(RBASE(IDCR))
          CALL LIBWET(MAXR,NDEPL,NSTATE,ISTATE,IBASE(MATNO),
     >                IBASE(JKPAX),RBASE(JBPAX))
          NDEPL=ISTATE(1)
          NDFI=ISTATE(2)
          NDFP=ISTATE(3)
          NHEAVY=ISTATE(4)
          NLIGHT=ISTATE(5)
          NOTHER=ISTATE(6)
          NBXR=ISTATE(7)
          IEVOT=1
        ELSE IF(HHLIB.EQ.'WIMS'.OR.HHLIB.EQ.'WIMSAECL') THEN
          CALL LIBEWI(CFILNA,NEL)
          IEVOT=2
        ELSE IF(HHLIB.EQ.'WIMSD4') THEN
          CALL LIBENI(CFILNA,NEL)
          IEVOT=3
        ENDIF
      ELSE
        CALL XABORT('LIBDEP: INVALID KEY WORD.')
      ENDIF
      IF(IEVOT.EQ.0.OR.IEVOT.GT.1) THEN
C----
C  ALLOCATE/INITIALIZE WORK VECTORS FOR WIMS-AECL, WIMSD4
C  AND INPUT FILE
C----
        CALL SETARA(IBASE,2*NEL,ITNAM)
        CALL SETARA(IBASE,NEL,ITZEA)
        CALL SETARA(IBASE,NEL,MATNO)
        CALL SETARA(IBASE,(NEL+MAXR)*NEL,JKPAX)
        CALL SETARA(RBASE,(NEL+MAXR)*NEL,JBPAX)
        CALL XDRSET(IBASE(ITNAM),2*NEL,ITEXT4)
        CALL XDRSET(IBASE(ITZEA),NEL,0)
        CALL XDRSET(IBASE(MATNO),NEL,0)
        CALL XDRSET(IBASE(JKPAX),(NEL+MAXR)*NEL,0)
        CALL XDRSET(RBASE(JBPAX),(NEL+MAXR)*NEL,0.0)
        IF(IEVOT.EQ.0) THEN
          CALL LIBEIR(MAXR,NEL,IBASE(ITNAM),IBASE(ITZEA),
     >                IBASE(JKPAX),RBASE(JBPAX))
        ELSE IF(IEVOT.EQ.2) THEN
          CALL LIBEWR(CFILNA,MAXR,NEL,IBASE(ITNAM),
     >                IBASE(JKPAX),RBASE(JBPAX))
        ELSE IF(IEVOT.EQ.3) THEN
          CALL LIBENR(CFILNA,MAXR,NEL,IBASE(ITNAM),
     >                IBASE(JKPAX),RBASE(JBPAX))
        ENDIF
        CALL LIBWET(MAXR,NEL,NSTATE,ISTATE,IBASE(MATNO),
     >              IBASE(JKPAX),RBASE(JBPAX))
        NDEPL=ISTATE(1)
        NDFI=ISTATE(2)
        NDFP=ISTATE(3)
        NHEAVY=ISTATE(4)
        NLIGHT=ISTATE(5)
        NOTHER=ISTATE(6)
        NBXR=ISTATE(7)
      ENDIF
C----
C   ALLOCATE DECAY CHAIN
C----
      NDEPL=MAX(NDEPL,1)
      NDFI=MAX(NDFI,1)
      NDFP=MAX(NDFP,1)
      CALL SETARA(IBASE,2*NDEPL,INAM)
      CALL SETARA(IBASE,NDEPL,IIZAE)
      CALL SETARA(IBASE,MAXR*NDEPL,IDR)
      CALL SETARA(RBASE,MAXR*NDEPL,IRR)
      CALL SETARA(IBASE,NBXR*NDEPL,IKPAR)
      CALL SETARA(RBASE,NBXR*NDEPL,IBPAR)
      CALL SETARA(RBASE,NDFI*NDFP,IYIELD)
C----
C   INITIALIZE DECAY CHAIN
C----
      CALL XDRSET(IBASE(INAM),2*NDEPL,ITEXT4)
      CALL XDRSET(IBASE(IIZAE),NDEPL,0)
      CALL XDRSET(IBASE(IDR),MAXR*NDEPL,0)
      CALL XDRSET(RBASE(IRR),MAXR*NDEPL,0.0)
      CALL XDRSET(IBASE(IKPAR),NBXR*NDEPL,0)
      CALL XDRSET(RBASE(IBPAR),NBXR*NDEPL,0.0)
      CALL XDRSET(RBASE(IYIELD),NDFI*NDFP,0.0)
      CALL LIBWED(MAXR,NEL,NDEPL,NDFI,NDFP,NHEAVY,NLIGHT,
     >            NBXR,IBASE(ITNAM),IBASE(ITZEA),
     >            IBASE(MATNO),IBASE(JKPAX),RBASE(JBPAX),
     >            IBASE(INAM),IBASE(IIZAE),IBASE(IDR),
     >            RBASE(IRR),IBASE(IKPAR),RBASE(IBPAR),
     >            RBASE(IYIELD))
C----
C  RELEASE WORK VECTORS FOR WIMS-AECL, WIMS-NEA, DRAGLIB
C  AND INPUT FILE
C----
      CALL RLSARA(RBASE(JBPAX))
      CALL RLSARA(IBASE(JKPAX))
      CALL RLSARA(IBASE(MATNO))
      CALL RLSARA(IBASE(ITZEA))
      CALL RLSARA(IBASE(ITNAM))
C----
C  PRINT DECAY CHAIN IF REQUIRED
C----
      IF(IMPX.GE.20) THEN
C----
C  CLOSE DRAGON LIBRARY
C----
        CALL LIBEPR(IMPX,MAXR,NDEPL,NDFI,NDFP,NBXR,IBASE(INAM),
     >              IBASE(IDR),RBASE(IRR),IBASE(IKPAR),
     >              RBASE(IBPAR),RBASE(IYIELD))
      ENDIF
C----
C  SAVE CHAIN
C----
      CALL LCMSIX(IPLIB,'DEPL-CHAIN',1)
      CALL LCMPUT(IPLIB,'STATE-VECTOR',NSTATE,1,ISTATE)
      CALL LCMPUT(IPLIB,'ISOTOPESUSED',2*NDEPL,3,IBASE(INAM))
      CALL LCMPUT(IPLIB,'CHARGEWEIGHT',NDEPL,1,IBASE(IIZAE))
      CALL LCMPUT(IPLIB,'DEPLETE-REAC',MAXR*NDEPL,1,IBASE(IDR))
      CALL LCMPUT(IPLIB,'DEPLETE-RATE',MAXR*NDEPL,2,RBASE(IRR))
      CALL LCMPUT(IPLIB,'PRODUCE-REAC',NBXR*NDEPL,1,IBASE(IKPAR))
      CALL LCMPUT(IPLIB,'PRODUCE-RATE',NBXR*NDEPL,2,RBASE(IBPAR))
      CALL LCMPUT(IPLIB,'FISSIONYIELD',NDFI*NDFP,2,RBASE(IYIELD))
      CALL LCMSIX(IPLIB,' ',2)
      IF(IMPX.GE.5) THEN
        WRITE(IOUT,6000) (ISTATE(ISTA),ISTA=1,7)
      ENDIF
C----
C  RELEASE DECAY CHAIN
C----
      CALL RLSARA(RBASE(IYIELD))
      CALL RLSARA(RBASE(IBPAR))
      CALL RLSARA(IBASE(IKPAR))
      CALL RLSARA(RBASE(IRR))
      CALL RLSARA(IBASE(IDR))
      CALL RLSARA(IBASE(IIZAE))
      CALL RLSARA(IBASE(INAM))
      RETURN
C----
C  FORMAT
C----
 6000 FORMAT(/' STATE-VECTOR FOR DEPLETION CHAIN'/' -------'/
     >  ' NDEPL  ',I6,' (NUMBER OF DEPLETING ISOTOPES)'/
     >  ' NDFI   ',I6,' (NUMBER OF DIRECT FISSILE ISOTOPES)'/
     >  ' NDFP   ',I6,' (NUMBER OF DIRECT FISSION PRODUCT)'/
     >  ' NHEAVY ',I6,' (NUMBER OF HEAVY ISOTOPES)'/
     >  ' NLIGHT ',I6,' (NUMBER OF LIGHT ISOTOPES)'/
     >  ' NOTHER ',I6,' (NUMBER OF OTHER ISOTOPES)'/
     >  ' NBXR   ',I6,' (MAXIMUM NUMBER OF PRODUCTION REACTIONS)'/)
      END
