*DECK LIBEAD
      SUBROUTINE LIBEAD(MAXISO,MAXMIX,NDEPL,MAXR,NBXR,NCOMB,NBISO,
     >                  ISONAM,ISONRF,IHLIB,ISOMIX,DENISO,TMPISO,
     >                  MASKI,ISOEVO,INAM,IDR,KPAR,MILVO,ITISOM)
C
C-----------------------------------------------------------------------
C
C ADD THE MISSING ISOTOPES IN HNAMIS FROM THE DEPLETION CHAIN.
C
C INPUT AND OUTPUT PARAMETERS:
C  MAXISO  : MAXIMUM NUMBER OF ISOTOPES.
C  MAXMIX  : MAXIMUM NUMBER OF MIXTURES.
C  NDEPL   : NUMBER OF DEPLETING ISOTOPES.
C  MAXR    : NUMBER OF DEPLETING REACTIONS
C  NBXR    : NUMBER OF PRODUCTION REACTIONS.
C  NCOMB   : NUMBER OF DEPLETING MIXTURES.
C  NBISO   : OLD/NEW NUMBER OF ISOTOPES PRESENT IN THE CALCULATION
C            DOMAIN.
C  ISONAM  : NAME OF EACH ISOTOPE. ISONAM(3,MAXISO)
C  ISONRF  : REFERENCE NAME OF EACH ISOTOPE. ISONRF(3,MAXISO)
C  IHLIB   : ISOTOPE OPTIONS. IHLIB(2,MAXISO,5)
C  ISOMIX  : MIX NUMBER OF EACH ISOTOPE. ISOMIX(MAXISO)
C  DENISO  : DENSITY OF EACH ISOTOPE. DENISO(MAXISO)
C  TMPISO  : TEMPERATURE OF EACH ISOTOPE. DIMENSION TMPISO(MAXISO)
C  MASKI   : ISOTOPE MASK. DIMENSION MASKI(MAXISO)
C  ISOEVO  : DIMENSION ISOEVO(MAXISO)
C  INAM    : DIMENSION INAM(2,NDEPL)
C  IDR     : DIMENSION IDR(MAXR,NDEPL)
C  KPAR    : DIMENSION KPAR(NBXR,NDEPL)
C  MILVO   : VECTOR FOR BUNNABLE MATERIAL IDENTIFICATION
C            MILVO(MAXMIX)
C  ITISOM  : Flag for adding isotopes
C            from the library.
C
C--------------------------------------- AUTHOR: A. HEBERT 13/02/91 ----
C
      IMPLICIT NONE
C----
C PARAMETERS
C----
      INTEGER          IOUT,KCAPTU,KDECAY,KFISSP,KFISSI,KN2N,KN3N
      PARAMETER       (IOUT=6,KCAPTU=3,KDECAY=1,KFISSP=2,KFISSI=6,
     1                 KN2N=4,KN3N=5)
C----
C DIMENSIONS
C----
      INTEGER          MAXISO,MAXMIX,NDEPL,MAXR,NBXR,NCOMB,NBISO
C----
C LOCAL VARIABLES
C----
      INTEGER          ISO,IBM,INUCL,JCOMB,NUNTIL,IUNTIL,NBOLD,NBNEW,
     1                 IMIX,NDEP,IDEPL,IFISS,IXR,ITR,IFR,JNUCL,NTEST,
     2                 KSO,KMIX,JSO
C
      INTEGER          ISONAM(3,MAXISO),ISONRF(3,MAXISO),
     1                 IHLIB(2,MAXISO,5),ISOMIX(MAXISO),
     2                 ISOEVO(MAXISO),INAM(2,NDEPL),
     3                 IDR(MAXR,NDEPL),KPAR(NBXR,NDEPL),
     4                 MILVO(MAXMIX),ITISOM(MAXISO)
C
      REAL             DENISO(MAXISO),TMPISO(MAXISO)
C
      LOGICAL          MASKI(MAXISO)
C----
C  FIND THE NUMBER OF DEPLETING MIXTURES
C  MARK ISOTOPES WITH DEPLETION PROPERTIES
C  All original isotopes are marked ITISOM=0
C  All isotopes to be added will be marked ITISOM=1
C----
      NCOMB=0
      DO 100 ISO=1,NBISO
        IBM=ISOMIX(ISO)
        IF(IBM.EQ.0) GO TO 105
        DO 101 INUCL=1,NDEPL
          IF(ISONRF(1,ISO).EQ.INAM(1,INUCL).AND.
     >       ISONRF(2,ISO).EQ.INAM(2,INUCL)) THEN
            ISOEVO(ISO)=INUCL
            DO 102 JCOMB=1,NCOMB
              IF(IBM.EQ.MILVO(JCOMB)) GO TO 105
 102        CONTINUE
            NCOMB=NCOMB+1
            MILVO(NCOMB)=IBM
            GO TO 105
          ENDIF
 101    CONTINUE
 105    CONTINUE
 100  CONTINUE
C----
C  ADD THE MISSING ISOTOPES FROM THE DEPLETION CHAIN.
C----
      NUNTIL=NDEPL
      DO 110 IUNTIL=1,NUNTIL
        NBOLD=NBISO
        NBNEW=NBISO
        DO 120 ISO=1,NBOLD
          INUCL=ISOEVO(ISO)
          IMIX=ISOMIX(ISO)
          NDEP=NBNEW+1
          IF(INUCL.GT.0) THEN
            IDEPL=0
            IFISS=0
C----
C  SEARCH IF ISOTOPE IS DEPLETING
C----
            DO 130 IXR=1,MAXR-1
              ITR=MOD(IDR(IXR,INUCL),10)
              IF(ITR.GT.0) THEN
                 IDEPL=1
                 GO TO 135
              ENDIF
 130        CONTINUE
 135        CONTINUE
C----
C  SEARCH IF ISOTOPE IS FISSILE
C----
            ITR=MOD(IDR(5,INUCL),10)
            IFR=IDR(5,INUCL)/10
            IF(ITR.EQ.KFISSI.AND.IFR.GT.0) THEN
              IFISS=1
            ENDIF
C----
C  ADD DEPLETION PRODUCT
C----
            IF(IDEPL.EQ.1) THEN
              DO 140 JNUCL=1,NDEPL
                DO 141 IXR=1,NBXR
                  IFR=KPAR(IXR,JNUCL)/10
                  IF(IFR.EQ.INUCL) THEN
C----
C  TEST IF NEW ISOTOPES ALREADY PRESENT IN THIS MIXTURE
C----
                    NTEST=NBISO
                    DO 142 KSO=1,NTEST
                      KMIX=ISOMIX(KSO)
                      IF( INAM(1,JNUCL).EQ.ISONRF(1,KSO).AND.
     >                    INAM(2,JNUCL).EQ.ISONRF(2,KSO).AND.
     >                    IMIX.EQ.KMIX                  ) GO TO 145
 142                CONTINUE
                    NBNEW=NBNEW+1
                    IF(NBNEW.GT.MAXISO) THEN
                      WRITE(IOUT,9000) MAXISO/MAXMIX
                      CALL XABORT
     >                  ('LIBEAD: NUMBER OF ISOTOPES EXCEEDED')
                    ENDIF
                    ISOEVO(NBNEW)=JNUCL
                    ITISOM(NBNEW)=-1
                    ISONRF(1,NBNEW)=INAM(1,JNUCL)
                    ISONRF(2,NBNEW)=INAM(2,JNUCL)
 145                CONTINUE
                  ENDIF
 141            CONTINUE
 140          CONTINUE
            ENDIF
C----
C  ADD FISSION PRODUCT
C----
            IF(IFISS.EQ.1) THEN
              DO 150 JNUCL=1,NDEPL
                ITR=MOD(IDR(5,JNUCL),10)
                IF(ITR.EQ.KFISSP) THEN
C----
C  TEST IF NEW ISOTOPES ALREADY PRESENT IN THIS MIXTURE
C----
                  NTEST=NBISO
                  DO 151 KSO=1,NTEST
                    KMIX=ISOMIX(KSO)
                    IF( INAM(1,JNUCL).EQ.ISONRF(1,KSO).AND.
     >                  INAM(2,JNUCL).EQ.ISONRF(2,KSO).AND.
     >                  IMIX.EQ.KMIX                  ) GO TO 155
 151              CONTINUE
                  NBNEW=NBNEW+1
                  IF(NBNEW.GT.MAXISO) THEN
                    WRITE(IOUT,9000) MAXISO/MAXMIX
                    CALL XABORT
     >                ('LIBEAD: NUMBER OF ISOTOPES EXCEEDED')
                  ENDIF
                  ISOEVO(NBNEW)=JNUCL
                  ITISOM(NBNEW)=-1
                  ISONRF(1,NBNEW)=INAM(1,JNUCL)
                  ISONRF(2,NBNEW)=INAM(2,JNUCL)
 155              CONTINUE
                ENDIF
 150          CONTINUE
            ENDIF
C----
C  SAVE PROPERTIES FOR NEW ISOTOPES IN THIS MIXTURE
C----
            DO 160 JSO=NDEP,NBNEW
              NBISO=NBISO+1
              ISOEVO(NBISO)=ISOEVO(JSO)
              ISONRF(1,NBISO)=ISONRF(1,JSO)
              ISONRF(2,NBISO)=ISONRF(2,JSO)
              ISONAM(1,NBISO)=ISONRF(1,JSO)
              ISONAM(2,NBISO)=ISONRF(2,JSO)
              ISONAM(3,NBISO)=ISONAM(3,ISO)
              IHLIB(1,NBISO,1)=IHLIB(1,ISO,1)
              IHLIB(2,NBISO,1)=IHLIB(2,ISO,1)
              IHLIB(1,NBISO,2)=IHLIB(1,ISO,2)
              IHLIB(2,NBISO,2)=IHLIB(2,ISO,2)
              MASKI(NBISO)=.TRUE.
              ISOMIX(NBISO)=IMIX
              DENISO(NBISO)=0.0
              TMPISO(NBISO)=TMPISO(ISO)
              IF(JSO.GT.NBISO) THEN
                ISONRF(1,JSO)=ISONRF(3,JSO)
                ISONRF(2,JSO)=ISONRF(3,JSO)
                ISOEVO(JSO)=0
              ENDIF
 160        CONTINUE
            ISOEVO(ISO)=-INUCL
          ENDIF
 120    CONTINUE
        IF(NBISO.EQ.NBOLD) GO TO 115
 110  CONTINUE
 115  CONTINUE
      RETURN
C----
C  FORMAT
C----
 9000 FORMAT(' LIBEAD: ERROR ******'/
     >       ' MAXIMUM NUMBER OF ISOTOPES PER MIXTURE = ',I10,
     >       ' EXCEEDED'/
     >       ' CAN BE INCREASED USING THE MXIS KEYWORD '/
     >       ' ********************')
      END
