*DECK LIBFIS
      SUBROUTINE LIBFIS(IPLIB,NBISO,NBMIX,NOFI,NNFI,ISONAM,ISONFI,
     >                  MIX,IPXS,NIFIS,NOFIS)
C
C-----------------------------------------------------------------------
C
C SET UP FISSION INFORMATION VECTOR
C
C INPUT PARAMETERS:
C  IPLIB   : POINTER TO THE LATTICE MICROSCOPIC CROSS SECTION LIBRARY
C            (L_LIBRARY SIGNATURE).
C  NBISO   : NUMBER OF ISOTOPES PRESENT IN THE CALCULATION DOMAIN.
C  NBMIX   : NUMBER OF MIXTURES PRESENT IN THE CALCULATION DOMAIN.
C  NOFI    : MAXIMUM NUMBER OF OLD FISSILE ISOTOPES
C  NNFI    : MAXIMUM NUMBER OF NEW FISSILE ISOTOPES
C  ISONAM  : NAME OF EACH ISOTOPE. ISONAM(3,NBISO)
C  ISONFI  : LOCAL NAMES OF FISSILE ISOTOPES ISONFI(2,NOFI)
C  MIX     : MIXTURE NUMBER OF EACH ISOTOPE. CAN BE ZERO.
C            DIMENSION MIX(NBISO)
C  IPXS    : DIMENSION IPXS(2*NOFI)
C  NIFIS   : DIMENSION NIFIS(NBMIX,MXFI)
C  NOFIS   : DIMENSION NOFIS(NBISO)
C
C-------------------------------------  AUTHOR: G. MARLEAU 19/04/88 ----
C
      IMPLICIT NONE
C----
C LOCAL VARIABLES
C----
      INTEGER       IPLIB,NBISO,NBMIX,NOFI,NNFI,IFI,ISO,IMX,ISOT,ITC,
     1              LENGTH,ITYLCM,LENGTZ
      INTEGER       MIX(*),IPXS(*),NIFIS(NBMIX,*),NOFIS(*),
     1              ISONAM(3,NBISO),ISONFI(2,*)
C
      CHARACTER     TEXT1*4,HNAMIS*12
C----
C  LOOK FOR FISSILE ISOTOPE NAMES.
C  1) SET ISOTOPE ALREADY PRESENT
C  2) SET NEW ISOTOPE
C----
      IF(NOFI.GT.0) THEN
        CALL LCMSIX(IPLIB,'MACROLIB',1)
        CALL LCMGET(IPLIB,'FISSIONNAMES',ISONFI)
        DO 100 IFI=1,NOFI
          IPXS(2*IFI-1)=1
          IPXS(2*IFI)=1
 100    CONTINUE
        CALL LCMSIX(IPLIB,' ',2)
      ENDIF
      NNFI=NOFI
      DO 110 ISO=1,NBISO
        IMX=MIX(ISO)
        WRITE(TEXT1,'(A4)') ISONAM(3,ISO)
        READ(TEXT1,'(I4)') ISOT
        DO 111 IFI=1,NNFI
          IF(ISONFI(1,IFI).EQ.ISONAM(1,ISO).AND.
     >       ISONFI(2,IFI).EQ.ISONAM(2,ISO)) THEN
            NOFIS(ISO)=IFI
            IF(NIFIS(IMX,IFI).EQ.0) THEN
              NIFIS(IMX,IFI)=ISOT
              IPXS(2*IFI-1)=IMX
              IPXS(2*IFI)=IMX
              GO TO 115
            ELSE IF(NIFIS(IMX,IFI).EQ.ISOT) THEN
              IPXS(2*IFI-1)=IMX
              IPXS(2*IFI)=IMX
              GO TO 115
            ELSE
              CALL XABORT('LIBFIS: SAME ISOTOPE WITH DIFFERENT '//
     >         'PROPERTIES IN A UNIQUE MIXTURE')
            ENDIF
          ENDIF
 111    CONTINUE
        WRITE(HNAMIS,'(3A4)') (ISONAM(ITC,ISO),ITC=1,3)
        CALL LCMSIX(IPLIB,HNAMIS,1)
        CALL LCMLEN(IPLIB,'NUSIGF',LENGTH,ITYLCM)
        CALL LCMLEN(IPLIB,'CHI',LENGTZ,ITYLCM)
        CALL LCMSIX(IPLIB,' ',2)
        IF((LENGTH.GT.0).AND.(LENGTZ.GT.0)) THEN
          NNFI=NNFI+1
          ISONFI(1,NNFI)=ISONAM(1,ISO)
          ISONFI(2,NNFI)=ISONAM(2,ISO)
          NIFIS(IMX,NNFI)=ISOT
          IPXS(2*NNFI-1)=0
          IPXS(2*NNFI)=0
          NOFIS(ISO)=NNFI
        ELSE
          NOFIS(ISO)=0
        ENDIF
 115    CONTINUE
 110  CONTINUE
      RETURN
      END
