*DECK LIBNRG
      SUBROUTINE LIBNRG(IPLIB,CLIBNA,CFILNA,NGROUP,NGF,NGFR,NGT)
C
C------------------------------  LIBNRG  ------------------------------
C
C  PROGRAMME STATISTICS:
C     NAME     : LIBNRG
C     ENTRY    : LIBNRG
C     USE      : TEST FOR ENERGY COMPATIBILITY
C     MODIFIED : 93-08-17
C     AUTHOR   : G. MARLEAU
C
C  ROUTINE PARAMETERS:
C   INPUT
C     IPLIB  : POINTER TO THE INTERNAL LIBRARY      I
C     CLIBNA : LIBRARY TYPE                         C*8
C     CFILNA : FILE NAME                            C*8
C     NGROUP : TOTAL NUMBER OF GROUPS               I
C     NGF    : NUMBER OF FAST GROUPS                I
C     NGFR   : NUMBER OF FAST + RESONANCE GROUPS    I
C     NGT    : NUMBER OF GROUPS TO TEST             I
C
C------------------------------  LIBNRG  ------------------------------
C
      IMPLICIT NONE
C----
C PARAMETERS
C----
      INTEGER          IOUT,LRIND,IACTO,IACTC,ILIBDA,ILIBIN
      PARAMETER       (IOUT=6,LRIND=256,IACTO=2,IACTC=1,ILIBDA=4,
     1                 ILIBIN=2)
C----
C INTERFACE VARIABLES
C----
      INTEGER          IPLIB,NGROUP,NGF,NGFR,NGT
      CHARACTER        CLIBNA*8,CFILNA*8
C----
C MEMORY ALLOCATION
C----
      INTEGER          IBASE(1)
      REAL             RBASE(1)
      COMMON           RBASE
      EQUIVALENCE     (RBASE(1),IBASE(1))
      INTEGER          IENERG,IUUU,IER
C----
C EXTERNAL FUNCTIONS
C----
      INTEGER          KDROPN,KDRCLS
C----
C LIBRARY PARAMETERS
C----
      INTEGER          MAXISO,NCT,LPZ,LMASTB,LMASIN,LGENTB,LGENIN,
     1                 MAXA,MULT
      REAL             ERRCUT
      PARAMETER       (MAXISO=246,NCT=10,LPZ=9,LMASTB=MAXISO+9,
     1                 LMASIN=LMASTB-4,LGENTB=6,LGENIN=LGENTB,
     2                 MAXA=1000,MULT=2,ERRCUT=1.0E-5)
C----
C LOCAL VARIABLES
C----
      INTEGER          NGRI,NGFI,NGFRI,IPDRL,LENGT,ITYLCM,
     1                 IUNIT,NGX,II,ITEMP,J,IERR,INDLOR,NR,NIA,K,I,
     2                 IHANDL,IG,NWDS,IREC,NPART,NTYPE,NEX1,ITEMPE,
     3                 NMAT,JG,JGR,ERRENR,IPR
      INTEGER          MASTER(LMASTB),GENINX(LGENTB),NPZ(LPZ),
     1                 IA(MAXA)
      REAL             E0,DEL
      REAL             RA(MAXA)
      CHARACTER        HPRT*6
      DOUBLE PRECISION DA(MAXA/2)
      EQUIVALENCE     (RA(1),IA(1),DA(1))
C
      NGRI=0
      NGFI=0
      NGFRI=0
C----
C  READ LIBRARY GROUP STRUCTURE
C----
      IF(CLIBNA.EQ.'DRAGON  ') THEN
C---
C  DRAGON LIBRARY
C----
        CALL LCMOP(IPDRL,CFILNA,2,2,0)
        CALL LCMLEN(IPDRL,'ENERGY',LENGT,ITYLCM)
        IF(LENGT.EQ.0)
     >     CALL XABORT('LIBNRG: NO GROUP STRUCTURE AVAILABLE')
        NGRI=LENGT-1
        IF(NGRI.EQ.69) THEN
          NGFI=14
        ENDIF
        CALL SETARA(RBASE,LENGT,IENERG)
        CALL LCMGET(IPDRL,'ENERGY',RBASE(IENERG))
        CALL LCMCL(IPDRL,1)
      ELSE IF(CLIBNA.EQ.'WIMSAECL') THEN
C---
C  WIMS-AECL LIBRARY
C----
        IUNIT=KDROPN(CFILNA,IACTO,ILIBDA,LRIND,IHANDL)
        IF(IUNIT.LE.0) CALL XABORT('LIBNRG: WIMS-AECL LIBRARY '//
     >      CFILNA//' CANNOT BE OPENED FOR MIXS')
        CALL OPNIND(IUNIT,MASTER,LMASTB)
        CALL REDIND(IUNIT,MASTER,LMASIN,GENINX,LGENTB,1)
        CALL REDIND(IUNIT,GENINX,LGENIN,NPZ,LPZ,1)
        NGRI=NPZ(2)
        NGFI=NPZ(4)
        NGX=NPZ(5)
        NGFRI=NGFI+NGX
        CALL SETARA(RBASE,NGRI+1,IENERG)
        CALL REDIND(IUNIT,GENINX,LGENIN,RBASE(IENERG),NGRI+1,4)
        CALL CLSIND(IUNIT)
      ELSE IF(CLIBNA.EQ.'WIMSD4  ') THEN
C---
C  WIMSD4 LIBRARY
C----
        IUNIT=KDROPN(CFILNA,IACTO,ILIBIN,LRIND,IHANDL)
        IF(IUNIT.LE.0) CALL XABORT('LIBNRG: WIMS-D4 LIBRARY '//
     >    CFILNA//' CANNOT BE OPENED')
        READ(IUNIT) (NPZ(II),II=1,LPZ-1)
        NGRI=NPZ(2)
        NGFI=NPZ(4)
        NGX=NPZ(5)
        NGFRI=NGFI+NGX
        READ(IUNIT) ITEMP
        CALL SETARA(RBASE,NGRI+1,IENERG)
        READ(IUNIT) (RBASE(J),J=IENERG,IENERG+NGRI)
        IERR=KDRCLS(IUNIT,IACTC)
        IF(IERR.LT.0)
     >    CALL XABORT('LIBNRG: WIMS-D4 LIBRARY '//
     >      CFILNA//' CANNOT BE CLOSED')
      ELSE IF(CLIBNA.EQ.'APLIB1  ') THEN
C---
C  APOLLO LIBRARY
C----
        IUNIT=KDROPN(CFILNA,IACTO,ILIBIN,LRIND,IHANDL)
        IF(IUNIT.LE.0) CALL XABORT('LIBNRG: APOLLO LIBRARY '//
     >    CFILNA//' CANNOT BE OPENED')
        REWIND(IUNIT)
 100    CONTINUE
        READ(IUNIT) INDLOR,NR,NIA,(IA(I),I=1,NIA)
        IF(NIA.GT.MAXA)
     >    CALL XABORT('LIBNRG: DIMENSION MAXA =1000 TOO SMALL')
        IF(INDLOR.EQ.9999)
     >     CALL XABORT('LIBNRG: NO GROUP STRUCTURE AVAILABLE')
        NGRI=IA(1)
        IF(IA(3).EQ.0) THEN
          DO 110 K=1,NR
            READ(IUNIT)
 110      CONTINUE
          GO TO 100
        ELSE
          CALL SETARA(RBASE,NGRI+1,IENERG)
          CALL SETARA(RBASE,NGRI,IUUU)
          READ(IUNIT) E0,DEL,(RBASE(I),I=IUUU,IUUU+NGRI)
          E0=1.0E+6*E0
          RBASE(IENERG)=E0
          DO 120 IG=1,NGRI
            RBASE(IENERG+IG)=E0*EXP(-RBASE(IUUU+IG-1))
 120      CONTINUE
          CALL RLSARA(RBASE(IUUU))
        ENDIF
        IERR=KDRCLS(IUNIT,IACTC)
        IF(IERR.LT.0) CALL XABORT('LIBNRG: APOLLIB LIBRARY '//
     >      CFILNA//' CANNOT BE CLOSED')
      ELSE IF(CLIBNA.EQ.'MATXS  ') THEN
C---
C  MATXS LIBRARY
C----
        IUNIT=KDROPN(CFILNA,IACTO,ILIBIN,LRIND,IHANDL)
        IF(IUNIT.LE.0) CALL XABORT('LIBNRG: MATXS LIBRARY '//
     >    CFILNA//' CANNOT BE OPENED')
        NWDS=3
        IREC=2
        CALL XDREED(IUNIT,IREC,RA,NWDS)
        NPART=IA(1)
        NTYPE=IA(2)
        IREC=4
        NWDS=(NPART+NTYPE)*MULT+6*NTYPE+NPART
        IF(NWDS.GT.MAXA)
     >    CALL XABORT('LIBNRG: INSUFFICIENT VALUE OF MAXA.')
        CALL XDREED(IUNIT,IREC,RA,NWDS)
        NEX1=(NPART+NTYPE)*MULT+6*NTYPE
        DO 130 I=1,NPART
          NGX=IA(NEX1+I)
          WRITE(HPRT,'(A6)') DA(I)
          IREC=IREC+1
          IF(HPRT.EQ.'NEUT'.OR.HPRT.EQ.'neut'.OR.
     >       HPRT.EQ.'N'.OR.HPRT.EQ.'n') THEN
            IF(NGRI.EQ.0) THEN
              NGRI=NGX
              CALL SETARA(RBASE,NGRI+1,IENERG)
              CALL XDREED(IUNIT,IREC,RBASE(IENERG),NGRI+1)
            ELSE
              IF(NGX.NE.NGRI)
     >          CALL XABORT('LIBNRG: INVALID GROUP STRUCTURE.')
              CALL SETARA(RBASE,NGRI+1,ITEMPE)
              CALL XDREED(IUNIT,IREC,RBASE(ITEMPE),NGRI+1)
              DO 131 IG=0,NGRI
                IF(RBASE(ITEMPE+IG).NE.RBASE(IENERG+IG))
     >            CALL XABORT('LIBNRG: INVALID GROUP STRUCTURE.')
 131          CONTINUE
              CALL RLSARA(RBASE(ITEMPE))
            ENDIF
          ENDIF
 130    CONTINUE
        IERR=KDRCLS(IUNIT,IACTC)
        IF(IERR.LT.0) CALL XABORT('LIBNRG: MATXS LIBRARY '//
     >      CFILNA//' CANNOT BE CLOSED')
      ELSE IF(CLIBNA.EQ.'MATXS2  ') THEN
C---
C  MATXS2 LIBRARY
C----
        IUNIT=KDROPN(CFILNA,IACTO,ILIBIN,LRIND,IHANDL)
        IF(IUNIT.LE.0) CALL XABORT('LIBNRG: MATXS2 LIBRARY '//
     >    CFILNA//' CANNOT BE OPENED')
        NWDS=6
        IREC=2
        CALL XDREED(IUNIT,IREC,RA,NWDS)
        NPART=IA(1)
        NTYPE=IA(2)
        NMAT=IA(4)
        IREC=4
        NWDS=(NPART+NTYPE+NMAT)*MULT+2*NTYPE+NPART+2*NMAT
        IF(NWDS.GT.MAXA)
     >    CALL XABORT('LIBNRG: INSUFFICIENT VALUE OF MAXA.')
        CALL XDREED(IUNIT,IREC,RA,NWDS)
        NEX1=(NPART+NTYPE+NMAT)*MULT
        DO 140 I=1,NPART
          NGX=IA(NEX1+I)
          WRITE(HPRT,'(A6)') DA(I)
          IREC=IREC+1
          IF(HPRT.EQ.'N'.OR.HPRT.EQ.'n') THEN
            IF(NGRI.EQ.0) THEN
              NGRI=NGX
              CALL SETARA(RBASE,NGRI+1,IENERG)
              CALL XDREED(IUNIT,IREC,RBASE(IENERG),NGRI+1)
            ELSE
              IF(NGX.NE.NGRI)
     >          CALL XABORT('LIBNRG: INVALID GROUP STRUCTURE.')
              CALL SETARA(RBASE,NGRI+1,ITEMPE)
              CALL XDREED(IUNIT,IREC,RBASE(ITEMPE),NGRI+1)
              DO 141 IG=0,NGRI
                IF(RBASE(ITEMPE+IG).NE.RBASE(IENERG+IG))
     >            CALL XABORT('LIBNRG: INVALID GROUP STRUCTURE.')
 141          CONTINUE
              CALL RLSARA(RBASE(ITEMPE))
            ENDIF
          ENDIF
 140    CONTINUE
        IERR=KDRCLS(IUNIT,IACTC)
        IF(IERR.LT.0) CALL XABORT('LIBNRG: MATXS2 LIBRARY '//
     >      CFILNA//' CANNOT BE CLOSED')
      ENDIF
      IF(RBASE(IENERG+NGRI).EQ.0.0) RBASE(IENERG+NGRI)=1.0E-5
      IF(NGT.EQ.0) THEN
C----
C  IF NGT=0 SAVE GROUP STRUCTURE AND SET GROUP PARAMETERS
C----
        NGROUP=NGRI
        CALL LCMPUT(IPLIB,'ENERGY',NGRI+1,2,RBASE(IENERG))
        JG=IENERG
        NGX=0
        DO 150 IG=1,NGROUP
          IF(NGX.EQ.0.AND.RBASE(JG+1).LT.4.0) THEN
            NGX=IG-1
          ENDIF
          RBASE(JG)=LOG(RBASE(JG)/RBASE(JG+1))
          JG=JG+1
 150    CONTINUE
        CALL LCMPUT(IPLIB,'DELTAU',NGROUP,2,RBASE(IENERG))
        NGFR=MAX(NGX,NGFRI)
        NGF=NGFI
        NGT=NGROUP
      ELSE IF(NGRI.EQ.NGT) THEN
C----
C  IF NGT>0 VALIDATE GROUP STRUCTURE
C----
        CALL SETARA(RBASE,NGT+1,IER)
        CALL LCMGET(IPLIB,'ENERGY',RBASE(IER))
        JG=IENERG
        JGR=IER
        NGX=0
        DO 160 IG=1,NGT+1
          IF(NGX.EQ.0.AND.RBASE(JG+1).LT.4.0) THEN
            NGX=IG-1
          ENDIF
          IF(RBASE(JGR) .NE. 0.0) THEN
            ERRENR=ABS(RBASE(JG)-RBASE(JGR))/RBASE(JGR)
          ELSE IF(RBASE(JG) .NE. 0.0) THEN
            ERRENR=ABS(RBASE(JG)-RBASE(JGR))/RBASE(JG)
          ELSE
            ERRENR=0.0
          ENDIF
          IF(ERRENR .GT. ERRCUT) THEN
            WRITE(IOUT,'(1X,A20)') 'OLD GROUP STRUCTURE='
            WRITE(IOUT,'(1P,5E15.7)')
     >        (RBASE(IPR),IPR=IER,IER+NGT)
            WRITE(IOUT,'(1X,A20)') 'NEW GROUP STRUCTURE='
            WRITE(IOUT,'(1P,5E15.7)')
     >        (RBASE(IPR),IPR=IENERG,IENERG+NGT)
            WRITE(IOUT,9000) IG,ERRENR,ERRCUT
            CALL XABORT('LIBNRG: INCOMPATIBLE GROUP STRUCTURE')
          ENDIF
          JG=JG+1
          JGR=JGR+1
 160    CONTINUE
        NGFR=MAX(NGX,NGFR,NGFRI)
        NGF=MIN(NGF,NGFI)
        CALL RLSARA(RBASE(IER))
      ELSE
        WRITE(IOUT,'(1X,A20,1X,I10)') 'OLD NUMBER OF GROUPS=',NGT
        WRITE(IOUT,'(1X,A20,1X,I10)') 'NEW NUMBER OF GROUPS=',NGRI
        CALL XABORT('LIBNRG: INCOMPATIBLE NUMBER OF GROUPS')
      ENDIF
      CALL RLSARA(RBASE(IENERG))
C----
C  RETURN
C----
      RETURN
 9000 FORMAT(' *** ERROR DETECTED IN LIBNRG ***'/
     >       ' INCOMPATIBLE GROUP STRUCTURE    '/
     >       ' GROUP =',I10/
     >       ' RELATIVE DIFFERENCES IN ENERGY FOUND =',1P,E10.3/
     >       ' RELATIVE ENERGY DIFFERENCE PERMITTED =',E10.3)
      END
