*DECK MACNFI
      SUBROUTINE MACNFI(IPMACR,IPRINT,IEN   ,NTOTMX,NGROUP,NANISO,
     >                  NIFISS,NEDMAC,NBMIXF,NGROF ,NIFISF,NEDF  ,
     >                  NBMIXO,NGROO ,NLO   ,NIFISO,NEDO  ,IMLOC ,
     >                  ENERGN,NAMEDN,NAMFN ,NUMFN ,IFGUPS,ENERGO,
     >                  NAMEDO,NAMFO ,NUMFO ,IFGUPO)
C
C---------------------------  MACNFI  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : MACNFI
C       USE      : UPDATE LIST OF FISSILE ISOTOPES
C                  FROM FISSILE ISOTOPES ON A SPECIFIC MACROLIB
C                  IPDATE IFGUPS FOR FIRST SCATTERING GROUP
C       MODIFIED : 2000/02/18
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       IPMACR   : POINTER TO STRUCTURES               I
C       IPRINT   : PRINT LEVEL                         I
C       IEN      : MARCOLIB NUMBER TO PROCESS          I
C       NTOTMX   : MAXIMUM NUMBER OF MIXTURES          I
C       NGROUP   : NUMBER OF GROUPS                    I
C       NANISO   : FINAL NUMBER OF SCATT ANISO         I
C       NIFISS   : NUMBER FISSILE ISOTOPES PER MIXTURE I
C       NEDMAC   : NUMBER OF ADITIONAL EDITION X-S     I
C       NBMIXF   : FINAL NUMBER OF MIXTURES            I
C       NGROF    : NUMBER OF GROUPS TESTED             I
C       NIFISF   : FINAL NUMBER FISSILE ISOTOPES       I
C       NEDF     : FINAL NUMBER OF ADITIONAL X-S       I
C       NBMIXO   : IPMACR NUMBER OF MIXTURES           I
C       NGROO    : IPMACR GROUPS                       I
C       NLO      : IPMACR NUMBER OF SCATT ANISO        I
C       NIFISO   : IPMACR NUMBER FISSILE ISOTOPES      I
C       NEDO     : IPMACR NUMBER OF ADITIONAL X-S      I
C       IMLOC    : MIXTURE LOCATION                    I(2,NTOTMX)
C       ENERGN   : FINAL ENERGY/LETHARGY VECTOR        R(2*NGROUP+1)
C       NAMEDN   : FINAL EDIT NAMES                    I(2,NEDMAC)
C       NAMFN    : FINAL FISSILE NAMES                 I(2,NIFISS)
C       NUMFN    : FINAL FISSILE NUMBER                I(NBMIXF,
C                                                        NIFISS)
C       IFGUPS   : FINAL NUMBER OF GROUP WITH          I(NBMIXF,
C                  UP SCATTERING                         NANISO)
C       ENERGO   : IPMACR ENERGY/LETHARGY VECTOR       R(2*NGROO+1)
C       NAMEDO   : IPMACR EDIT NAMES                   I(2,NEDO)
C       NAMFO    : IPMACR FISSILE NAMES                I(2,NIFISO)
C       NUMFO    : IPMACR FISSILE NUMBER               I(NBMIXO,
C                                                        NIFISO)
C       IFGUPO   : IPMACR NUMBER OF GROUP WITH         I(NBMIXO,
C                  UP SCATTERING                         NLO)
C   3- INTERNAL PARAMETERS:
C
C---------------------------   MACNFI  --------------------------------
C
      IMPLICIT     NONE
      INTEGER      IOUT
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,NAMSBR='MACNFI')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER      IPMACR,IPRINT,IEN,NTOTMX,NGROUP,NANISO,NIFISS,
     >             NEDMAC,NBMIXF,NGROF,NIFISF,NEDF,NBMIXO,
     >             NGROO,NLO,NIFISO,NEDO
      INTEGER      IMLOC(2,NTOTMX),NAMEDN(2,NEDMAC),NAMFN(2,NIFISS),
     >             NUMFN(NBMIXF,NIFISS),IFGUPS(NBMIXF,NANISO),
     >             NAMEDO(2,NEDO),NAMFO(2,NIFISO),
     >             NUMFO(NBMIXO,NIFISO),IFGUPO(NBMIXO,NLO)
      REAL         ENERGN(2*NGROUP+1),ENERGO(2*NGROO+1)
C----
C  LOCAL PARAMETERS
C----
      INTEGER      IGR,ILO,ILN,JLN,IMXN,IMAC,IMIX,ITC
C----
C  PRINT HEADER IF REQUIRED
C----
      IF(IPRINT .GE. 10) THEN
        WRITE(IOUT,6000) NAMSBR,IEN
      ENDIF
C----
C  TEST FOR ENERGY
C----
      IF(NGROO .GT. 0) THEN
        IF(NGROF .GT. 0 ) THEN
          CALL LCMGET(IPMACR,'ENERGY      ',ENERGO(1))
          CALL LCMGET(IPMACR,'DELTAU      ',ENERGO(NGROO+2))
          DO 100 IGR=1,2*NGROO+1
            IF( ENERGN(IGR) .NE. ENERGO(IGR)) THEN
              WRITE(IOUT,9000) NAMSBR,IEN
              GO TO 105
            ENDIF
 100      CONTINUE
        ELSE
          CALL LCMGET(IPMACR,'ENERGY      ',ENERGN(1))
          CALL LCMGET(IPMACR,'DELTAU      ',ENERGN(NGROO+2))
          NGROF=NGROO
        ENDIF
      ENDIF
 105  CONTINUE
C----
C  TEST FOR ADDITIONAL EDIT XS
C----
      IF(NEDO .GT. 0 ) THEN
        CALL LCMGET(IPMACR,'ADDXSNAME   ',NAMEDO)
        IF(IPRINT .GE. 10) THEN
          WRITE(IOUT,6010) 'ADDXSNAME   '
          WRITE(IOUT,6011) ((NAMEDO(ITC,ILO),ITC=1,2),ILO=1,NEDO)
        ENDIF
        DO 110 ILO=1,NEDO
          DO 111 ILN=1,NEDF
            IF( NAMEDO(1,ILO) .EQ. NAMEDN(1,ILN) .AND.
     >          NAMEDO(1,ILO) .EQ. NAMEDN(1,ILN)      ) GO TO 115
 111      CONTINUE
          NEDF=NEDF+1
          NAMEDN(1,ILN)=NAMEDO(1,ILO)
          NAMEDN(2,ILN)=NAMEDO(2,ILO)
 115      CONTINUE
 110    CONTINUE
      ENDIF
C----
C  TEST FOR FISSILE ISOTOPES NAMES
C  STORE IN NUMFN THE LOCATION OF CROSS SECTION IN OLD
C  NUSIGF AND CHI
C----
      IF(NIFISO .GT. 0) THEN
        CALL LCMGET(IPMACR,'FISSIONNAMES',NAMFO)
        CALL LCMGET(IPMACR,'FISSIONNB   ',NUMFO)
        IF(IPRINT .GE. 10) THEN
          WRITE(IOUT,6010) 'FISSIONNAMES'
          WRITE(IOUT,6011) ((NAMFO(ITC,ILO),ITC=1,2),ILO=1,NIFISO)
          WRITE(IOUT,6010) 'FISSIONNB   '
          WRITE(IOUT,6012) ((NUMFO(ITC,ILO),ITC=1,NBMIXO),ILO=1,NIFISO)
        ENDIF
        DO 120 ILO=1,NIFISO
          DO 121 ILN=1,NIFISF
            IF( NAMFO(1,ILO) .EQ. NAMFN(1,ILN) .AND.
     >          NAMFO(1,ILO) .EQ. NAMFN(1,ILN)      ) THEN
              JLN=ILN
              GO TO 125
            ENDIF
 121      CONTINUE
          NIFISF=NIFISF+1
          NAMFN(1,ILN)=NAMFO(1,ILO)
          NAMFN(2,ILN)=NAMFO(2,ILO)
          JLN=ILN
 125      CONTINUE
C----
C  RESET FISSION NUMBER FOR ISOTOPES IN NEW MACROLIB WITH
C  CURRENT MACROLIB FISSILE NUMBER
C----
          DO 130 IMXN=1,NTOTMX
            IMAC=IMLOC(1,IMXN)
            IMIX=IMLOC(2,IMXN)
            IF(IMAC .EQ. IEN) THEN
              IF(NUMFO(IMIX,ILO) .NE. 0) THEN
                NUMFN(IMXN,JLN)=(ILO-1)*NBMIXO+IMIX
              ENDIF
            ENDIF
 130      CONTINUE
 120    CONTINUE
      ENDIF
C----
C  READ FIRST GROUP WITH UP-SCATTERING AND TRANSFER
C  IN ADEQUATE VECTOR
C----
      CALL LCMGET(IPMACR,'FGWITHUPSCAT',IFGUPO)
      DO 140 IMXN=1,NTOTMX
        IMAC=IMLOC(1,IMXN)
        IMIX=IMLOC(2,IMXN)
        IF(IMAC .EQ. IEN) THEN
          DO 141 ILO=1,NLO
            IFGUPS(IMXN,ILO)=IFGUPO(IMIX,ILO)
 141      CONTINUE
        ENDIF
 140  CONTINUE
      RETURN
C----
C  EDIT FORMATS
C----
 6000 FORMAT(1X,A6,' - PROCESSING MACROLIB : ',I12)
 6010 FORMAT(7X,   '   PRECESSING RECORD   : ',A12)
 6011 FORMAT(10(2A4,4X))
 6012 FORMAT(10(I8,4X))
C----
C  WARNING FORMATS
C----
 9000 FORMAT(' **** WARNING IN ',A6,' FOR MACROLIB : ',I12/
     >       '      ENERGY GROUP STRUCTURE NOT COMPATIBLE'/
     >       ' **** CORRECTION:  USE LAST ENERGY STRUCTURE')
      END
