*DECK MACRDM
      SUBROUTINE MACRDM(IPMACR,IPRINT,IEN   ,NTOTMX,NGROUP,NANISO,
     >                  NBMIXF,NIFISF,NEDF  ,NREACD,NTREA ,IMLOC ,
     >                  NAMREA,
     >                  NAMEDN,NUMFN ,IXSPRO,XSGEN ,XSSCAT,XSTMP ,
     >                  SCTMP ,ISCAT )
C
C---------------------------  MACRDM  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : MACRDM
C       USE      : READ AN OLD MACROLIB AND TRANSFER INFORMATION
C                  TO VECTORS FOR A NEW MACROLIB
C       MODIFIED : 98-06-04
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       IPMACR   : POINTER TO STRUCTURES               I
C       IPRINT   : PRINT LEVEL                         I
C       IEN      : MARCOLIB NUMBER TO PROCESS          I
C       NTOTMX   : MAXIMUM NUMBER OF MIXTURES          I
C       NGROUP   : NUMBER OF GROUPS                    I
C       NANISO   : MAXIMUN SCATTERING ANISOTROPY       I
C       NBMIXF   : FINAL NUMBER OF MIXTURES            I
C       NIFISF   : FINAL NUMBER FISSILE ISOTOPES       I
C       NEDF     : FINAL NUMBER OF ADITIONAL X-S       I
C       NREACD   : NUMBER OF DEFAULT XS                I
C       NTREA    : TOTAL NUMBER OF XS                  I
C       IMLOC    : MIXTURE LOCATION                    I(2,NTOTMX)
C       NAMREA   : NAME OF DEFAULT XS                  C(NREACD)*12
C       NAMEDN   : NAME OF EDIT XS                     I(2,NEDF)
C       NUMFN    : FINAL FISSILE NUMBER                I(NBMIXF,
C                                                        NIFISF)
C       IXSPRO   : FLAG FOR CROSS SECTION PROCESSING   I(NTREA+NANISO)
C       XSGEN    : GENERAL XS VECTOR                   R(NBMIXF,
C                                                        NTREA)
C       XSSCAT   : GENERAL SCATTERING MATRIX           R(NGROUP,
C                                                 NBMIXF,NANISO,2)
C       XSTMP    : TEMPORARY XS VECTOR                 R(NTOTMX*
C                                                      (NIFISF+1))
C       SCTMP    : TEMPORARY SCATTERING MATRIX         R(NGROUP*
C                                                        NTOTMX)
C       ISCAT    : SCATTERING POINTER                  I(NTOTMX,3)
C   3- INTERNAL PARAMETERS:
C
C---------------------------   MACRDM  --------------------------------
C
      IMPLICIT     NONE
      INTEGER      IOUT,ILCMUP,ILCMDN
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,ILCMUP=1,ILCMDN=2,NAMSBR='MACRDM')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER      IPMACR,IPRINT,IEN,NTOTMX,NGROUP,NANISO,
     >             NBMIXF,NIFISF,NEDF,NREACD,NTREA
      CHARACTER    NAMREA(NREACD)*12
      INTEGER      IMLOC(2,NTOTMX),NAMEDN(2,NEDF),
     >             NUMFN(NBMIXF,NIFISF),IXSPRO(NTREA+NANISO),
     >             ISCAT(NTOTMX,3)
      REAL         XSGEN(NBMIXF,NTREA),XSSCAT(NGROUP,NBMIXF,NANISO,2),
     >             XSTMP(NTOTMX*(NIFISF+1)),SCTMP(NGROUP*NTOTMX)
C----
C  LOCAL PARAMETERS
C----
      INTEGER      ILCMLN,ILCMTY,IMIX,IREA,IREAF,IREAT,IREAP,IREAA,
     >             IFIS,IED,IANIS,IOMIX,NGF,IGD,IGF,IPOS,IGT,ITC
      CHARACTER    NAMADD*12,CANISO*2
C----
C  PRINT HEADER IF REQUIRED
C----
      IF(IPRINT .GE. 10) THEN
        WRITE(IOUT,6000) NAMSBR
      ENDIF
C----
C  1) DEFAULT XS
C----
      DO 100 IREA=1,NREACD
        CALL LCMLEN(IPMACR,NAMREA(IREA),ILCMLN,ILCMTY)
        IF(ILCMLN .GT. 0) THEN
          IF(IPRINT .GE. 10) THEN
            WRITE(IOUT,6010) NAMREA(IREA)
          ENDIF
          IXSPRO(IREA)=1
          CALL LCMGET(IPMACR,NAMREA(IREA),XSTMP)
          DO 101 IMIX=1,NTOTMX
            IF(IMLOC(1,IMIX) .EQ. IEN) THEN
              IOMIX=IMLOC(2,IMIX)
              XSGEN(IMIX,IREA)=XSTMP(IOMIX)
            ENDIF
 101      CONTINUE
        ENDIF
 100  CONTINUE
C----
C  2) NUSIGF, CHI AND NFTOT
C----
      IF(NIFISF .GT. 0) THEN
        IREAF=NREACD
        IREAT=NREACD+NIFISF
        IREAP=NREACD+2*NIFISF
        CALL LCMLEN(IPMACR,'NUSIGF      ',ILCMLN,ILCMTY)
        IF(ILCMLN .GT. 0) THEN
          IF(IPRINT .GE. 10) THEN
            WRITE(IOUT,6010) 'NUSIGF      '
            WRITE(IOUT,6010) 'CHI         '
          ENDIF
          CALL LCMGET(IPMACR,'NUSIGF      ',XSTMP)
          IXSPRO(IREAF+1)=1
          IXSPRO(IREAP+1)=1
          DO 110 IMIX=1,NTOTMX
            IF(IMLOC(1,IMIX) .EQ. IEN) THEN
              DO 111 IFIS=1,NIFISF
                IOMIX=NUMFN(IMIX,IFIS)
                IF( IOMIX .NE. 0 ) THEN
                  XSGEN(IMIX,IREAF+IFIS)=XSTMP(IOMIX)
                ENDIF
 111          CONTINUE
            ENDIF
 110      CONTINUE
          CALL LCMGET(IPMACR,'CHI         ',XSTMP)
          DO 112 IMIX=1,NTOTMX
            IF(IMLOC(1,IMIX) .EQ. IEN) THEN
              DO 113 IFIS=1,NIFISF
                IOMIX=NUMFN(IMIX,IFIS)
                IF( IOMIX .NE. 0 ) THEN
                  XSGEN(IMIX,IREAP+IFIS)=XSTMP(IOMIX)
                ENDIF
 113          CONTINUE
            ENDIF
 112      CONTINUE
        ENDIF
        CALL LCMLEN(IPMACR,'NFTOT       ',ILCMLN,ILCMTY)
        IF(ILCMLN .GT. 0) THEN
          IF(IPRINT .GE. 10) THEN
            WRITE(IOUT,6010) 'NFTOT       '
          ENDIF
          IXSPRO(IREAT+1)=1
          CALL LCMGET(IPMACR,'NFTOT       ',XSTMP)
          DO 114 IMIX=1,NTOTMX
            IF(IMLOC(1,IMIX) .EQ. IEN) THEN
              DO 115 IFIS=1,NIFISF
                IOMIX=NUMFN(IMIX,IFIS)
                IF( IOMIX .NE. 0 ) THEN
                  XSGEN(IMIX,IREAT+IFIS)=XSTMP(IOMIX)
                ENDIF
 115          CONTINUE
            ENDIF
 114      CONTINUE
        ENDIF
      ENDIF
C----
C  3) ADDITIONAL EDIT XS
C----
      IF(NEDF .GT. 0) THEN
        IREAA=NREACD+3*NIFISF
        DO 120 IED=1,NEDF
          WRITE(NAMADD,'(A4,A2)') (NAMEDN(ITC,IED),ITC=1,2)
          CALL LCMLEN(IPMACR,NAMADD,ILCMLN,ILCMTY)
          IF(ILCMLN .GT. 0) THEN
            IF(IPRINT .GE. 10) THEN
              WRITE(IOUT,6010) NAMADD
            ENDIF
            IXSPRO(IREAA+IED)=1
            CALL LCMGET(IPMACR,NAMADD,XSTMP)
            DO 121 IMIX=1,NTOTMX
              IF(IMLOC(1,IMIX) .EQ. IEN) THEN
                IOMIX=IMLOC(2,IMIX)
                XSGEN(IMIX,IREAA+IED)=XSTMP(IOMIX)
              ENDIF
 121        CONTINUE
          ENDIF
 120    CONTINUE
      ENDIF
C----
C  4) SCATTERING XS
C----
      DO 130 IANIS=1,NANISO
        WRITE(CANISO,'(I2)') IANIS-1
        CALL LCMLEN(IPMACR,'SCAD'//CANISO,ILCMLN,ILCMTY)
        IF(ILCMLN .GT. 0) THEN
          IXSPRO(NTREA+IANIS)=1
          IF(IPRINT .GE. 10) THEN
            WRITE(IOUT,6010) 'SCATTERING'//CANISO
          ENDIF
C----
C  4.3) TREAT SCAT
C----
          CALL LCMGET(IPMACR,'IJJD'//CANISO,ISCAT(1,1))
          CALL LCMGET(IPMACR,'NJJD'//CANISO,ISCAT(1,2))
          CALL LCMGET(IPMACR,'IPOD'//CANISO,ISCAT(1,3))
          CALL LCMGET(IPMACR,'SCAD'//CANISO,SCTMP)
          DO 133 IMIX=1,NTOTMX
            IF(IMLOC(1,IMIX) .EQ. IEN) THEN
              IOMIX=IMLOC(2,IMIX)
              NGF=ISCAT(IOMIX,2)
              IF(NGF .GT. 0) THEN
                IGD=ISCAT(IOMIX,1)
                IGF=IGD-NGF+1
                IPOS=ISCAT(IOMIX,3)
                DO 134 IGT=IGD,IGF,-1
                  XSSCAT(IGT,IMIX,IANIS,1)=SCTMP(IPOS)
                  IPOS=IPOS+1
 134            CONTINUE
              ENDIF
            ENDIF
 133      CONTINUE
          CALL LCMGET(IPMACR,'IJJA'//CANISO,ISCAT(1,1))
          CALL LCMGET(IPMACR,'NJJA'//CANISO,ISCAT(1,2))
          CALL LCMGET(IPMACR,'IPOA'//CANISO,ISCAT(1,3))
          CALL LCMGET(IPMACR,'SCAA'//CANISO,SCTMP)
          DO 135 IMIX=1,NTOTMX
            IF(IMLOC(1,IMIX) .EQ. IEN) THEN
              IOMIX=IMLOC(2,IMIX)
              NGF=ISCAT(IOMIX,2)
              IF(NGF .GT. 0) THEN
                IGD=ISCAT(IOMIX,1)
                IGF=IGD-NGF+1
                IPOS=ISCAT(IOMIX,3)
                DO 136 IGT=IGD,IGF,-1
                  XSSCAT(IGT,IMIX,IANIS,2)=SCTMP(IPOS)
                  IPOS=IPOS+1
 136            CONTINUE
              ENDIF
            ENDIF
 135      CONTINUE
        ENDIF
 130  CONTINUE
      RETURN
C----
C  EDIT FORMATS
C----
 6000 FORMAT(1X,A6,' - READING CROSS SECTIONS '/)
 6010 FORMAT(7X,   '   READING RECORD         : ',A12)
      END
