*DECK MACUPD
      SUBROUTINE MACUPD(NENTRY,KENTRY,IPRINT,NTOTMX,NBMIX ,NGROUP,
     >                  NANISO,NIFISS,NEDMAC,ITRANC,
     >                  IMLOC )
C
C---------------------------  MACUPD  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : MACUPD
C       USE      : UPDATE DRAGON MACROLIB WITH OTHER DRAGON MACROLIB
C       MODIFIED : 2000-01-20 (T. COURAU)
C                   98-06-03
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C       NENTRY   : NUMBER OF STRUCTURES                  I
C       KENTRY   : POINTER TO STRUCTURES                 I(NENTRY)
C       IPRINT   : PRINT LEVEL                           I
C       NTOTMX   : MAXIMUM NUMBER OF MIXTURES            I
C                  MACROLIBS IN INPUT: IPMAC1,IPMAC2,IPMAC3
C       NBMIX    : NUMBER OF MIXTURES ON OUTPUT          I
C                  MACROLIB
C       NGROUP   : NUMBER OF GROUPS                      I
C       NANISO   : MAXIMUN SCATTERING ANISOTROPY         I
C       NIFISS   : NUMBER FISSILE ISOTOPES PER MIXTURE   I
C       NEDMAC   : NUMBER OF ADITIONAL EDITION X-S       I
C       ITRANC   : TYPE OF TRANSPORT CORRECTION          I
C       IMLOC    : MIXTURE LOCATION                      I(2,NTOTMX)
C                  IMLOC(1) -> STRUCTURE NUMBER
C                  IMLOC(2) -> MIXTURE NUMBER
C---------------------------   MACUPD  --------------------------------
C
      IMPLICIT     NONE
      INTEGER      IOUT,NSTATE,ILCMUP,ILCMDN,NREACD
      CHARACTER    NAMSBR*6
      PARAMETER   (IOUT=6,NSTATE=40,ILCMUP=1,ILCMDN=2,NREACD=8,
     >             NAMSBR='MACUPD')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER      NENTRY,IPRINT,NTOTMX,NBMIX,NGROUP,NANISO,
     >             NIFISS,NEDMAC,ITRANC
      INTEGER      KENTRY(NENTRY),IMLOC(2,NTOTMX)
C----
C  MEMORY ALLOCATION VARIABLES
C----
      INTEGER      IBASE(1)
      REAL         RBASE
      COMMON       RBASE(1)
      EQUIVALENCE (RBASE(1),IBASE(1))
      INTEGER      INAMEN,INUMFN,INAMFN,IFGUPS,IENERN,INAMEO,
     >             INUMFO,INANFO,IFGUPO,IENERO,ITIMN,IXSPRO,
     >             IXSGEN,ISCAT,IXSTMP,ISCTMP,IISCAT
C----
C  INPUT
C----
      CHARACTER    CARLIR*12
      INTEGER      ITYPLU,INTLIR
      REAL         REALIR
      DOUBLE PRECISION DBLLIR
C----
C  LOCAL PARAMETERS
C----
      INTEGER      ISTATE(NSTATE),ITEXT4,IPMACR,IMIX,IEN,
     >             NUMNEW,NUMOLD,NBMIXF,NIFISF,NGROF,NEDF,
     >             NBMIXO,NLO,NIFISO,NEDO,NTREA,NGROO,
     >             ILCMLN,ILCMTY,ITC,IFI,IGR,IEFPRO,IPRG
      CHARACTER    TEXT4*4,GRPDIR*12
C----
C  DATA
C----
      CHARACTER    NAMREA(NREACD)*12
      SAVE         NAMREA
      DATA         NAMREA
     >  /'TOTAL       ','TRANC       ','ABS         ','OVERV       ',
     >   'DIFFHOM     ','DIFFX       ','DIFFY       ','DIFFZ       '/
C----
C  INITIALIZE IMLOC FOR MIXTURE ALREADY PRESENT ON OUTPUT MACROLIB
C----
      TEXT4='    '
      READ(TEXT4,'(A4)') ITEXT4
      DO 100 IMIX=1,NBMIX
        IMLOC(1,IMIX)=1
        IMLOC(2,IMIX)=IMIX
 100  CONTINUE
      IF(IPRINT .GE. 5) THEN
        WRITE(IOUT,6000) NAMSBR
      ENDIF
C----
C  READ INPUT DATA
C  TYPICAL FORMAT:
C  EDIT iprint
C  CTRA { ON | OFF }
C  MIX numnew numold [{ UPDL | OLDL }]
C    WHERE
C    iprint =  PRINT LEVEL
C    numnew =  NEW MIXTURE NUMBER
C    numold =  OLD MIXTURE NUMBER
C    UPDL   =  TAKE numold FORM LIBRARY TO UPDATE
C    OLDL   =  TAKE numold FORM OLD LIBRARY
C----
      ITYPLU = 3
      CARLIR = 'MIX'
 1000 CONTINUE
      IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >': CHARACTER KEYWORD EXPECTED')
C----
C  CHECK FOR STOP/RETURN
C----
      IF(CARLIR .EQ. ';') THEN
        GO TO 1005
      ELSE IF(CARLIR(1:3) .EQ. 'MIX') THEN
C----
C  READ MIX CARD
C----
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >  ': NEW MIXTURE NUMBER IS NOT AN INTEGER')
        NUMNEW=INTLIR
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 1) CALL XABORT(NAMSBR//
     >  ': OLD MIXTURE NUMBER IS NOT AN INTEGER')
        NUMOLD=INTLIR
        CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
        IF(ITYPLU .NE. 3) CALL XABORT(NAMSBR//
     >  ': STRUCTURE TYPE IS NOT CHARACTER')
C---
C  TEST IF NUMNEW IS VALID
C----
        IF(NUMNEW .GT. NTOTMX) CALL XABORT(NAMSBR//
     >  ': NEW MATERIAL NUMBER IS TOO LARGE')
C----
C  BY DEFAULT CARLIR IS ASSUMED TO BE OLDL
C  IF CARLIR IS UPDL
C  STORE INFORMATION IN IMLOC
C  CVS-UPDATE: 2000/09/07
C  KEYWORD OLDL NOT PROCESSED IF PRESENT
C  PROCESS KEYWORD OLDL ACCORDING TO USER'S GUIDE IN THE
C  CASE WHERE IT IS PRESENT
C----
        IF(CARLIR(1:4) .EQ. 'UPDL') THEN
          IMLOC(1,NUMNEW)=1
          IMLOC(2,NUMNEW)=NUMOLD
        ELSE IF(CARLIR(1:4) .EQ. 'OLDL') THEN
          IMLOC(1,NUMNEW)=2
          IMLOC(2,NUMNEW)=NUMOLD
        ELSE
          IMLOC(1,NUMNEW)=2
          IMLOC(2,NUMNEW)=NUMOLD
          GO TO 1000
        ENDIF
      ELSE
        CALL XABORT(NAMSBR//
     >  ': KEYWORD '//CARLIR//' NOT PERMITTED')
      ENDIF
      CALL REDGET(ITYPLU,INTLIR,REALIR,CARLIR,DBLLIR)
      GO TO 1000
 1005 CONTINUE
C----
C  FIND TOTAL NUMBER OF MIXTURES CREATED
C----
      DO 120 IMIX=NTOTMX,1,-1
        IF(IMLOC(2,IMIX) .NE. 0) THEN
          NBMIXF=IMIX
          GO TO 125
        ENDIF
 120  CONTINUE
      CALL XABORT(NAMSBR//': NO MIXTURES FOUND')
 125  CONTINUE
C----
C  TEST FOR ENERGY
C  FIND ADDITIONAL XS NAME
C  FIND TOTAL NUMBER OF FISSILE ISOTOPES AND THEIR NAME
C----
      CALL SETARA(IBASE,2*NEDMAC      ,INAMEN)
      CALL SETARA(IBASE,2*NIFISS      ,INAMFN)
      CALL XDISET(IBASE(INAMEN),2*NEDMAC     ,ITEXT4)
      CALL XDISET(IBASE(INAMFN),2*NIFISS     ,ITEXT4)
      CALL SETARA(IBASE,NBMIXF*NIFISS ,INUMFN)
      CALL SETARA(IBASE,NBMIXF*NANISO ,IFGUPS)
      CALL SETARA(RBASE,2*NGROUP+1    ,IENERN)
      CALL SETARA(IBASE,2*NEDMAC      ,INAMEO)
      CALL SETARA(IBASE,NTOTMX*NIFISS ,INUMFO)
      CALL SETARA(IBASE,NIFISS*2      ,INANFO)
      CALL SETARA(IBASE,NTOTMX*NANISO ,IFGUPO )
      CALL SETARA(RBASE,2*NGROUP+1    ,IENERO)
      CALL SETARA(RBASE,3             ,ITIMN )
C----
C  INITIALIZE VECTOR
C----
      CALL XDISET(IBASE(INUMFN),NBMIXF*NIFISS,0)
      CALL XDISET(IBASE(IFGUPS),NBMIXF*NANISO,NGROUP+1)
      CALL XDRSET(RBASE(ITIMN) ,3            ,0.0)
      NIFISF=0
      NGROF =0
      NEDF  =0
      DO 130 IEN=1,NENTRY
        IPMACR=KENTRY(IEN)
        DO 131 IMIX=1,NTOTMX
          IF(IMLOC(1,IMIX) .EQ. IEN) THEN
            CALL XDISET(ISTATE,NSTATE,0)
            CALL LCMGET(IPMACR,'STATE-VECTOR',ISTATE)
            NBMIXO=ISTATE(2)
            CALL LCMLEN(IPMACR,'DELTAU      ',ILCMLN,ILCMTY)
            NGROO=ILCMLN
            NLO=ISTATE(3)
            NIFISO=ISTATE(4)
            NEDO=ISTATE(5)
            CALL MACNFI(IPMACR,IPRINT,IEN   ,NTOTMX,NGROUP,NANISO,
     >                  NIFISS,NEDMAC,NBMIXF,NGROF ,NIFISF,NEDF  ,
     >                  NBMIXO,NGROO ,NLO   ,NIFISO,NEDO  ,IMLOC ,
     >                  RBASE(IENERN),IBASE(INAMEN),IBASE(INAMFN),
     >                  IBASE(INUMFN),IBASE(IFGUPS) ,RBASE(IENERO),
     >                  IBASE(INAMEO),IBASE(INANFO),IBASE(INUMFO),
     >                  IBASE(IFGUPO))
            GO TO 135
          ENDIF
 131    CONTINUE
 135    CONTINUE
 130  CONTINUE
C----
C  SAVE ENERGY, ADDITIONAL XS NAME AND FISSILE ISOTOPES INFORMATION
C  ON FINAL MACROLIB
C----
      IPMACR=KENTRY(1)
      IF(NGROF .GT. 0) THEN
        CALL LCMPUT(IPMACR,'ENERGY      ',NGROF+1,
     >    2,RBASE(IENERN))
        CALL LCMPUT(IPMACR,'DELTAU      ',NGROF  ,
     >    2,RBASE(IENERN+NGROF+1))
        IF(IPRINT .GE. 5) THEN
          WRITE(IOUT,6010) 'ENERGY      '
          WRITE(IOUT,6013) (RBASE(IENERN+ITC-1),ITC=1,NGROF+1)
          WRITE(IOUT,6010) 'DELTAU      '
          WRITE(IOUT,6013) (RBASE(IENERN+ITC-1),ITC=NGROF+2,2*NGROF+1)
        ENDIF
      ENDIF
      IF(NEDF .GT. 0) THEN
        CALL LCMPUT(IPMACR,'ADDXSNAME   ',2*NEDF ,
     >    3,IBASE(INAMEN))
        IF(IPRINT .GE. 5) THEN
          WRITE(IOUT,6010) 'ADDXSNAME   '
          WRITE(IOUT,6011) (IBASE(INAMEN+ITC-1),ITC=1,2*NEDO)
        ENDIF
      ENDIF
      IF(NIFISF .GT. 0) THEN
        CALL LCMPUT(IPMACR,'FISSIONNAMES',2*NIFISF,
     >    3,IBASE(INAMFN))
        IF(IPRINT .GE. 5) THEN
          WRITE(IOUT,6010) 'FISSIONNAMES'
          WRITE(IOUT,6011) (IBASE(INAMFN+ITC-1),ITC=1,2*NIFISF)
          WRITE(IOUT,6010) 'FISSIONNB   '
          WRITE(IOUT,6012) (IBASE(INUMFN+ITC-1),ITC=1,NBMIXF*NIFISF)
        ENDIF
      ENDIF
      CALL LCMPUT(IPMACR,'FGWITHUPSCAT',NBMIXF*NANISO,
     >    1,IBASE(IFGUPS))
      CALL LCMPUT(IPMACR,'TIMESTAMP   ',3,
     >    2,RBASE(ITIMN))
      CALL RLSARA(RBASE(ITIMN))
      CALL RLSARA(RBASE(IENERO))
      CALL RLSARA(IBASE(IFGUPO))
      CALL RLSARA(IBASE(INANFO))
      CALL RLSARA(IBASE(INUMFO))
      CALL RLSARA(IBASE(INAMEO))
      CALL RLSARA(RBASE(IENERN))
      CALL RLSARA(IBASE(IFGUPS))
      CALL RLSARA(IBASE(INAMFN))
C----
C  TREAT NU AND EFISS
C----
      NTREA=NREACD+3*NIFISF+NEDF
      CALL SETARA(RBASE,NTOTMX*(NIFISF+1),IXSTMP)
      CALL SETARA(RBASE,NBMIXF*NTREA,IXSGEN)
      CALL SETARA(IBASE,NTREA+NANISO,IXSPRO)
      CALL XDISET(IBASE(IXSPRO),NTREA+NANISO,0)
      IEFPRO=0
      DO 170 IEN=1,NENTRY
        IPMACR=KENTRY(IEN)
        CALL MACEFI(IPMACR,IPRINT,IEN   ,NTOTMX,NBMIXF,NIFISF,
     >              IMLOC ,IEFPRO,
     >              IBASE(INUMFN),RBASE(IXSGEN),RBASE(IXSTMP))
 170  CONTINUE
      IPMACR=KENTRY(1)
      IF(IEFPRO .EQ. 1) THEN
C----
C  SAVE EFISS
C----
        CALL LCMPUT(IPMACR,'EFISS       ',NBMIXF*NIFISF,
     >              2,RBASE(IXSGEN))
      ENDIF
C----
C  ALLOCATE MEMORY FOR CROSS SECTIONS PROCESSING
C----
      CALL SETARA(RBASE,NGROUP*NBMIXF*NANISO*2,ISCAT)
      CALL SETARA(RBASE,NGROUP*NTOTMX,ISCTMP)
      CALL SETARA(IBASE,NTOTMX*3,IISCAT)
      IPRG=IPRINT
      DO 140 IGR=1,NGROUP
        WRITE(GRPDIR,'(A5,I3,A1,I3)') 'GROUP',IGR,'/',NGROUP
        CALL XDRSET(RBASE(IXSGEN),NBMIXF*NTREA,0.0)
C----
C  CVS-UPDATE: 2000/09/07 
C  INITIALIZATION OF RBASE(ISCAT) WAS 
C       CALL XDRSET(RBASE(ISCAT),NGROUP*NBMIXF*NANISO,0.0)
C  LEAD TO INCORRECT INITIALIZATION OF ADJOINT SCATTERING  
C  REPLACE WITH
C       CALL XDRSET(RBASE(ISCAT),NGROUP*NBMIXF*NANISO*2,0.0)
C----
        CALL XDRSET(RBASE(ISCAT),NGROUP*NBMIXF*NANISO*2,0.0)
        DO 150 IEN=1,NENTRY
          IPMACR=KENTRY(IEN)
          IF(IPRG .GE. 10) THEN
            WRITE(IOUT,6020) NAMSBR,IEN
          ENDIF
          DO 151 IMIX=1,NTOTMX
            IF(IMLOC(1,IMIX) .EQ. IEN) THEN
              CALL LCMSIX(IPMACR,GRPDIR,ILCMUP)
              CALL MACRDM(IPMACR,IPRG  ,IEN   ,NTOTMX,NGROUP,NANISO,
     >                    NBMIXF,NIFISF,NEDF  ,NREACD,NTREA ,IMLOC ,
     >                    NAMREA,
     >                    IBASE(INAMEN),IBASE(INUMFN),IBASE(IXSPRO),
     >                    RBASE(IXSGEN),RBASE(ISCAT) ,RBASE(IXSTMP),
     >                    RBASE(ISCTMP),IBASE(IISCAT))
              CALL LCMSIX(IPMACR,GRPDIR,ILCMDN)
              GO TO 155
            ENDIF
 151      CONTINUE
 155      CONTINUE
 150    CONTINUE
        IPMACR=KENTRY(1)
        CALL LCMSIX(IPMACR,GRPDIR,ILCMUP)
C----
C  FOR TRANC OFF DO NOT SAVE TRANSPORT CORRECTION
C----
        IF(ITRANC .EQ. 0) IBASE(IXSPRO+1)=0
        CALL MACPRM(IPMACR,IPRG  ,NGROUP,NANISO,NBMIXF,NIFISF,
     >              NEDF  ,NREACD,NTREA ,IGR   ,NAMREA,
     >              IBASE(INAMEN),IBASE(IXSPRO),RBASE(IXSGEN),
     >              RBASE(ISCAT) ,RBASE(ISCTMP),IBASE(IISCAT))
        CALL LCMSIX(IPMACR,GRPDIR,ILCMDN)
        IPRG=0
 140  CONTINUE
      CALL RLSARA(IBASE(IISCAT))
      CALL RLSARA(RBASE(ISCTMP))
      CALL RLSARA(RBASE(ISCAT))
      CALL RLSARA(IBASE(IXSPRO))
      CALL RLSARA(RBASE(IXSGEN))
      CALL RLSARA(RBASE(IXSTMP))
      IF(NIFISF .GT. 0) THEN
C----
C  RESET NUMFFN TO ONE FOR TERMS WHICH ARE NOT 0
C  AND SAVE
C----
        DO 160 IFI=1,NBMIXF*NIFISF
          IF(IBASE(INUMFN+IFI-1) .GT. 0) THEN
            IBASE(INUMFN+IFI-1)=1
          ENDIF
 160    CONTINUE
        CALL LCMPUT(IPMACR,'FISSIONNB   ',NBMIXF*NIFISF,
     >    1,IBASE(INUMFN))
      ENDIF
      CALL RLSARA(IBASE(INUMFN))
      CALL RLSARA(IBASE(INAMEN))
      NBMIX=NBMIXF
      NIFISS=NIFISF
      NEDMAC=NEDF
      RETURN
C----
C  EDIT FORMATS
C----
 6000 FORMAT(1X,A6,' - UPDATING  MACROLIB ')
 6010 FORMAT(7X,   '   PRECESSING RECORD   : ',A12)
 6011 FORMAT(10(2A4,4X))
 6012 FORMAT(10(I8,4X))
 6013 FORMAT(1P,8E15.7)
 6020 FORMAT(1X,A6,'   PROCESSING MACROLIB : ',I12)
      END
