      SUBROUTINE MCU(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*-----------------------------------------------------------------------
*
* 3-D CHARACTERISTICS SOVER WITH EXCELL TYPE (3-D) TRACKING.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_FLUX).
*  HENTRY(2) : CREATE OR READ-ONLY    TYPE(L_TRACK).
*  HENTRY(3) : READ-ONLY              TYPE(L_GEOM) OR 
*              READ-ONLY SEQ. BINARY TRACKING FILE.
*  HENTRY(4) : READ-ONLY              TYPE(L_MACROLIB).
*
*     AUTHOR: M. DAHMANI (07/2003)
*---------------------------------------------------------------------
      IMPLICIT  NONE
C
      INTEGER      NENTRY                  	
      CHARACTER    HENTRY(NENTRY)*12
      INTEGER      IENTRY(NENTRY),JENTRY(NENTRY),KENTRY(NENTRY)
   
      INTEGER   IOUT,NSTATE
      PARAMETER( IOUT=6,NSTATE=40)
      CHARACTER  TEXT4*4,TEXT12*12,TITLE*72,HSIGN*12
      LOGICAL   LASS, LDRASS
      DOUBLE PRECISION DFLOTT
      INTEGER   ITITL(18)
      INTEGER   I,J,ITRANC,NANIS,MAXPTS,MAXMIX,NGRP,IPRT,NORE
      REAL      CUTOFX, ATCRMX, AIEPS, AEEPS
      INTEGER   INDIC,NITMA,IDATA,INDLEC, ISYMM,NREG,I1,NUN,IGP4
      INTEGER   NANG, NIFIS, MIFIS,ITRB,NL,NBN,NINTMX,NEXTMX,ITYPEC
      INTEGER   ILEAK,IFRITR,IACITR,IREBAL,MGTRK,MAXSCR,ICAC,ITCRMX
      REAL      FLOTT, ADATA,DENS
*
      INTEGER   IPGEOM, IPMACR, IPTRK, IPFLUX
      INTEGER   XSSIGT, XSSIGW, XSSIG1, MATCOD, VOLUME, KEYFLX
      INTEGER   IMAT, IVOL, IIDL, ITYLCM, IFTRAK, NGTRK, IFLMPI, IFLUXW
      INTEGER   NJJ, IJJ, IPOS, IXSSOL, IXSSIT, IXSSIW, IXSCHI, IXSNUF
      INTEGER   IXSTK, IXSCAT, IVSCAT, MAXM1, LENGT 
*
      REAL            RD
      COMMON          RD(1)
      INTEGER         ID(1)
      EQUIVALENCE    (RD(1),ID(1))
CMD
      CHARACTER*8 CDATA,CMAXR,CTITL,CRENO,CRENM,CNORE,
     >     CCUT,CTRAK,
     >     CS,    CK,    CB,    CSIGS, CTYPE, CNOBA,
     >     CACCE, CPNL,  CEXEC, CEDIT, CNBPN, CTHER,
     >     CEXTE, CBUCK, CB0,   CB0TR, CB1,   CP1  ,
     >     CCURR, CITCR, CJACC, CITLM, CMERG, CETAB,
     >     CSCR
      DOUBLE PRECISION DDATA
      LOGICAL LEAKSW,ILK, LJACC, LITLM, LINIF, LETAB, LPVM
      INTEGER KCHAR(18),ISTATE(NSTATE)
      REAL    ALBEDO(6)
      REAL   ZERO, ONE, RB2
      PARAMETER ( ZERO=0., ONE=1. )
C
      DATA  CMAXR,CTITL,CRENO,CRENM,CNORE,CCUT,CTRAK,
     >      CS,    CK,    CB,    CSIGS, CTYPE, CNOBA,
     >      CACCE, CPNL,  CEXEC, CEDIT, CNBPN, CTHER,
     >      CEXTE, CBUCK, CB0,   CB0TR, CB1,   CP1  ,
     >      CCURR, CITCR, CJACC, CITLM, CMERG, CETAB,
     >      CSCR
     >    /'MAXR','TITL','RENO','RENM','NORE','CUT','TRAK', 
     >     'S   ','K   ','B   ','SIGS','TYPE','NOBA',
     >     'ACCE','PNL ','; ','EDIT','NBPN','THER',
     >     'EXTE','BUCK','B0  ','B0TR','B1  ','P1  ',
     >     'CURR','ITCR','JACC','ITLM','MERG','ETAB',
     >     'SCR '/
*
* PARAMETER VALIDATION.
*
      IF(NENTRY.LT.4) THEN 
         CALL XABORT('MCU: AT LEAST FOUR DATA STRUCTURES REQUIRED')
      ENDIF
      IPFLUX= KENTRY(1)
      IF(IENTRY(1).NE.1.AND.IENTRY(1).NE.2) THEN
        CALL XABORT
     >  ('MCU: FIRST DATA STRUCTURE NOT A LINKED LIST OR XSM FILE')
      ENDIF
      IF(JENTRY(1).EQ.1) THEN
         CALL LCMGET(IPFLUX,'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(HSIGN.NE.'L_FLUX') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('MCU: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     >      '. L_FLUX EXPECTED.')
         ENDIF
      ELSE
         HSIGN='L_FLUX'
         READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
         CALL LCMPUT(IPFLUX,'SIGNATURE',3,3,KCHAR)
      ENDIF
CD      
      IPTRK= KENTRY(2)
      IF(IENTRY(2).NE.1) THEN 
        CALL XABORT('MCU: SECOND DATA STRUCTURE NOT A LINKED LIST')
      ENDIF
      IF(JENTRY(2).EQ.0) THEN
          HSIGN='L_TRACK'
          READ(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
          CALL LCMPUT(IPTRK,'SIGNATURE',3,3,KCHAR)
      ELSE 
          CALL XDRSET(ISTATE,NSTATE,0)
          CALL LCMGET(IPTRK,'STATE-VECTOR',ISTATE)
      	  NREG=   ISTATE(1)
      	  NUN=    ISTATE(2)+ISTATE(5)+1
     	  LEAKSW= ISTATE(3).EQ.0
          IGP4=   ISTATE(4)
     	  NANG=   ISTATE(11)
          CALL SETARA(ID,NREG,IMAT)
          CALL SETARA(RD,NREG,IVOL)
          CALL SETARA(ID,NREG,IIDL)
          CALL LCMGET(IPTRK,'MATCOD',ID(IMAT))
          CALL LCMGET(IPTRK,'VOLUME',RD(IVOL))
          CALL LCMGET(IPTRK,'KEYFLX',ID(IIDL))
          CALL LCMGET(IPTRK,'ALBEDO',ALBEDO)
          CALL LCMLEN(IPTRK,'TITLE',LENGT,ITYLCM)
      ENDIF
*
* RECOVER GEOMETRY OR TRACKING
      IF((IENTRY(3).NE.1.AND.IENTRY(3).NE.2).AND.IENTRY(3).NE.3)THEN
      CALL XABORT
     >  ('MCU: THIRD DATA STRUCTURE NOT A LINKED LIST OR XSM FILE')
      ENDIF
      IF(JENTRY(3).NE.2) CALL XABORT
     >  ('MCU: THIRD DATA STRUCTURE NOT IN READ-ONLY MODE')
      IF(IENTRY(3).EQ.1.OR.IENTRY(3).EQ.2) THEN
          IPGEOM= KENTRY(3)
         CALL LCMGET(IPGEOM,'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
         TEXT12=HENTRY(3)
         IF(HSIGN.NE.'L_GEOM') THEN
           CALL XABORT('MCU: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_GEOM EXPECTED.')
         ENDIF
         CALL LCMGET(IPGEOM,'STATE-VECTOR',ISTATE)
         MAXPTS=ISTATE(6)
      ELSEIF(IENTRY(3).EQ.3) THEN
         IFTRAK=KENTRY(3)  
      ENDIF   
*
* RECOVER MACROLIB.
      IPMACR= KENTRY(4)
      IF(IENTRY(4).NE.1.AND.IENTRY(4).NE.2) CALL XABORT
     >  ('MCU: FOURTH DATA STRUCTURE NOT A LINKED LIST OR XSM FILE')
      IF(JENTRY(4).NE.2) CALL XABORT
     >  ('MCU: FOURTH DATA STRUCTURE NOT IN READ-ONLY MODE')
      CALL LCMGET(IPMACR,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(J),J=1,3)
      TEXT12=HENTRY(4)
      IF(HSIGN.NE.'L_MACROLIB'.AND.HSIGN.NE.'L_LIBRARY') THEN
         CALL XABORT('MCU: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_MACROLIB OR L_LIBRARY EXPECTED.')
      ENDIF
*
* RECOVER MACROLIB PARAMETERS.
      CALL LCMGET(IPMACR,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I),I=1,3)
      IF(HSIGN.EQ.'L_LIBRARY') THEN
         CALL LCMSIX(IPMACR,'MACROLIB',1)
      ELSE IF(HSIGN.NE.'L_MACROLIB') THEN
         TEXT12=HENTRY(4)
         CALL XABORT('MCU: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_MACROLIB EXPECTED.')
      ENDIF
      CALL XDRSET(ISTATE,NSTATE,0)
      CALL LCMGET(IPMACR,'STATE-VECTOR',ISTATE)
      NGRP=   ISTATE(1)
      MAXMIX= ISTATE(2)
      NANIS=  ISTATE(3)-1
      NIFIS=  ISTATE(4)
      MIFIS=  MAX(NIFIS,1)
      ITRANC= ISTATE(6)
*
*     RECOVER FLUX INFORMATION IF ANY, OR IMPOSE DEFAULT VALUES IF NOT.
*
      IPRT=1
      TITLE=' '
      ITRB= 0
      NL=  -1
      NBN= -1
      NINTMX= 4*NGRP
      NEXTMX= 2*NREG + 1
      IF( JENTRY(1).EQ.1)THEN
         CALL LCMLEN(IPFLUX,'STATE-VECTOR',LENGT,ITYLCM)
         IF( LENGT.EQ.0.OR.ITYLCM.NE.1 )THEN
            CALL XABORT('MCU: INVALID FPARAM RECORD ON FLUX')
         ENDIF
         CALL LCMGET(IPFLUX,'STATE-VECTOR',ISTATE)
         ITYPEC= ISTATE(1)
         ILEAK=  ISTATE(2)
         IFRITR= ISTATE(3)
         IACITR= ISTATE(4)
         IREBAL= ISTATE(5)
      ELSE
         ITYPEC= -99
         ILEAK=  0
         IFRITR= 3
         IACITR= 3
         IREBAL= 1
      ENDIF
      ILK= IREBAL.EQ.1
      ILK=.true.
      LJACC=.TRUE.
      LITLM=.FALSE.
*
      MGTRK = 1
      RB2=0.0
      MAXSCR = 5
      ICAC= 0
      ITCRMX= 10
      ATCRMX= 5.0E-5
      NANIS=0
      NORE=0
      CUTOFX=0.0
      CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
   40 CONTINUE  
      IF(INDLEC.EQ.10) THEN
         LASS=LDRASS(IPGEOM,1,IPRT)
      	GO TO 55
      ENDIF
      IF(INDLEC.NE.3) CALL XABORT('MCU: CHARACTER DATA EXPECTED.')
      IF(CDATA(1:4).EQ.CEDIT(1:4)) THEN
         CALL REDGET(INDLEC,IPRT,ADATA, CDATA, DDATA)
         IF(INDLEC.NE.1) CALL XABORT('MCU: INTEGER DATA EXPECTED(1).')
      ENDIF
      IF( CDATA(1:4).EQ.CTYPE(1:4) )THEN
           CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
           IF( CDATA(1:4).EQ.CS(1:4) )THEN
              ITYPEC= 0
           ELSEIF( CDATA(1:4).EQ.CK(1:4) )THEN
              ITYPEC= 1
           ELSEIF( CDATA(1:4).EQ.CB(1:4) )THEN
              ITYPEC= 3
           ELSE
            CALL XABORT( 'MCU: TYPE *S*, *K* OR *B* HAS TO BE READ')
           ENDIF
           CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ENDIF
      IF( ITYPEC.EQ.-99 )THEN
         CALL XABORT( 'MCU: TYPE *S*, *K* OR *B* HAS TO BE READ')
      ENDIF
*
      IF( ITYPEC.EQ.0.OR.ITYPEC.EQ.1 )THEN
         NL= 0
         IF( CDATA(1:4).EQ.CP1(1:4) )THEN
            NL= 1
            IF( NL.GT.NANIS )THEN
               CALL XABORT('MCU: ILLEGAL OPTION = *P1* '//
     >          ' WITHOUT P1 SCATTERING CROSS SECTIONS')
            ENDIF
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ENDIF
      ELSEIF( ITYPEC.EQ.3 )THEN
         IF( CDATA(1:4).EQ.CB0(1:4) )THEN
            IF( ITRANC.NE.0 )THEN
               CALL XABORT('MCU: ILLEGAL OPTION = *B0* '//
     >              ' WITH TRANSPORT CORRECTED CROSS SECTIONS')
            ENDIF
            NBN= 0
            NL= 0
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ELSEIF( CDATA(1:4).EQ.CB0TR(1:4) )THEN
            IF( ITRANC.EQ.0 )THEN
               CALL XABORT('MCU: ILLEGAL OPTION = *B0TR* '//
     >              ' WITHOUT TRANSPORT CORRECTED CROSS SECTIONS')
            ENDIF
            NBN= 0
            NL= 0
            ITRB= 1
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ELSEIF( CDATA(1:4).EQ.CB1(1:4) )THEN
            NBN= 1
C           NL= 1
            NL= 0
            IF( NL.GT.NANIS )THEN
               CALL XABORT('MCU: ILLEGAL OPTION = *B1* '//
     >              ' WITHOUT P1 SCATTERING CROSS SECTIONS')
            ENDIF
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ENDIF
         ILEAK= 2
         IF( CDATA(1:4).EQ.CSIGS(1:4) )THEN
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
            ILEAK= 3
         ELSEIF( CDATA(1:4).EQ.CPNL(1:4) )THEN
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
            ILEAK= 2
         ENDIF
      ENDIF
      IF( CDATA(1:4).EQ.CNBPN(1:4) )THEN
         CALL REDGET ( INDLEC, NL, ADATA, CDATA, DDATA)
         IF( INDLEC.NE.1 )CALL XABORT( 'MCU: NBPN  HAS TO BE READ')
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         IF( NL.GT.NANIS )THEN
            CALL XABORT('MCU: ANISOTROPY ORDER GREATER THAN MIXTURES')
         ELSEIF( NL.LT.0 )THEN
            CALL XABORT('MCU: ANISOTROPY ORDER LESS THAN 0')
         ENDIF
      ENDIF
      IF( CDATA(1:4).EQ.CBUCK(1:4) )THEN
         CALL REDGET ( INDLEC, IDATA, RB2, CDATA, DDATA)
         IF( INDLEC.NE.2 )CALL XABORT( 'MCU: BUCKLING  HAS TO BE READ')
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ENDIF
      IF(NL.EQ.-1) NL= NANIS
      IF( CDATA(1:4).EQ.CNOBA(1:4) )THEN
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ILK= .FALSE.
      ENDIF
*
      IF( CDATA(1:4).EQ.CACCE(1:4) )THEN
         CALL REDGET ( INDLEC, IFRITR, ADATA, CDATA, DDATA)
         CALL REDGET ( INDLEC, IACITR, ADATA, CDATA, DDATA)
         CALL REDGET ( INDLEC, IDATA,  ADATA, CDATA, DDATA)
      ENDIF
C
      IF( CDATA(1:4).EQ.CSCR(1:4) )THEN
         CALL REDGET ( INDLEC, MAXSCR, ADATA, CDATA, DDATA)
         CALL REDGET ( INDLEC, IDATA,  ADATA, CDATA, DDATA)
      ENDIF
C     MERG {0|1|2} Default is MERG 1
      IF( CDATA(1:4).EQ.CMERG(1:4) )THEN
         CALL REDGET ( INDLEC, MGTRK, ADATA, CDATA, DDATA)
         IF( INDLEC.EQ.1 ) THEN
            IF( .NOT.(MGTRK.EQ.0 .OR. MGTRK.EQ.1 .OR. MGTRK.EQ.2) )THEN
               WRITE(IOUT,*)
     >         "MCU: MERG LEVEL IS ONLY POSSIBLE FOR 0, 1, 2"
               WRITE(IOUT,*) 
     >         "MCU: MERG LEVEL IS RESET TO 1 !!"
               NGTRK = 1
            ENDIF
            CALL REDGET(INDLEC, IDATA, ADATA, CDATA, DDATA)
         ELSE
            MGTRK = 1
         ENDIF
      ENDIF
C     [ETAB [ON|OFF]] Default is ON
      LETAB = .TRUE.
      IF( CDATA(1:4).EQ.CETAB(1:4) )THEN
         CALL  REDGET ( INDLEC, IDATA,  ADATA, CDATA, DDATA)
         IF( CDATA(1:4).EQ.'ON  ' )THEN
            LETAB = .TRUE.
         ELSE IF( CDATA(1:4).EQ.'OFF ' )THEN
            LETAB = .FALSE.
         ELSE
            CALL XABORT('MCU: ON OR OFF HAS TO BE READ')
         ENDIF
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ENDIF
      IF( CDATA(1:4).EQ.CTHER(1:4) )THEN
         CALL REDGET ( INDLEC, NINTMX, AIEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MCU: NINT OR EPS INTERNAL HAS TO BE READ')
         CALL REDGET ( INDLEC, NINTMX, AIEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MCU: NINT OR EPS INTERNAL HAS TO BE READ')
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ELSE
         AIEPS = 5.0E-05
      ENDIF
      IF( CDATA(1:4).EQ.CEXTE(1:4) )THEN
         CALL REDGET ( INDLEC, NEXTMX,  AEEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MCU: NEXT OR EPS EXTERNAL HAS TO BE READ')
         CALL REDGET ( INDLEC, NEXTMX,  AEEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MCU: NEXT OR EPS EXTERNAL HAS TO BE READ')
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ELSE
         AEEPS = 1.0E-05
      ENDIF
      IF( CDATA(1:4).EQ.CCURR(1:4) )THEN
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         IF( CDATA(1:4).EQ.'DIRT' )THEN
           ICAC= 0
           ITCRMX= 1
         ELSEIF( CDATA(1:4).EQ.'CHAR' )THEN
           ICAC= 2
         ELSE
           CALL XABORT( 'MCU: DIRT or PTRM or CHAR HAS TO BE READ' )
         ENDIF
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ENDIF
      IF( CDATA(1:4).EQ.CJACC(1:4) )THEN
         CALL  REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         IF( CDATA(1:4).EQ.'ON  ' )THEN
           LJACC=.TRUE.
         ELSEIF( CDATA(1:4).EQ.'OFF ') THEN
           LJACC=.FALSE.
         ELSE
           CALL XABORT( 'MCU: ON or OFF HAS TO BE READ' )
         ENDIF
         CALL  REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ENDIF
      IF( CDATA(1:4).EQ.CITCR(1:4) )THEN
         CALL REDGET ( INDLEC, ITCRMX,  ATCRMX, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MCU: NEXT OR EPS CURRENT HAS TO BE READ')
         CALL REDGET ( INDLEC, ITCRMX,  ATCRMX, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MCU: NEXT OR EPS CURRENT HAS TO BE READ')
        CALL REDGET ( INDLEC, IDATA,  ADATA, CDATA, DDATA)
      ENDIF
      IF( CDATA(1:4).EQ.CITLM(1:4) )THEN
        LITLM = .TRUE.
        CALL REDGET ( INDLEC, IDATA,  ADATA, CDATA, DDATA)
      ENDIF
*
*-------- Read Tracking Data 
*
      IF(IENTRY(3).NE.3) THEN
C      
      	IF(CDATA(1:4).EQ.CMAXR(1:4)) THEN
        	 CALL REDGET(INDLEC,MAXPTS,ADATA, CDATA, DDATA)
        	 IF(INDLEC.NE.1) CALL 
     >        	 XABORT('MCU: INTEGER DATA EXPECTED(2).')
        	 CALL REDGET(INDLEC,IDATA,ADATA, CDATA, DDATA)
     	 ENDIF
      	 IF(CDATA(1:4).EQ.CTITL(1:4)) THEN
      	   CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
           IF(INDLEC.NE.3) CALL XABORT('MCU: TITLE EXPECTED.')
     	 ENDIF
      	 IF(CDATA(1:4).EQ.CRENO(1:4)) NORE=0
      	 IF(CDATA(1:4).EQ.CRENM(1:4)) THEN
C----
C  RENM NOT AVAILABLE HERE REVERT TO RENO
C----
         	NORE=0
      	 ENDIF
     	 IF(CDATA(1:4).EQ.CNORE(1:4)) NORE=1
      	 IF(CDATA(1:4).EQ.CCUT(1:4)) THEN
        	 CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         	 IF(INDLEC.NE.2.OR.FLOTT.LT.0.0) THEN
           	   CALL XABORT('MCU: CUTOFF MUST BE A POSITIVE REAL')
        	 ENDIF
        	 CUTOFX=FLOTT
     	 ENDIF
     	 IF(CDATA(1:4).EQ.CTRAK(1:4)) THEN
       		  LASS=LDRASS(IPGEOM,1,IPRT)
        	  GOTO 55
      	 ENDIF
      	 IF( CDATA(1:4).EQ.CEXEC(1:4) )THEN
         	  LASS=LDRASS(IPGEOM,1,IPRT)
         	  GOTO 55
   	     ENDIF
      ELSE
         IF( CDATA(1:4).EQ.CEXEC(1:4) )THEN
             GOTO 55
         ENDIF   
      ENDIF
      GOTO 40
   55 CONTINUE
*
*------------------------------------------------------------------------
CMD
      LINIF= (JENTRY(1).EQ.0)
      IF(IENTRY(3).EQ.3) THEN
*
* READ A TRACKING FROM TRACKING FILE (USE EXCELT MODULE)
*
           CALL SETARA(RD,2*NUN*NGRP,IFLUXW)
           CALL SETARA(RD,2*NUN*NGRP,IFLMPI)
*
           CALL SETARA(ID,MAXMIX,NJJ)
           CALL SETARA(ID,MAXMIX,IJJ)
           CALL SETARA(ID,MAXMIX,IPOS)
           MAXM1= MAXMIX+1
           CALL SETARA(RD,NGRP*MAXM1,IXSSOL)
           CALL SETARA(RD,NGRP*MAXM1,IXSSIT)
           CALL SETARA(RD,NGRP*MAXM1,IXSSIW)
           CALL SETARA(RD, MAXM1*NGRP*MIFIS, IXSCHI)
           CALL SETARA(RD, MAXM1*NGRP*MIFIS, IXSNUF)
           CALL SETARA(RD, MAXMIX*MIFIS, IXSTK)
           CALL SETARA(RD, MAXM1*NGRP*NGRP*(NANIS+1), IXSCAT)
           CALL SETARA(RD, MAXMIX*NGRP*NGRP, IVSCAT)
           CALL MCIDRV(
     +        IPFLUX, IPTRK , IPMACR, RB2   , IFTRAK, NGRP  ,
     +        MAXMIX, MIFIS , NANIS , NL    , NBN   , NUN ,  
     +        RD(IFLUXW)  ,  RD(IFLMPI), NINTMX         , 
     +        AIEPS, NEXTMX        , AEEPS        , IFRITR,
     +        IACITR, ITYPEC, ILEAK , NREG  , ID(IMAT),
     +        RD(IVOL)    , RD(IXSSOL)  , RD(IXSSIT)  ,
     +        RD(IXSSIW)  , RD(IXSCHI)  , RD(IXSNUF)  ,
     +        RD(IXSTK)   , ID(NJJ)    , ID(IJJ)    ,
     +        ID(IPOS)   , RD(IXSCAT)  , RD(IVSCAT)  ,
     +        ALBEDO, LEAKSW, ILK   , ICAC  , ITRANC, ITRB  ,
     +        ITCRMX, ATCRMX, LJACC , LITLM , LINIF ,
     +        LETAB , MGTRK , MAXSCR, IPRT  )
           CALL RLSARA(RD(IVSCAT))
           CALL RLSARA(RD(IXSCAT))
           CALL RLSARA(RD(IXSTK ))
           CALL RLSARA(RD(IXSNUF))
           CALL RLSARA(RD(IXSCHI))
           CALL RLSARA(RD(IXSSIW))
           CALL RLSARA(RD(IXSSIT))
           CALL RLSARA(RD(IXSSOL))
           CALL RLSARA(ID(IPOS))
           CALL RLSARA(ID(IJJ))
           CALL RLSARA(ID(NJJ))
           CALL RLSARA(RD(IFLUXW))
           CALL RLSARA(RD(IFLMPI)) 
      ELSE
*
* NO TRACKING FILE IS NEEDED EXCELL TRACKING TYPE
*
* BUILD MULTI-GROUP CROSS-SECTIONS.
           CALL SETARA(RD,NGRP*(MAXMIX+1),XSSIGT)
           CALL SETARA(RD,NGRP*(MAXMIX+1),XSSIGW)
           CALL SETARA(RD,     (MAXMIX+1),XSSIG1)
*
           IF(TITLE.NE.' ') THEN
              READ(TITLE,'(18A4)') (ITITL(I),I=1,18)
              CALL LCMPUT(IPTRK,'TITLE',18,3,ITITL)
           ENDIF
           IF(IPRT.GT.1) WRITE(IOUT,'(1X,A72//)') TITLE
*
           IF(MAXPTS.EQ.0) CALL XABORT('MCU: MAXPTS NOT DEFINED.')
           CALL SETARA(ID,MAXPTS,MATCOD)
           CALL SETARA(RD,MAXPTS,VOLUME)
           CALL SETARA(ID,MAXPTS,KEYFLX)
*
           MAXM1= MAXMIX+1
           CALL SETARA(RD,NGRP*MAXM1,IXSSOL)
           CALL SETARA(RD, MAXM1*NGRP*MIFIS, IXSCHI)
           CALL SETARA(RD, MAXM1*NGRP*MIFIS, IXSNUF)
           CALL SETARA(RD, MAXMIX*MIFIS, IXSTK)
           CALL SETARA(RD, MAXM1*NGRP*NGRP*(NANIS+1), IXSCAT)
           CALL SETARA(RD, MAXMIX*NGRP*NGRP, IVSCAT)
*
           CALL MCUDRV (IPFLUX,IPTRK,IPGEOM,IPMACR, MAXPTS ,
     +          NORE, TITLE, CUTOFX, NGRP, MAXMIX, RD(XSSIGT) ,
     +          RD(XSSIGW),ID(MATCOD),  RD(VOLUME), ID(KEYFLX),
     +          RB2, MIFIS, NANIS, NL,NUN, NBN,  NINTMX,
     +          AIEPS, NEXTMX, AEEPS, IFRITR  ,
     +          IACITR, ITYPEC, ILEAK ,  RD(IXSSOL)  , 
     +          RD(IXSCHI)  , RD(IXSNUF)  ,RD(IXSCAT)  , 
     +          RD(IVSCAT), RD(IXSTK), LEAKSW, ILK, ICAC , 
     +          ITRANC, ITRB, ITCRMX, ATCRMX, LJACC , 
     +          LITLM, LINIF , LETAB , MGTRK , MAXSCR, IPRT )
*
           CALL RLSARA(RD(IVSCAT))
           CALL RLSARA(RD(IXSCAT))
           CALL RLSARA(RD(IXSTK ))
           CALL RLSARA(RD(IXSNUF))
           CALL RLSARA(RD(IXSCHI))
           CALL RLSARA(RD(IXSSOL))
           CALL RLSARA(ID(KEYFLX))
           CALL RLSARA(RD(VOLUME))
           CALL RLSARA(ID(MATCOD))
           CALL RLSARA(RD(XSSIG1))
           CALL RLSARA(RD(XSSIGW))
           CALL RLSARA(RD(XSSIGT))
      ENDIF
*
      CALL LCMSIX(IPMACR,' ',0)
      CALL XDRSET(ISTATE,NSTATE,0)
      ISTATE(1)= ITYPEC
      ISTATE(2)= ILEAK
      ISTATE(3)= IFRITR
      ISTATE(4)= IACITR
      IF( ILK )THEN
         ISTATE(5)= 1
      ELSE
         ISTATE(5)= 0
      ENDIF
      CALL LCMPUT(IPFLUX,'STATE-VECTOR',NSTATE,1,ISTATE)
      IF(IPRT.GE.3) CALL LCMLIB(IPFLUX)
      RETURN
      END


