************************************************************************
      SUBROUTINE MCU3DL( IPRT, NANGLE, DENUSR,ISYMM, ANGLES,DENSTY,
     +                   NTOTCL,MAXMIX,NEXTGE,MAXR,REMESH,LINMAX,MAXPTS,
     +                   RCUTOF, NSUR, NVOL, INDEL, MINDIM, NANGL,
     +                   MAXDIM,ICOORD,INCR,ICUR,TRKBEG,CONV,TRKDIR,
     +                   INVVOL, NGRP, SWVOID, ALBEDO,
     +                   ISPEC,NORE,MATCOD,MATMRG,VOLTRK,
     +                   KEYMRG,NSOUT, NREG, VOLMRG,NUNK, NUNKNO,VOL,
     +                   IPFLUX, IPMACR,RB2, NIFIS, NANIS, NL,  
     +                   NBN, NINTMX, AIEPS , NEXTMX, AEEPS ,
     +                   IFRITR, IACITR, ITYPEC, ILEAK ,
     +                   XSOLD, XSCHI, XSNUF, XSCAT, VSCAT, XSTK, 
     +                   NMOD, LEAKSW, ILK , ICAC  , ITRANC, ITRB,
     +                   TITRE , ITCRMX, ATCRMX, LJACC , LITLM ,
     +                   LINIF , LETAB , MGTRK , MAXSCR,  
     +                   VOLSUR, MATALB,  NJJ, IJJ, IPOS )
************************************************************************
*                                                                      *
*           NAME: MCU3DL                                               *
*           AUTHOR: M. DAHMANI                                         *                                          
*           SUBROUTINE: 3D CHARACTERISTICS DRIVER                      *
*                                                                      *
* IPRT   / INTERMEDIATE PRINTING LEVEL FOR OUTPUT.      /I./INT        *
* NANGLE / # OF ANGLES USED IN THE TRACKING PROCESS.    /I./INT        *
* DENUSR / DENSITY OF TRACKS IN THE PLANE PERPENDICULAR /I./REL        *
*        /      TO THE TRACKING ANGLES.                 /  /           *
* ANGLES / 3D ANGLE VALUES.                             /I./R(3*NSOLAN)*
* DENSTY / DENSITY OF TRACKS ANGLE BY ANGLE.            /I./REL(NSOLAN)*
************************************************************************
C
      IMPLICIT      NONE
C
      INTEGER       IPRT,NANGLE,NTOTCL,NEXTGE,MAXR,LINMAX,NANGL,
     >              NSUR,NVOL,NGRP,NORE,NRMV,NSOUT,NREG,MAXMIX,MAXPTS
      REAL          DENUSR, AIEPS, RKEFF, RB2
C
      REAL          TRKBEG(NTOTCL), TRKDIR(NTOTCL), CONV(NTOTCL),
     >              REMESH(MAXR),  DENSTY(*), RCUTOF,
     >              TRKEND(3), TRKORI(3), TRKOR2(3), PROJC2(3),
     >              ANGEQN(3,3), ANGLE2(3), ANGLE3(3), BARY(3),
     >              TRKCUT(3,2), TCUTOF(3,4), TORIC(3), ANGLES(3,*) 
      DOUBLE PRECISION VOLTRK(NSUR:NVOL,0:*)
      INTEGER       MINDIM(NTOTCL), MAXDIM(NTOTCL), ICUR(NTOTCL),
     >              ICOORD(NTOTCL), INCR(NTOTCL), 
     >              INDEL(4,*), NSBEG(4), NSEND(4), NSCUT(2),
     >              KEYMRG(NSUR:NVOL), MATALB(NSUR:NVOL),
     >              NCSEG, NOLDS, NNEWS,IVOLTK
      INTEGER       ISYMM
      INTEGER       IQUART(4)
      LOGICAL       LANGLE, SWVOID
      EQUIVALENCE ( ANGEQN(1,2), ANGLE2 ), ( ANGEQN(1,3), ANGLE3 )
      CHARACTER     TEDATA*13
      INTEGER       NPAN, IOUT
      DOUBLE PRECISION DZERO
      PARAMETER   ( NPAN=3, IOUT=6, DZERO=0.0D0 )
C
      INTEGER       NDIM,  I, J, NPOINT, NPO2, NCUTOF, LINM2,
     >              NOTRAK, NSOLAN, IVS, IANG, IVS1, IVS2, IGRP, ISB,
     >              NANGLS, IPAN, NESTIM, JANG, IX, IY, IREF1, I2, I3,
     >              NSOLMX, NTTRK, IANG0, NDEBS, N, IZZ, IANGL, K, K3,
     >              NCROS, LINE, JC, IL, IXSS
CD      REAL          ANORM2, A, B
      REAL          DENLIN, RCIRC, R2CIRC, DP, FCUTOF,
     >              SURTOT, VOLTOT, WEIGHT, DEPART, X, Y, ANN, ODDNXT,
     >              TOTLEN, TOTXXX, DDENST,VOLSUR(*), AEEPS, ATCRMX
CMD
      INTEGER   IUNOUT, ILCMUP, ILCMDN,  NANIS, NIFIS,
     >          IPMACR, IREGIO, ITYLCM, IR, IMAT, IMIX, ITYPEC,
     >          IFIS, JGR, NTRK, ISPEC, NMOD
      REAL      EPSR, ZERO, ONE
      PARAMETER (IUNOUT=6,ILCMUP=1,ILCMDN=2)
      PARAMETER (NDIM=3, EPSR=1.E-6)
      PARAMETER (ZERO=0., ONE=1.)
      LOGICAL     LEAKSW,ILK, LJACC, LITLM, LINIF, LETAB, L2LNG
      CHARACTER   TITRE*72,CGRPNM*12
      INTEGER     NREGIO,MATMRG(-NSOUT:NREG),MATCOD(NREG),ITCRMX,MGTRK,
     >            ITRANC,ITRB,IGR,ILCMLN,NJJ(*),IJJ(*),IPOS(*)
      REAL        XSSIGT(0:MAXMIX,NGRP),XSSIGW(0:MAXMIX,NGRP),
     >            XSOLD(0:MAXMIX,NGRP),VOLMRG(-NSOUT:NREG), VOL(MAXPTS),
     >            XSCAT(NGRP,0:MAXMIX,0:NANIS,NGRP),VSCAT(*),ALBEDO(6),
     >            XSNUF(0:MAXMIX,NIFIS,NGRP),XSCHI(0:MAXMIX,NIFIS,NGRP),
     >            XSTK(MAXMIX,NIFIS), INVVOL(-NSOUT:NREG)
      INTEGER     TTSEG, MBDSEG
      INTEGER     INTEGER2, INTEGER4, REAL4, REAL8
      INTEGER     NMAT, MXSEG, IANI, NPHI,NR,NS, NRNL, NL, MATMAX,
     >            NSS,IPFLUX, ICAC, NINTMX, NEXTMX, ILEAK, 
     >            NBN, IFRITR, IACITR, NUNK, IS, NUNKNO, MAXSCR  
      INTEGER     SIGANG, SANINV, FLUX  , FLUXO ,
     >            EXP2  , FLM   , FLP   , ICYM  ,
     >            ICYP  , SOURCE, SOURCO, ISGNR ,
     >            KEYANI, MASQ  , Q     , REBAL , DA14  ,
     >            FLUC  , XCTOT , XCNUF , XCCHI , XCABS , XCS0  ,
     >            XCTR  , XCCAT , DIFF  , DB2,    DAST  , DBST  ,
     >            DCST  , YTDB2 , YSDB2 , IBETA , CUR   , SEGLEN,
     >            SURF  , VOID  , CMASQ , NUMERO, LENGHT, NRSEG ,
     >            FLUX1 , FACN  , FCSUR , FACF  , DSURF , INDSUR,
     >            FL    , FR    , FS    , FD, FLUXW, INDS
C
      PARAMETER ( INTEGER2=2, INTEGER4=3, REAL4=4, REAL8=6 )
C----
C  PARAMETERS FOR MEMORY ALLOCATION
C----
      REAL            RD
      INTEGER         ID(1)
      COMMON          RD(1)
      EQUIVALENCE    (RD(1),ID(1))
C
      CHARACTER*2 CAN(0:9)
      DATA CAN /' 0',' 1',' 2',' 3',' 4',' 5',' 6',' 7',' 8',' 9'/
      NMAT  = MAXMIX
      MXSEG = LINMAX
C
      IF(IPRT.GE.1) THEN
        WRITE(IUNOUT,6200)
        IF(ITRANC.EQ.-1) THEN
          WRITE(IUNOUT,6100)
        ELSE IF(ITRANC.GE.1) THEN
          WRITE(IUNOUT,6101) ITRANC
        ENDIF
      ENDIF
CDM-----
      NREGIO = NREG
      DO 115 IR=1,NREG
   	     VOL(IR)=VOLMRG(IR)
         MATCOD(IR)=MATMRG(IR)  
  115 CONTINUE
CDM-----	
CDM      IPRT=3
      IF(IPRT.GE.2) THEN
        WRITE(IUNOUT,6000)
        WRITE(IUNOUT,6001) (IREGIO,VOL(IREGIO),MATCOD(IREGIO),
     >                      IREGIO=1,NREGIO)
      ENDIF
      DO 150 IGR=1,NGRP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGRP
        CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
        CALL LCMLEN(IPMACR,'TOTAL',ILCMLN,ITYLCM)
        IF(ILCMLN .GT.0) THEN
          CALL LCMGET(IPMACR,'TOTAL',XSSIGT(1,IGR))
          XSSIGT(0,IGR)=ZERO
          DO 111 IR= 0, NMAT
            XSOLD(IR,IGR)=XSSIGT(IR,IGR)
 111      CONTINUE
        ELSE
          CALL LCMLIB(IPMACR)
          CALL XABORT('MCU3DL: READ ERROR ON LCM RECORD= TOTAL')
        ENDIF
        CALL LCMLEN(IPMACR,'SIGW 0',ILCMLN,ITYLCM)
        IF(ILCMLN.GT.0) THEN
          CALL LCMGET(IPMACR,'SIGW 0',XSSIGW(1,IGR))
          XSSIGW(0,IGR)=ZERO
        ELSE
          DO 110 IR=0,NMAT
 110      XSSIGW(IR,IGR)=ZERO
        ENDIF
        IF(ITRANC.NE.0) THEN
C***         TRANSPORT CORRECTION.
          CALL LCMLEN(IPMACR,'TRANC',ILCMLN,ITYLCM)
          IF(ILCMLN.GT.0) THEN
            CALL LCMGET(IPMACR,'TRANC',VSCAT)
            DO 120 IMAT=1,NMAT
              XSSIGT(IMAT,IGR)=XSSIGT(IMAT,IGR)-VSCAT(IMAT)
              XSSIGW(IMAT,IGR)=XSSIGW(IMAT,IGR)-VSCAT(IMAT)
 120        CONTINUE
          ENDIF
        ENDIF
        IF(IPRT.GE.3) THEN
          WRITE(IUNOUT,6002)  IGR
          WRITE(IUNOUT,6003) (IMIX,XSSIGT(IMIX,IGR),
     >                             XSSIGW(IMIX,IGR),IMIX=1,NMAT)
        ENDIF
        IF( ITYPEC.NE.0 )THEN
           CALL LCMGET(IPMACR,'CHI',XSTK)
           DO 132 IFIS= 1, NIFIS
              XSCHI(0,IFIS,IGR)= ZERO
              DO 131 IMAT= 1, NMAT
                 XSCHI(IMAT,IFIS,IGR)= XSTK(IMAT,IFIS)
  131         CONTINUE
  132      CONTINUE
           CALL LCMGET(IPMACR,'NUSIGF',XSTK)
           DO 134 IFIS= 1, NIFIS
              XSNUF(0,IFIS,IGR)= ZERO
              DO 133 IMAT= 1, NMAT
                 XSNUF(IMAT,IFIS,IGR)= XSTK(IMAT,IFIS)
  133         CONTINUE
  134      CONTINUE
           IF( IPRT.GT.3 )THEN
              WRITE(IUNOUT,6004) (IMIX,XSNUF(IMIX,1,IGR),
     >                                 XSCHI(IMIX,1,IGR),IMIX=1,NMAT)
           ENDIF
        ELSE
           IF( NIFIS.NE.1 )THEN
              CALL XABORT('MCU3DL: FOR FIXED SOURCE PROBLEM, NIFIS = 1')
           ENDIF
           XSNUF(0,1,IGR)= ZERO
           CALL LCMGET(IPMACR,'FIXE',XSNUF(1,1,IGR))
        ENDIF
        DO 50 IANI=0,NANIS
          CALL LCMLEN(IPMACR,'NJJD'//CAN(IANI),ILCMLN,ITYLCM)
          DO 39 IMAT= 0, NMAT
            DO 38 JGR= 1, NGRP
              XSCAT(JGR,IMAT,IANI,IGR)= ZERO
   38       CONTINUE
   39     CONTINUE
          IF(ILCMLN.GT.0) THEN
            CALL LCMGET(IPMACR,'NJJD'//CAN(IANI),NJJ)
            CALL LCMGET(IPMACR,'IJJD'//CAN(IANI),IJJ)
            CALL LCMGET(IPMACR,'IPOD'//CAN(IANI),IPOS)
            CALL LCMGET(IPMACR,'SCAD'//CAN(IANI),VSCAT)
            DO 45 IMAT= 1, NMAT
              DO 40 JGR= IJJ(IMAT)-NJJ(IMAT)+1, IJJ(IMAT)
                IXSS= IPOS(IMAT)+IJJ(IMAT)-JGR
                XSCAT(JGR,IMAT,IANI,IGR)= VSCAT(IXSS)
   40         CONTINUE
   45       CONTINUE
          ENDIF
   50   CONTINUE
        CALL LCMSIX(IPMACR,' ',ILCMDN)
 150  CONTINUE
C
      IF( NREG.NE.NREGIO )THEN
         CALL XABORT('MCU3DL: INVALID NUMBER OF REGIONS')
      ENDIF
      IF( ISPEC.NE.0 )THEN
         CALL XABORT('MCU3DL: NON ISOTROPIC TRACKING FILE')
      ENDIF
      NPHI  = NANGL
      NR = NREG
      NS = NSOUT
      NRNL=   (NL+1)**2
C
C     CHECK COMPATIBLITY OF MATCOD
      MATMAX= 0
      DO 20 IS=-NS,NR
         IF( IS.LT.0 )THEN
CMD            IF( I(MATALB+NSOUT+IS).LT.0 )THEN
            IF( MATMRG(IS).LT.0 )THEN
Cwu               ILK = ILK.AND.ALBEDO(-I(MATALB+NSOUT+IS)).EQ.ONE
            ELSE
               CALL XABORT('MCU3DL: IS THIS A PROBLEM?')
            ENDIF
         ELSEIF( IS.GT.0 )THEN
CMD            MATMAX= MAX(MATMAX,I(MATALB+NSOUT+IS))
            MATMAX= MAX(MATMAX,MATMRG(IS))
            IF( MATMRG(IS).NE.MATCOD(IS) )THEN
               WRITE(6,*) 'MATCOD HAS BEEN CHANGED ',
CMD     >                    I(MATALB+NSOUT+IS),'->',MATCOD(IS)
     >                    MATMRG(IS),'->',MATCOD(IS)
CMD               I(MATALB+NSOUT+IS)= MATCOD(IS)
               MATMRG(IS) = MATCOD(IS)
            ENDIF
CMD            IF( ABS(VOL(IS)-A(VOLSUR+NSOUT+IS))/VOL(IS).GT.EPSR )THEN
            IF( ABS(VOL(IS)-VOLMRG(IS))/VOL(IS).GT.EPSR )THEN
               CALL XABORT('MCU3DL: INCOMPATIBLE VOLS')
            ENDIF
         ENDIF
   20 CONTINUE
      IF( ILK )THEN
         WRITE(6,*)' *** NO LEAKAGE IN THE CELL: REBALANCING *ON * ***'
         IF( LEAKSW )THEN
            WRITE(6,*) ' *** INCOMPATIBILITY ON LEAKAGE SWITCH ***'
            CALL XABORT('MCU3DL: ERROR ON LEAKAGE SWITCH')
         ENDIF
      ELSE
         WRITE(6,*)' ***    LEAKAGE IN THE CELL: REBALANCING *OFF* ***'
         IF( .NOT.LEAKSW )THEN
            WRITE(6,*) ' *** INCOMPATIBILITY ON LEAKAGE SWITCH ***'
         ENDIF
      ENDIF
      IF( MATMAX.GT.NMAT )THEN
         CALL XABORT('MCU3DL: NOT ENOUGH MATERIALS ARE DEFINED')
      ENDIF
C
      NUNKNO= NREG+NSOUT+1
      MXSEG= LINMAX
      NR=NREG
      NS=NSOUT
      NSS=-NSOUT
      NRNL=(NL+1)**2
C
      CALL SETARA( RD, NGRP*(NR+7), SIGANG )
      CALL SETARA( RD, NGRP*(NR+7), SANINV )
*
      CALL SETARA( RD, 6*NGRP*(NR+NSOUT+1), FLUX  )
      CALL SETARA( RD, 2*NGRP*NR,        FLUX1 )
      CALL SETARA( RD, 2*NUNKNO*NGRP, FLUXO )
      CALL SETARA( RD, 2*MXSEG*NGRP , EXP2 )
      CALL SETARA( RD, MXSEG , FLM )
      CALL SETARA( RD, MXSEG , FLP )
      CALL SETARA( RD, MXSEG , ICYM )
      CALL SETARA( RD, MXSEG , ICYP )
CMD     CALL SETARA( RD, (NSOUT+NR+1), INVVOL )
      CALL SETARA( RD,   2*NGRP*NR , SOURCE )
      CALL SETARA( RD,   2*NGRP*NR , SOURCO )
      CALL SETARA( ID,      8*NRNL , ISGNR  )
      CALL SETARA( ID,        NRNL , KEYANI )
      CALL SETARA( ID,        NGRP , MASQ   )
      CALL SETARA( ID,        NGRP , CMASQ  )
      CALL SETARA( ID,       MXSEG , VOID   )
      CALL SETARA( ID,       NSOUT , INDSUR )
*----------
      CALL MOCIK3(NDIM, NL, ID(ISGNR), ID(KEYANI) )
*----------
      IF(NDIM.EQ.2) THEN
          NMOD = 4
      ELSE
          NMOD = 1
      ENDIF
      CALL SETARA( RD, NREG*NMOD*NGRP , Q )
      CALL SETARA( RD, NGRP*(NGRP+1) , REBAL )
      CALL SETARA( RD, (NMAT+1)*NIFIS, DA14)
      CALL SETARA( RD, NGRP, FLUC)
      CALL SETARA( RD, NGRP, XCTOT)
      CALL SETARA( RD, NGRP, XCTR)
      CALL SETARA( RD, NGRP, XCS0)
      CALL SETARA( RD, NGRP, XCNUF)
      CALL SETARA( RD, NGRP, XCCHI)
      CALL SETARA( RD, NGRP, XCABS)
      CALL SETARA( RD, NGRP*NGRP*(NANIS+1) , XCCAT)
      CALL SETARA( RD, NGRP, DIFF)
      CALL SETARA( RD, NGRP, DB2)
      CALL SETARA( RD, 2*NGRP*(NGRP+1), DAST)
      CALL SETARA( RD, 2*NGRP*NGRP, DBST)
      CALL SETARA( RD, 2*NGRP, DCST)
      CALL SETARA( RD, (NMAT+1)*NGRP, YTDB2)
      CALL SETARA( RD, (NMAT+1)*NGRP*(NANIS+1), YSDB2)
      CALL SETARA( RD, 2*NGRP, IBETA)
      CALL SETARA( RD, 2*NSOUT*NGRP, CUR)
      CALL SETARA( RD, NSOUT, SURF)
      CALL SETARA( RD, 2*NREG*NGRP,    FACN   )
      CALL SETARA( RD, 2*NSOUT*NGRP,   FCSUR  )
      CALL SETARA( RD, 2*NREG*NGRP,    FACF   )
      CALL SETARA( RD, 2*NREG*NGRP,    FR   )
      CALL SETARA( RD, 2*NSOUT*NGRP,   FS   )
      CALL SETARA( ID, NSOUT,          INDS )
      CALL SETARA( RD, 2*NSOUT,      DSURF  )
      CALL SETARA( RD, 2*NSOUT,      FD  )
      CALL SETARA( RD, 2*NGRP,     FL  )
      CALL SETARA( ID,  LINMAX, NUMERO )
      CALL SETARA( RD,  LINMAX, LENGHT )
      CALL SETARA( RD, NGRP*(NR+NSOUT+1), FLUXW  )

C
      DO 303 NRMV= 1, 2
          CALL MCU2FC( RD(FACN), RD( FACF), RD( EXP2), RD(DSURF),
     +             RD(SURF), RD(FCSUR), ID(INDSUR), ID(NUMERO), 
     +             RD(LENGHT),MATCOD,XSSIGT,XSSIGW,VOL,NGRP,NREG, 
     +             NSOUT, MXSEG, NMAT, LETAB, L2LNG, ID(INDS),   
     +             IPRT,NANGLE, DENUSR,  ANGLES, DENSTY,
     +             NTOTCL, NEXTGE, MAXR, REMESH, LINMAX, RCUTOF,
     +             NSUR,NVOL,INDEL,MINDIM, ISYMM, MAXDIM, ICOORD,
     +             INCR,ICUR, TRKBEG,CONV,TRKDIR, SWVOID, 
     +             NORE, NRMV, VOLTRK, KEYMRG, MAXPTS )
C
         IF( NRMV.EQ.1 )THEN
            CALL XL3NTR( IPRT, NDIM, ISPEC, -NSUR, NVOL, NORE,
     >            VOLSUR, KEYMRG, MATALB, NANGL, VOLTRK, DENSTY )
	         ENDIF
  303 CONTINUE
      CALL RLSARA( ID(INDS) )
      CALL RLSARA( RD(DSURF))
      CALL RLSARA( RD(FS))
      CALL RLSARA( RD(FR))
      CALL RLSARA(RD(LENGHT))
      CALL RLSARA(ID(NUMERO))
C--------------------------------
C
      IF( LINIF ) THEN
         CALL MCIGFL(IPFLUX,ITYPEC,NGRP,NUNKNO,NREG,RD(FLUXW),RD(SURF))
      ENDIF
C
      INVVOL(0)=ZERO
      DO 2001 IS=-NSOUT,-1
         INVVOL(IS)=ONE/VOLMRG(IS)
 2001 CONTINUE
      DO 2002 IR=1,NREG
         INVVOL(IR)=ONE/VOLMRG(IR)
 2002 CONTINUE     
CMD LINMAX
      CALL SETARA( RD,MXSEG, SEGLEN)
      CALL SETARA( ID,MXSEG, NRSEG)
      CALL MCU2DR ( IPFLUX,  NGRP, NREG ,NSOUT, NANIS, NMAT, MXSEG, 
     +              ISYMM, NPHI, NMOD, ID(KEYANI), MATCOD, MATMRG,
     +              VOL, ANGLES,DENSTY,RD(SEGLEN),ID(NRSEG),RD(EXP2),
     +              RD(FLM), RD(FLP), RD(ICYM), RD(ICYP), ID(VOID),
     +              INVVOL, RD(SIGANG), RD(SANINV), ALBEDO,
     +              XSOLD, XSSIGT, XSSIGW, XSCAT, NIFIS, XSNUF,
     +              XSCHI, RD(YTDB2),RD(YSDB2),ITRB,RD(SOURCE), RD(Q),
     +              RD(FLUX), RD(FLUXO), RD(FLUX1), RD(FLUXW), ID(MASQ),
     +              ID(CMASQ), LEAKSW,ILK, ICAC,NINTMX, AIEPS, NEXTMX,
     +              AEEPS, ITYPEC, ILEAK, NL, NBN, RKEFF, RB2,
     +              RD(SOURCO), RD(REBAL), IFRITR, IACITR,
     +              RD(DA14), RD(FLUC), RD(XCTOT), RD(XCTR), RD(XCS0),
     +              RD(XCCAT), RD(XCNUF), RD(XCCHI), RD(XCABS),
     +              RD(DIFF), RD(DB2), RD(IBETA), RD(DAST), RD(DBST),
     +              RD(DCST), RD(CUR), RD(SURF), ITCRMX, ATCRMX,
     +              RD(FACN), RD(FCSUR), RD(FACF), RD(FL), ID(INDSUR),
     +              LJACC, LETAB, L2LNG, MAXSCR, LITLM, IPRT, NANGLE,
     +              DENUSR, NTOTCL, NEXTGE, MAXR, REMESH,
     +              LINMAX, RCUTOF, NSUR, NVOL, INDEL, MINDIM, 
     +              MAXDIM, ICOORD, INCR, ICUR, TRKBEG, CONV,
     +                            TRKDIR, NORE, VOLTRK, KEYMRG,MAXPTS )
C
       CALL RLSARA(RD(SEGLEN))
       CALL RLSARA(ID(NRSEG))
*------------------------------------------------------------------
C
      CALL MCI2WR ( IPFLUX,ITYPEC, RKEFF, RB2,
     >                 NSOUT, NREG, NGRP, RD(FLUXO),RD(FLUXW), RD(DIFF))
*
      CALL RLSARA( RD(SIGANG) )
      CALL RLSARA( RD(SANINV) )
      CALL RLSARA( RD(FLUX)  )
      CALL RLSARA( RD(FLUX1) )
      CALL RLSARA( RD(FLUXO) )
      CALL RLSARA( RD(EXP2) )
      CALL RLSARA( RD(FLM) )
      CALL RLSARA( RD(FLP) )
      CALL RLSARA( RD(ICYM) )
      CALL RLSARA( RD(ICYP) )
CMD      CALL RLSARA( RD(INVVOL) )
      CALL RLSARA( RD(SOURCE) )
      CALL RLSARA( RD(SOURCO) )
      CALL RLSARA( ID(ISGNR)  )
      CALL RLSARA( ID(KEYANI) )
      CALL RLSARA( ID(MASQ)   )
      CALL RLSARA( ID(CMASQ)  )
      CALL RLSARA( ID(VOID) )
      CALL RLSARA( ID(INDSUR) )
      CALL RLSARA( RD( Q) )
      CALL RLSARA( RD(REBAL) )
      CALL RLSARA( RD(DA14) )
      CALL RLSARA( RD(FLUC) )
      CALL RLSARA( RD(XCTOT) )
      CALL RLSARA( RD(XCTR) )
      CALL RLSARA( RD(XCS0) )
      CALL RLSARA( RD(XCNUF) )
      CALL RLSARA( RD(XCCHI) )
      CALL RLSARA( RD(XCABS) )
      CALL RLSARA( RD(XCCAT) )
      CALL RLSARA( RD(DIFF) )
      CALL RLSARA( RD(DB2) )
      CALL RLSARA( RD(DAST) )
      CALL RLSARA( RD(DBST) )
      CALL RLSARA( RD(DCST) )
      CALL RLSARA( RD(YTDB2) )
      CALL RLSARA( RD(YSDB2) )
      CALL RLSARA( RD(IBETA) )
      CALL RLSARA( RD(CUR) )
      CALL RLSARA( RD(SURF) )
      CALL RLSARA( RD(FACN) )
      CALL RLSARA( RD(FCSUR) )
      CALL RLSARA( RD(FACF) )
      CALL RLSARA( RD(FD))
      CALL RLSARA( RD(FL))
      CALL RLSARA( RD(FLUXW))
C
      RETURN
C
C------ FORMATS
C
 5090 FORMAT(31HMCU3DL: INVALID VALUE OF NMAT (,I5,2H).)
 6000 FORMAT(//30X,' EDITION REGION/VOL/MIXTURE '//
     >3(5X,'REGION',5X,'VOL  ',5X,'MIXTURE')/)
 6001 FORMAT(1P,3(5X,I4,4X,E12.5,4X,I4,4X))
 6002 FORMAT(//30X,' G R O U P : ',I5//
     >30X,' TOTAL MACROSCOPIC CROSS SECTIONS PER MIXTURE '/)
 6003 FORMAT(3(1X,'MIXTURE',4X,'TOTAL',11X,'SIGW',3X)/
     >1P,3(1X,I4,3X,E12.5,3X,E12.5))
 6004 FORMAT(3(1X,'MIXTURE',4X,'NUSIGF',11X,'CHI ',3X)/
     >1P,3(1X,I4,3X,E12.5,3X,E12.5))
 6100 FORMAT(//' USE APOLLO TYPE TRANSPORT CORRECTED CROSS-SECTIONS')
 6101 FORMAT(//' USE WIMS TYPE TRANSPORT CORRECTED CROSS-SECTIONS (IT',
     >'RANC=',I4,' )')
 6200 FORMAT(//' COMPUTATION WITH THE CHARACTERISTIC METHOD       ')
C
      END

