*DECK MOC
      SUBROUTINE MOC(NENTRY,HENTRY,IENTRY,JENTRY,KENTRY)
*
*-----------------------------------------------------------------------
*
* COLLISION PROBABILITY ASSEMBLY MODULE.
*
* INPUT/OUTPUT PARAMETERS:
*  NENTRY : NUMBER OF LINKED LISTS OR FILES USED BY THE MODULE.
*  HENTRY : CHARACTER*12 NAME OF EACH LINKED LIST OR FILE.
*  IENTRY : =1 LINKED LIST; =2 XSM FILE; =3 SEQUENTIAL BINARY FILE;
*           =4 SEQUENTIAL ASCII FILE.
*  JENTRY : =0 THE LINKED LIST OR FILE IS CREATED.
*           =1 THE LINKED LIST OR FILE IS OPEN FOR MODIFICATIONS;
*           =2 THE LINKED LIST OR FILE IS OPEN IN READ-ONLY MODE.
*  KENTRY : =FILE UNIT NUMBER; =LINKED LIST ADDRESS OTHERWISE.
*           DIMENSION HENTRY(NENTRY),IENTRY(NENTRY),JENTRY(NENTRY),
*           KENTRY(NENTRY)
*
* LINKED LIST / XSM FILE:
*  HENTRY(1) : CREATE OR MODIFICATION TYPE(L_FLUX).
*  HENTRY(2) : READ-ONLY TYPE(L_MACROLIB OR L_LIBRARY)
*  HENTRY(3) : READ-ONLY LINKED LIST TYPE(L_EXCELL)
*  HENTRY(4) : READ-ONLY SEQUENTIAL BINARY TRACKING FILE.
*
*-------------------------------------- AUTHOR: R. ROY ; 22/01/96 ---
*
      IMPLICIT    NONE
      INTEGER     IOUT,NSTATE
      PARAMETER ( IOUT=6,NSTATE=40)
      INTEGER     NWORDS
C
C***     FOR SINGLE PRECISION ***
      PARAMETER ( NWORDS=1 )
C***     FOR DOUBLE PRECISION ***
C     PARAMETER ( NWORDS=2 )
C
      REAL        EPSX(3),AIEPS,AEEPS
      INTEGER     NENTRY,IENTRY(*),JENTRY(*),KENTRY(*)
      CHARACTER   HENTRY(*)*12,HSIGN*12,TEXT12*12,HSMG*131,
     >            TITRE*72,CDIRFL*12
      CHARACTER*8 CS,    CK,    CB,    CSIGS, CTYPE,
     >            CNOBA, CACCE, CPNL,  CEXEC, CEDIT,
     >            CNBPN, CTHER, CEXTE, CB0,   CB0TR, CB1,   CP1,
     >            CCACA, CCACB, CGAUS, CLMCD, CEXAC, CKEFF
      LOGICAL     LEAKSW,ILK,LEXIN
      INTEGER     LCACA
      INTEGER     KCHAR(18),ISTATE(NSTATE)
      INTEGER     IPFLUX,IPMACR,IPTRK,IFTRAK,ITYLCM,ILNLCM
      INTEGER     NJJ,IFLUXO,IFRITR,ILEAK,IACITR,IREBAL,IJJ,MAXM1,
     >            IPOS,ITYPEC,IGP4,I1,NUN,NREG,IREG,NGRP,ITRB,NL,NBN,
     >            NEXTMX,NINTMX,IPRT,NANIS,MAXMIX,NIFIS,ITRANC,NALB
      INTEGER     MATCOD,KEYFLX,VOL,VOLINV,XSNUF,XSCHI,VSCAT,XSCAT,
     >            XSOLD,XSSIGT,XSSIGW,XTINV,XSTK,DIFFB1,ALBEDO
      DOUBLE PRECISION REFKEF, DONE
      INTEGER     LCACT,NMU,ISYMM,NGSS,NANGL,KTOPT
      PARAMETER ( DONE=1.0D0 )
C
      INTEGER     INDLEC,IDATA
      REAL        ADATA
      CHARACTER*8 CDATA
      DOUBLE PRECISION DDATA
C
      INTEGER     I(1)
      REAL        A
      COMMON      A(1)
      EQUIVALENCE (A(1),I(1))
      REAL        ZERO, ONE
      PARAMETER ( ZERO=0., ONE=1. )
      DATA CS,    CK,    CB,    CSIGS, CTYPE,
     >     CNOBA, CACCE, CPNL,  CEXEC, CEDIT,
     >     CNBPN, CTHER, CEXTE,
     >     CB0,   CB0TR, CB1,   CP1,   CKEFF,
     >     CCACA, CCACB, CGAUS, CLMCD, CEXAC
     >    /'S   ','K   ','B   ','SIGS','TYPE',
     >     'NOBA','ACCE','PNL ',';   ','EDIT',
     >     'NBPN','THER','EXTE',
     >     'B0  ','B0TR','B1  ','P1  ','KEFF',
     >     'CACA','CACB','GAUS','LMCD','EXAC'/
*
* PARAMETER VALIDATION.
      IF(NENTRY.LE.2) CALL XABORT('MOC: THREE PARAMETERS EXPECTED.')
      IF((IENTRY(1).NE.1).AND.(IENTRY(1).NE.2)) CALL XABORT('MOC: LI'
     1 //'NKED LIST OR XSM FILE EXPECTED AT LHS.')
      IF((JENTRY(1).NE.0).AND.(JENTRY(1).NE.1)) CALL XABORT('MOC: EN'
     1 //'TRY IN CREATE OR MODIFICATION MODE EXPECTED.')
      IF((JENTRY(2).NE.2).OR.((IENTRY(2).NE.1).AND.(IENTRY(2).NE.2)))
     1 CALL XABORT('MOC: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT FIRST RHS.')
      IF((JENTRY(3).NE.2).OR.((IENTRY(3).NE.1).AND.(IENTRY(3).NE.2)))
     1 CALL XABORT('MOC: LINKED LIST OR XSM FILE IN READ-ONLY MODE E'
     2 //'XPECTED AT SECOND RHS.')
      CALL LCMGET(KENTRY(3),'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF(HSIGN.NE.'L_TRACK') THEN
         TEXT12=HENTRY(3)
         CALL XABORT('MOC: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_TRACK EXPECTED.')
      ENDIF
      IPFLUX= KENTRY(1)
      IF(JENTRY(1).EQ.1) THEN
         CALL LCMGET(IPFLUX,'SIGNATURE',KCHAR)
         WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         IF(HSIGN.NE.'L_FLUX') THEN
            TEXT12=HENTRY(1)
            CALL XABORT('MOC: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1      '. L_FLUX EXPECTED.')
         ENDIF
      ELSE
         HSIGN='L_FLUX'
         READ(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
         CALL LCMPUT(IPFLUX,'SIGNATURE',3,3,KCHAR)
      ENDIF
      IPMACR= KENTRY(2)
      IPTRK=  KENTRY(3)
      CDIRFL='FLUXDIRECT  '
*
* RECOVER TRACKING FILE INFORMATION.
      IF((IENTRY(4).NE.3).OR.(JENTRY(4).NE.2)) CALL XABORT(
     1   'MOC: INCONSISTENT BINARY TRACKING ASCII FILE NAMED '//
     2   TEXT12//'.')
      IFTRAK=KENTRY(4)
*
* RECOVER GENERAL TRACKING INFORMATION.
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPTRK,'STATE-VECTOR',ISTATE)
      NREG=   ISTATE(1)
      NUN=    ISTATE(2)
      LEAKSW= ISTATE(3).EQ.0
      IGP4=   ISTATE(4)
      KTOPT=  ISTATE(9)
      NANGL=  ISTATE(11)
      ISYMM=  ISTATE(12)
      LCACT=  ISTATE(13)
      NMU  =  ISTATE(14)
C
C     # OF ALBEDOS PERMITTED
      NALB=   6
      CALL SETARA( I, NREG, MATCOD )
      CALL SETARA( A, NREG, VOL    )
      CALL SETARA( A, NREG, VOLINV )
      CALL SETARA( I, NREG, KEYFLX )
      CALL SETARA( A, NALB, ALBEDO )
      CALL LCMLEN(IPTRK,'MATCOD',ILNLCM,ITYLCM)
      IF( ILNLCM.NE.NREG )THEN
         CALL XABORT( 'MOC: INCOMPATIBLE NUMBER OF REGIONS')
      ENDIF
      CALL LCMGET(IPTRK,'MATCOD',I(MATCOD))
      CALL LCMGET(IPTRK,'VOLUME',A(VOL))
      DO 1000 IREG=1,NREG
         A(VOLINV+IREG-1)= ONE/A(VOL+IREG-1)
 1000 CONTINUE
      CALL LCMGET(IPTRK,'KEYFLX',I(KEYFLX))
      CALL LCMLEN(IPTRK,'ALBEDO',ILNLCM,ITYLCM)
      IF( ILNLCM.NE.NALB )THEN
         CALL XABORT( 'MOC: INCOMPATIBLE NUMBER OF ALBEDOS')
      ENDIF
      CALL LCMGET(IPTRK,'ALBEDO',A(ALBEDO))
      CALL LCMLEN(IPTRK,'TITLE',ILNLCM,ITYLCM)
      IF( ILNLCM.GT.0 )THEN
         CALL LCMGET(IPTRK,'TITLE',KCHAR)
         WRITE(TITRE,'(18A4)') (KCHAR(I1),I1=1,18)
      ELSE
         TITRE='*** NO TITLE PROVIDED ***'
      ENDIF
*
* RECOVER MACROLIB PARAMETERS.
      CALL LCMGET(IPMACR,'SIGNATURE',KCHAR)
      WRITE(HSIGN,'(3A4)') (KCHAR(I1),I1=1,3)
      IF(HSIGN.EQ.'L_LIBRARY') THEN
         CALL LCMSIX(IPMACR,'MACROLIB',1)
      ELSE IF(HSIGN.NE.'L_MACROLIB') THEN
         TEXT12=HENTRY(2)
         CALL XABORT('MOC: SIGNATURE OF '//TEXT12//' IS '//HSIGN//
     1   '. L_MACROLIB EXPECTED.')
      ENDIF
      CALL XDISET(ISTATE,NSTATE,0)
      CALL LCMGET(IPMACR,'STATE-VECTOR',ISTATE)
      NGRP=   ISTATE(1)
      MAXMIX= ISTATE(2)
      NANIS=  ISTATE(3)-1
      NIFIS=  MAX(ISTATE(4),1)
      ITRANC= ISTATE(6)
      IF(IGP4.GT.MAXMIX) THEN
         WRITE(HSMG,'(45HMOC: THE NUMBER OF MIXTURES IN THE TRACKING (,
     1   I5,55H) IS GREATER THAN THE NUMBER OF MIXTURES IN THE MACROLI,
     2   3HB (,I5,2H).)') IGP4,MAXMIX
         CALL XABORT(HSMG)
      ENDIF
*
*     RECOVER FLUX INFORMATION IF ANY, OR IMPOSE DEFAULT VALUES IF NOT.
      IPRT= 1
      ITRB= 0
      NL=  -1
      NBN= -1
      IF( JENTRY(1).EQ.1 )THEN
         CALL LCMLEN(IPFLUX,'STATE-VECTOR',ILNLCM,ITYLCM)
         IF( ILNLCM.EQ.0.OR.ITYLCM.NE.1 )THEN
            CALL XABORT('MOC: INVALID FPARAM RECORD ON FLUX')
         ENDIF
         CALL XDISET(ISTATE,NSTATE,0)
         CALL LCMGET(IPFLUX,'STATE-VECTOR',ISTATE)
         ITYPEC= ISTATE(1)
         ILEAK=  ISTATE(2)
         IFRITR= ISTATE(3)
         IACITR= ISTATE(4)
         IREBAL= ISTATE(5)
         CALL LCMGET(IPFLUX,'EPS-CONVERGE',EPSX)
         AIEPS=EPSX(1)
         AEEPS=EPSX(2)
      ELSE
         ITYPEC= -99
         ILEAK=  0
         IFRITR= 3
         IACITR= 3
         IREBAL= 1       	
      ENDIF
      ILK= IREBAL.EQ.1
*
*     READ USER COMMANDS
      CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      IF( CDATA(1:4).EQ.CEDIT(1:4) )THEN
         CALL REDGET ( INDLEC, IPRT, ADATA, CDATA, DDATA)
         IF( INDLEC.NE.1 )CALL XABORT( 'MOC: IPRT HAS TO BE READ')
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ENDIF
      IF( CDATA(1:4).EQ.CEXAC(1:4) )THEN
         CALL REDGET ( INDLEC, IPRT, ADATA, CDATA, DDATA)
         LEXIN=.TRUE.
      ELSE
         LEXIN=.FALSE.
      ENDIF
*     CHOSE POLAR ANGLES
      IF( CDATA(1:4).EQ.CGAUS(1:4) )THEN
         LCACA= 0
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ELSEIF( CDATA(1:4).EQ.CCACA(1:4) )THEN
         LCACA= 1
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ELSEIF( CDATA(1:4).EQ.CCACB(1:4) )THEN
         LCACA= 2
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ELSEIF( CDATA(1:4).EQ.CLMCD(1:4) )THEN
         LCACA= 3
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ELSE
*----
*   Default is that provided on the tracking data structure
*----
         LCACA=-1
      ENDIF
      IF(LCACA .EQ. -1) THEN
        NGSS= NMU
        LCACA=LCACT
      ELSE
        NGSS=(NANGL+1)/2
        IF(KTOPT .EQ. 0) THEN 
          IF(ISYMM .GT. 1) THEN
            NGSS=NANGL
          ENDIF
        ENDIF
        IF(LCACA .EQ. 3 ) NGSS= 2
      ENDIF
*
      IF( CDATA(1:4).EQ.CTYPE(1:4) )THEN
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         IF( CDATA(1:4).EQ.CS(1:4) )THEN
            ITYPEC= 6
         ELSEIF( CDATA(1:4).EQ.CK(1:4) )THEN
            ITYPEC= 1
         ELSEIF( CDATA(1:4).EQ.CB(1:4) )THEN
            ITYPEC= 4
         ELSE
            CALL XABORT( 'MOC: TYPE *S*, *K* OR *B* HAS TO BE READ')
         ENDIF
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ENDIF
      IF( ITYPEC.EQ.-99 )THEN
         CALL XABORT( 'MOC: TYPE *S*, *K* OR *B* HAS TO BE READ')
      ENDIF
      REFKEF= DONE
*
      IF(ITYPEC .EQ. 6 .OR. ITYPEC .EQ. 1) THEN
         NL= 0
         IF( CDATA(1:4).EQ.CP1(1:4) )THEN
            NL= 1
            IF( NL.GT.NANIS )THEN
               CALL XABORT('MOC: ILLEGAL OPTION = *P1* '//
     >          ' WITHOUT P1 SCATTERING CROSS SECTIONS')
            ENDIF
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ENDIF
      ELSEIF(ITYPEC .EQ. 4)THEN
         IF( CDATA(1:4).EQ.CB0(1:4) )THEN
           IF( ITRANC.NE.0 )THEN
              CALL XABORT('MOC: ILLEGAL OPTION = *B0* '//
     >         ' WITH TRANSPORT CORRECTED CROSS SECTIONS')
           ENDIF
           NBN= 0
           NL= 0
           CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ELSEIF( CDATA(1:4).EQ.CB0TR(1:4) )THEN
           IF( ITRANC.EQ.0 )THEN
              CALL XABORT('MOC: ILLEGAL OPTION = *B0TR* '//
     >         ' WITHOUT TRANSPORT CORRECTED CROSS SECTIONS')
           ENDIF
           NBN= 0
           NL= 0
           ITRB= 1
           CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ELSEIF( CDATA(1:4).EQ.CB1(1:4) )THEN
           NBN= 1
C           NL= 1
           NL= 0
           IF( NL.GT.NANIS )THEN
              CALL XABORT('MOC: ILLEGAL OPTION = *B1* '//
     >         ' WITHOUT P1 SCATTERING CROSS SECTIONS')
           ENDIF
           CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ENDIF
         ILEAK= 2
         IF( CDATA(1:4).EQ.CSIGS(1:4) )THEN
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
            ILEAK= 3
         ELSEIF( CDATA(1:4).EQ.CPNL(1:4) )THEN
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
            ILEAK= 2
         ENDIF
         IF( CDATA(1:4).EQ.CKEFF(1:4) )THEN
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
            IF( INDLEC.NE.2 ) CALL XABORT('MOC: KEFF MUST BE REAL')
            REFKEF= DBLE(ADATA)
            CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ENDIF
      ENDIF
      IF( CDATA(1:4).EQ.CNBPN(1:4) )THEN
         CALL REDGET ( INDLEC, NL, ADATA, CDATA, DDATA)
         IF( INDLEC.NE.1 )CALL XABORT( 'MOC: NBPN  HAS TO BE READ')
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         IF( NL.GT.NANIS )THEN
            CALL XABORT('MOC: ANISOTROPY ORDER GREATER THAN MIXTURES')
         ELSEIF( NL.LT.0 )THEN
            CALL XABORT('MOC: ANISOTROPY ORDER LESS THAN 0')
         ENDIF
      ENDIF
      IF(NL.EQ.-1) NL= NANIS
      IF(NL.NE.0) CALL XABORT('MOC: ANISOTROPY *N/A* YET')
      IF( CDATA(1:4).EQ.CNOBA(1:4) )THEN
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
         ILK= .FALSE.
      ENDIF
*
      IF( CDATA(1:4).EQ.CACCE(1:4) )THEN
         CALL REDGET ( INDLEC, IFRITR, ADATA, CDATA, DDATA)
         CALL REDGET ( INDLEC, IACITR, ADATA, CDATA, DDATA)
         CALL REDGET ( INDLEC, IDATA,  ADATA, CDATA, DDATA)
      ENDIF
      IF( CDATA(1:4).EQ.CTHER(1:4) )THEN
         CALL REDGET ( INDLEC, NINTMX, AIEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MOC: NINT OR EPS INTERNAL HAS TO BE READ')
         CALL REDGET ( INDLEC, NINTMX, AIEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MOC: NINT OR EPS INTERNAL HAS TO BE READ')
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ELSE
         AIEPS = 5.0E-05
         IF( ITYPEC .EQ. 6 )THEN
            NINTMX= 2*NREG + 1
         ELSE
            NINTMX= 4*NGRP
         ENDIF
      ENDIF
      IF( CDATA(1:4).EQ.CEXTE(1:4) )THEN
         CALL REDGET ( INDLEC, NEXTMX,  AEEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MOC: NEXT OR EPS EXTERNAL HAS TO BE READ')
         CALL REDGET ( INDLEC, NEXTMX,  AEEPS, CDATA, DDATA)
         IF( INDLEC.NE.2.AND.INDLEC.NE.1 )
     >      CALL XABORT( 'MOC: NEXT OR EPS EXTERNAL HAS TO BE READ')
         CALL REDGET ( INDLEC, IDATA, ADATA, CDATA, DDATA)
      ELSE
         AEEPS = 1.0E-05
         IF( ITYPEC .EQ. 6 )THEN
            NEXTMX= 2
         ELSE
            NEXTMX= 2*NREG + 1
         ENDIF
      ENDIF
      IF( CDATA(1:4).NE.CEXEC(1:4) )THEN
         CALL XABORT( 'MOC: *;* HAS TO BE READ')
      ENDIF
      CALL SETARA( A ,NUN*NGRP*NWORDS, IFLUXO )
      IF( JENTRY(1) .EQ. 0 )THEN
        CALL LCMSIX(IPFLUX,CDIRFL,1)
        CALL MOCGFL(IPFLUX,ITYPEC,NGRP,NUN,A(IFLUXO))
        CALL LCMSIX(IPFLUX,CDIRFL,2)
      ENDIF
*
      CALL SETARA( I, MAXMIX, NJJ    )
      CALL SETARA( I, MAXMIX, IJJ    )
      CALL SETARA( I, MAXMIX, IPOS   )
      MAXM1= MAXMIX+1
      CALL SETARA( A, NGRP*MAXM1, XSOLD  )
      CALL SETARA( A, NGRP*MAXM1, XSSIGT )
      CALL SETARA( A, NGRP*MAXM1, XTINV  )
      CALL SETARA( A, NGRP*MAXM1, XSSIGW )
      CALL SETARA( A, MAXM1*NGRP*NIFIS, XSCHI )
      CALL SETARA( A, MAXM1*NGRP*NIFIS, XSNUF )
      CALL SETARA( A, MAXMIX*NIFIS, XSTK  )
      CALL SETARA( A, MAXM1*NGRP*NGRP*(NANIS+1), XSCAT  )
      CALL SETARA( A, MAXMIX*NGRP*NGRP, VSCAT  )
      CALL SETARA( A, NGRP, DIFFB1 )
      CALL MOCDRV(IPFLUX,IPTRK,IPMACR,IFTRAK,NGRP,MAXMIX,NIFIS,NANIS,
     1 NL,NBN,NUN,A(IFLUXO),A(DIFFB1),
     2 NINTMX,AIEPS,NEXTMX,AEEPS,IFRITR,IACITR,ITYPEC,ILEAK,
     3 NREG,I(MATCOD),A(VOL),A(VOLINV),
     4 A(XSOLD),A(XSSIGT),A(XTINV),A(XSSIGW),
     5 A(XSCHI),A(XSNUF),A(XSTK),
     6 I(NJJ),I(IJJ),I(IPOS),A(XSCAT),A(VSCAT),
     7 NALB,A(ALBEDO),LEAKSW,ILK,ITRANC,ITRB,TITRE,LCACA,NGSS,LEXIN,
     8 REFKEF,IPRT,CDIRFL)
      CALL RLSARA( A(DIFFB1) )
      CALL RLSARA( A(VSCAT ) )
      CALL RLSARA( A(XSCAT ) )
      CALL RLSARA( A(XSTK  ) )
      CALL RLSARA( A(XSNUF ) )
      CALL RLSARA( A(XSCHI ) )
      CALL RLSARA( A(XSSIGW) )
      CALL RLSARA( A(XTINV ) )
      CALL RLSARA( A(XSSIGT) )
      CALL RLSARA( A(XSOLD ) )
      CALL RLSARA( I(IPOS  ) )
      CALL RLSARA( I(IJJ   ) )
      CALL RLSARA( I(NJJ   ) )
      CALL RLSARA( A(IFLUXO) )
*
      CALL XDISET(ISTATE,NSTATE,0)
      ISTATE(1)= ITYPEC
      ISTATE(2)= ILEAK
      ISTATE(3)= IFRITR
      ISTATE(4)= IACITR
      IF( ILK )THEN
         ISTATE(5)= 1
      ELSE
         ISTATE(5)= 0
      ENDIF
      ISTATE(6)=NINTMX
      ISTATE(7)=NEXTMX
      ISTATE(9)=NGRP
      ISTATE(10)=NUN
      CALL LCMPUT(IPFLUX,'STATE-VECTOR',NSTATE,1,ISTATE)
      EPSX(1)=AIEPS
      EPSX(2)=AEEPS
      EPSX(3)=AEEPS
      CALL LCMPUT(IPFLUX,'EPS-CONVERGE',3,2,EPSX)
*
      IF(IPRT.GE.3) CALL LCMLIB(IPFLUX)
*
* RELEASE GENERAL TRACKING INFORMATION.
      CALL RLSARA( A(ALBEDO) )
      CALL RLSARA( I(KEYFLX) )
      CALL RLSARA( A(VOLINV) )
      CALL RLSARA( A(VOL   ) )
      CALL RLSARA( I(MATCOD) )
      CALL LCMSIX( IPMACR, ' ', 0)
      CALL LCMSIX( IPTRK,  ' ', 0)
      RETURN
      END
