*DECK PERABS
      SUBROUTINE PERABS(NBMIX ,NGROUP,NANISO,XSTOT,XSSCA,XSABS)
C
C---------------------------  PERABS  ---------------------------------
C
C   1- PROGRAMME STATISTICS:
C       NAME     : PERABS
C       USE      : ABSORPTION ROSS SECTIONS INITIALIZATION
C       MODIFIED : 2003-09-28 
C       AUTHOR   : G.MARLEAU
C
C   2- ROUTINE PARAMETERS:
C    INPUT
C       NBMIX    : MAXIMUM NUMBER OF MIXTURES         I
C       NGROUP   : NUMBER OF ENERGY GROUPS            I
C       NANISO   : MAXIMUM LEGENDRE ORDER             I
C                  = 1 ISOTROPIC COLLISION
C                  = 2 LINEARLY ANISOTROPIC COLLISION
C       XSTOT    : TOTAL CROSS SECTION OF MIXTURE     R(NBMIX,NGROUP)
C       XSSCA    : SCATT X-SECTION OF MIXTURE/GROUP   R(NBMIX,NANISO,
C                                                      NGROUP,NGROUP)
C       XSABS    : ABS CROSS SECTION OF MIXTURE       R(NBMIX,NGROUP)
C
C---------------------------   PERABS  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NAMSBR='PERABS')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     NBMIX,NGROUP,NANISO
      REAL        XSTOT(NBMIX,NGROUP)
      REAL        XSSCA(NGROUP,NBMIX,NANISO,NGROUP)
      REAL        XSABS(NBMIX,NGROUP)
      DOUBLE PRECISION SUMSC
C----
C  LOCAL PARAMETERS
C----
      INTEGER     IGR,JGR,IMIX
C----
C  READ/INITIALIZE MACROLIB CROSS SECTION DATA
C----
      CALL XDRSET(XSABS,NBMIX*NGROUP,0.0)
      DO 100 IGR=1,NGROUP
        DO 110 IMIX=1,NBMIX
          SUMSC=0.0D0
          DO 120 JGR=1,NGROUP
            SUMSC=SUMSC+DBLE(XSSCA(IGR,IMIX,1,JGR))
 120      CONTINUE
          XSABS(IMIX,IGR)=XSTOT(IMIX,IGR)-SUMSC
 110    CONTINUE
 100  CONTINUE
      RETURN
      END
