*DECK PIJCMP
      SUBROUTINE PIJCMP(NREG,NSOUT,NCOR,DPR,PROB)
C
C-------------------------    PIJCMP    -------------------------------
C
C 1- SUBROUTINE STATISTICS:
C     NAME     : PIJCMP
C     LEVEL    : 2 (CALLED BY 'EXCELP')
C     USE      : COMPRESSION OF PIJ MATRICES IN SYMMETRIC FORMAT
C     AUTHOR   : R. ROY (94-05-03)
C
C 2- PARAMETERS:
C  INPUT
C     NREG    : TOTAL NUMBER OF REGIONS                I
C     NSOUT   : NUMBER OF OUTER SURFACE                I
C     NCOR    : MAXIMUM NUMBER OF CORNERS              I
C     DPR     : COLLISION PROBABILITIES      D(-NSOUT:NREG,-NSOUT:NREG)
C
C  OUTPUT
C     PROB    : COMPRESS PROBABILITY MATRIX            R(NPLEN)
C               NPLEN=(NREG+NSOUT+2)*(NREG+NSOUT+1)/2
C               IND(I,J)=MAX(I+NSOUT+1,J+NSOUT+1)
C                       *(MAX(I+NSOUT+1,J+NSOUT+1)-1)/2
C                       +MIN(I+NSOUT+1,J+NSOUT+1)
C         IS=-NSOUT,-1; JS=-NSOUT,IS; I=IND(IS,JS)
C           PROB(I)=VOLSUR(IS)*PSS(IS,JS)
C         IV=1,NREG; JS=-NSOUT,-1;    I=IND(IV,JS)
C           SIGT(IV).GT.0.0
C             PROB(I)=SIGT(IV)*VOLSUR(IV)*PVS(IV,JS)
C           SIGT(IV).EQ.0.0
C             PROB(I)=VOLSUR(IV)*PVS(IV,JS)
C         IV=1,NREG; JV=1,IV;       I=IND(IV,JV)
C           SIGT(IV).GT.0.0 AND SIGT(JV).GT.0.0
C             PROB(I)=SIGT(IV)*SIGT(JV)*VOLSUR(IV)*PVV(IV,JV)
C           SIGT(IV).GT.0.0 AND SIGT(JV).EQ.0.0
C             PROB(I)=SIGT(IV)*VOLSUR(IV)*PVV(IV,JV)
C           SIGT(IV).EQ.0.0 AND SIGT(JV).GT.0.0
C             PROB(I)=SIGT(JV)*VOLSUR(IV)*PVV(IV,JV)
C           SIGT(IV).EQ.0.0 AND SIGT(JV).EQ.0.0
C             PROB(I)=VOLSUR(IV)*PVV(IV,JV)
C
C-------------------------    PIJCMP    -------------------------------
C
      IMPLICIT NONE
C----
C VARIABLES
C----
      INTEGER          NREG,NSOUT,NCOR,IPR,IL,JL
      REAL             PROB(*)
      DOUBLE PRECISION DPR(-NSOUT:NREG,-NSOUT:NREG),ZCOR,ZCOR1
C----
C  SYMMETRIZE AND STORE IN PROB
C----
      IF( NCOR.EQ.1 )THEN
         IPR= 0
         DO  250 IL    = -NSOUT, NREG
            DO  260 JL = -NSOUT, IL
               IPR= IPR+1
               PROB(IPR)= DPR(IL,JL) + DPR(JL,IL)
  260       CONTINUE
  250    CONTINUE
      ELSE
         IPR= 0
         ZCOR1= 1.0D0/DBLE(NCOR)
         ZCOR=  1.0D0/DBLE(NCOR*NCOR)
         DO  251 IL    = -NSOUT, NREG
            IF( IL.GT.0 ) ZCOR= ZCOR1
            DO  261 JL = -NSOUT, IL
               IPR= IPR+1
               IF( JL.GT.0 ) ZCOR= 1.0D0
               PROB(IPR)= ZCOR * ( DPR(IL,JL) + DPR(JL,IL) )
  261       CONTINUE
  251    CONTINUE
      ENDIF
C
      RETURN
      END
