*DECK PIJNRM
      SUBROUTINE PIJNRM(NREGIO,MATCOD,VOLUME,XSSIGT,PIJSYM,PIS)
C
C---------------------------  PIJNRM  ---------------------------------
C
C   1-  PROGRAMME STATISTICS:
C
C          NAME       :  PIJNRM
C          FUNCTION   :  NORMALISATION OF THE CP MATRIX TO FORCE
C                        NEUTRON CONSERVATION (NO LEAKAGE).
C          DATE       :  17-10-1988
C          AUTHOR     :  A.HEBERT
C
C   2-  INPUT / OUTPUT PARAMETERS:
C
C         NREGIO  : NUMBER OF REGIONS CONSIDERED       I            I
C         MATCOD  : MATERIAL CODE IN REGION            I(NREGIO)    I
C         VOLUME  : VOLUME OF REGION                   R(NREGIO)    I
C         XSSIGT  : TOTAL MACROSCOPIC X.S.             R(NBMIX)     D
C                   WHERE NBMIX IS THE TOTAL NUMBER OF MIXTURES.
C         PIJSYM  : GROUP CONDENSED REDUCE/SYMMETRIC   R(NREGIO*
C                   PIJ MATRIX                        (NREGIO+1)/2  D
C         PIS     : SCRATCH STORAGE.                  R(NREGIO)
C
C---------------------------   PIJNRM  --------------------------------
C
      IMPLICIT NONE
C-----
C INTERNAL FUNCTIO
C-----
      INTEGER    INDPOS
C----
C VARIABLES
C----
      INTEGER    I,J,MATNUM,INDPIJ,NREGIO,MATCOD(*)
      REAL       VOLUME(*),XSSIGT(*),PIJSYM(*),PIS(*)
      DOUBLE PRECISION SUM,DD
C
C----- INTRINSIC FUNCTION FOR POSITION IN CONDENSE PIJ MATRIX
C
      INDPOS(I,J)=MAX(I,J)*(MAX(I,J)-1)/2+MIN(I,J)
C
      DD=0.0D0
      DO 20 I=1,NREGIO
      SUM=0.0D0
      DO 10 J=1,NREGIO
      MATNUM=MATCOD(J)
      IF(MATNUM.GT.0) THEN
         SUM=SUM+XSSIGT(MATNUM)*PIJSYM(INDPOS(I,J))/VOLUME(I)
      ENDIF
   10 CONTINUE
      PIS(I)=1.0D0-SUM
      MATNUM=MATCOD(I)
      IF(MATNUM.GT.0) THEN
         DD=DD+XSSIGT(MATNUM)*VOLUME(I)*PIS(I)
      ENDIF
   20 CONTINUE
      IF(DD.NE.0.0D0) THEN
        DO 30 I=1,NREGIO
        DO 30 J=1,I
          INDPIJ=INDPOS(I,J)
          PIJSYM(INDPIJ)=PIJSYM(INDPIJ)
     >                  +PIS(I)*PIS(J)*VOLUME(I)*VOLUME(J)/DD
 30     CONTINUE
      ENDIF
      RETURN
      END
