*DECK QIJCPL
      SUBROUTINE QIJCPL(NREG  ,NSOUT ,NELPIJ,NGRP  ,MATCOD,VOLUME,
     >                  SIGINV,PIJSYM,PIS   ,DD    )
C
C---------------------------  QIJCPL  ---------------------------------
C
C   1-  PROGRAMME STATISTICS:
C
C          NAME       :  QIJCPL
C          FUNCTION   :  COMPUTATION OF CP LEAKAGE MATRIX
C          DATE       :  2000/01/21
C          AUTHOR     :  G. MARLEAU
C
C   2-  PARAMETERS:
C       INPUT
C         NREG    : NUMBER OF REGIONS CONSIDERED       I
C         NSOUT   : NUMBER OF SURFACES CONSIDERED      I
C         NGRP    : NUMBER OF GROUPS CONSIDERED        I
C         NELPIJ  : NUMBER OF ELEMENTS IN PIJ MATRIX   I
C         MATCOD  : MATERIAL CODE IN REGION            I(NREG)
C         VOLUME  : VOLUME OF REGION                   R(NREG)
C         SIGINV  : INVERSE OF TOTAL MACROSCOPIC X.S.  R(NGRP,NREG)
C         PIJSYM  : GROUP CONDENSED REDUCE/SYMMETRIC   D(NGRP,NELPIJ)
C       OUTPUT
C         PIS     : SCRATCH STORAGE.                   D(NGRP,NREG)
C       WORK
C         DD      : SCRATCH STORAGE.                   D(NGRP)
C
C---------------------------   QIJCPL  --------------------------------
C
      IMPLICIT NONE
C----
C INTERNAL FUNCTION
C----
      INTEGER          INDPOS
C----
C VARIABLES
C----
      INTEGER          NREG,NSOUT,NELPIJ,NGRP,I,J,IG
      INTEGER          MATCOD(NREG)
      REAL             DD(NGRP)
      REAL             VOLUME(NREG),SIGINV(NGRP,NREG)
      DOUBLE PRECISION PIJSYM(NGRP,NELPIJ),PIS(NGRP,NREG)
C
C----- INTRINSIC FUNCTION FOR POSITION IN CONDENSE PIJ MATRIX
C
      INDPOS(I,J)=(MAX(I-NSOUT+1,J-NSOUT+1)*
     >            (MAX(I-NSOUT+1,J-NSOUT+1)-1))/2
     >            +MIN(I-NSOUT+1,J-NSOUT+1)
C
      DO 100 I=1,NREG
        DO 110 IG=1, NGRP
          PIS(IG,I)=0.0D0
 110    CONTINUE
        DO 120 J=1,NREG
          IF( MATCOD(J).GT.0 )THEN
            DO 121 IG=1, NGRP
              PIS(IG,I)= PIS(IG,I)+PIJSYM(IG,INDPOS(I,J))
 121        CONTINUE
          ENDIF
 120    CONTINUE
        DO 130 IG=1, NGRP
          PIS(IG,I)=PIJSYM(IG,INDPOS(I,0))-PIS(IG,I)
 130    CONTINUE
 100  CONTINUE
      RETURN
      END
