*DECK QIJNRM
      SUBROUTINE QIJNRM(NREG,NSOUT,NGRP,MATCOD,VOLUME,
     >                  SIGINV,PIJSYM,PIS,DD)
C
C---------------------------  QIJNRM  ---------------------------------
C
C   1-  PROGRAMME STATISTICS:
C
C          NAME       :  QIJNRM
C          FUNCTION   :  NORMALISATION OF THE CP MATRIX TO FORCE
C                        NEUTRON CONSERVATION (NO LEAKAGE).
C          DATE       :  25-09-1996
C          AUTHOR     :  R.ROY (INSPIRED BY A.HEBERT *XDRNRM*)
C
C   2-  INPUT / OUTPUT PARAMETERS:
C
C         NREG    : NUMBER OF REGIONS CONSIDERED       I
C         NSOUT   : NUMBER OF SURFACES CONSIDERED      I
C         NGRP    : NUMBER OF GROUPS CONSIDERED        I
C         MATCOD  : MATERIAL CODE IN REGION            I(NREG)
C         VOLUME  : VOLUME OF REGION                   R(NREG)
C         SIGINV  : INVERSE OF TOTAL MACROSCOPIC X.S.  R(NGRP,NREG)
C         PIJSYM  : GROUP CONDENSED REDUCE/SYMMETRIC   D(NGRP,
C                                                      (NREG-NSOUT+1)
C                   PIJ MATRIX                        *(NREG-NSOUT+2)/2)
C         PIS     : SCRATCH STORAGE.                   D(NGRP,NREG)
C         DD      : SCRATCH STORAGE.                   D(NGRP)
C
C---------------------------   QIJNRM  --------------------------------
C
      IMPLICIT NONE
C----
C INTERNAL FUNCTIONS
C----
      INTEGER    INDPOS
C----
C VARIABLES
C----
      INTEGER    NREG,NGRP,I,IG,J,NSOUT,INDPIJ
      REAL       VOLUME(*),SIGINV(NGRP,*),MATCOD(*)
      DOUBLE PRECISION DD(*),PIJSYM(NGRP,*),PIS(NGRP,*)
C
C----- INTRINSIC FUNCTION FOR POSITION IN CONDENSE PIJ MATRIX
C
      INDPOS(I,J)=(MAX(I-NSOUT+1,J-NSOUT+1)*
     >            (MAX(I-NSOUT+1,J-NSOUT+1)-1))/2
     >            +MIN(I-NSOUT+1,J-NSOUT+1)
C
      DO 1 IG=1, NGRP
        DD(IG)=0.0D0
    1 CONTINUE
      DO 20 I=1,NREG
        DO 5 IG=1, NGRP
           PIS(IG,I)=0.0D0
    5   CONTINUE
        DO 10 J=1,NREG
          IF( MATCOD(J).GT.0 )THEN
            DO 6 IG=1, NGRP
              PIS(IG,I)= PIS(IG,I)+PIJSYM(IG,INDPOS(I,J))
    6       CONTINUE
          ENDIF
   10   CONTINUE
        DO 7 IG=1, NGRP
          PIS(IG,I)=PIJSYM(IG,INDPOS(I,0))-PIS(IG,I)
    7   CONTINUE
        IF( MATCOD(I).GT.0 )THEN
          DO 8 IG=1, NGRP
            DD(IG)=DD(IG)+PIS(IG,I)
    8     CONTINUE
        ENDIF
   20 CONTINUE
      DO 9 IG=1, NGRP
        IF(DD(IG).NE.0.0D0) THEN
          DO 30 I=1,NREG
          DO 30 J=1,I
            INDPIJ=INDPOS(I,J)
            PIJSYM(IG,INDPIJ)= PIJSYM(IG,INDPIJ)+PIS(IG,I)*PIS(IG,J)
     >                         /DD(IG)
   30     CONTINUE
        ENDIF
    9 CONTINUE
      RETURN
      END
