*DECK SYBPRX
      SUBROUTINE SYBPRX (NCOUR,IPAS,IKG,SIGT,P,PIS,PSS)
*
*-----------------------------------------------------------------------
*
* PRINT THE CELL-WISE COLLISION PROBABILITIES IN SYBRX- MODULES.
*
* INPUT PARAMETERS:
*   NCOUR : TOTAL NUMBER OF SURFACES.
*   IPAS  : TOTAL NUMBER OF VOLUMES.
*   IKG   : GENERATING CELL NUMBER.
*   SIGT  : TOTAL MACROSCOPIC CROSS SECTIONS. DIMENSION SIGT(IPAS)
*   P     : REDUCED COLLISION PROBABILITIES. DIMENSION P(IPAS,IPAS)
*   PIS   : VOLUME TO SURFACE PROBABILITIES. DIMENSION PIS(NCOUR,IPAS)
*   PSS   : SURFACE TO SURFACE PROBABILITIES. DIMENSION PSS(NCOUR,NCOUR)
*
*-----------------------------------------------------------------------
*
      DIMENSION SIGT(*),P(IPAS,*),PIS(NCOUR,*),PSS(NCOUR,*)
*
      WRITE (6,100) IKG
      WRITE (6,110) (SIGT(I),I=1,IPAS)
      WRITE (6,'(//16H P(I,J) MATRIX :/)')
      DO 10 I=1,IPAS
      WRITE (6,110) (P(I,J),J=1,IPAS)
10    CONTINUE
      WRITE (6,'(//16H PIS(I) MATRIX :/)')
      DO 20 I=1,IPAS
      WRITE (6,110) (PIS(J,I),J=1,NCOUR)
20    CONTINUE
      WRITE (6,'(//13H PSS MATRIX :/)')
      DO 30 I=1,NCOUR
      WRITE (6,110) (PSS(I,J),J=1,NCOUR)
30    CONTINUE
      WRITE (6,'(//)')
      RETURN
100   FORMAT (1H1//19H GENERATING CELL NB,I4//21H TOTAL MACROSCOPIC CR,
     $ 14HOSS SECTIONS :/)
110   FORMAT (1X,1P,10E13.5)
      END
