*DECK TRFICS
      SUBROUTINE TRFICS(IPSYS ,IPTRK ,IPBTF ,IPRNTF,IDIR  ,NREGIO,
     >                  NUNKNO,MATCOD,VOLUME,KEYFLX,
     >                  FUNKNO,SUNKNO,TITRE)
C
C-------------------------    TRFICS    -------------------------------
C
C  1- PROGRAMME STATISTICS:
C      NAME      :  TRFICS
C      USE       :  FIND A RESIDUAL VECTOR CORRESPONDING TO A PIJ
C                   FLUX CALCULATION BY TRFICF
C      MODIFIED  :  91-03-19
C      AUTHOR    :  A. HEBERT
C
C  2- INPUT AND OUTPUT PARAMETERS:
C      IPSYS    : POINTER TO THE PIJ                 I
C      IPTRK    : POINTER TO THE TRACKING            I
C      IPBTF    : POINTER TO BINARY TRACKING FILE    I
C      IPRNTF   : PRINT SELECTION FOR FLUX MODULES   I
C      IDIR     : DIRECTION FOR PC                   I
C                  = 0 FOR PIJ OR WIJ
C                  = K FOR PIJK OR WIJK K=1,2,3
C      NREGIO   : NUMBER OF REGIONS CONSIDERED       I
C      NUNKNO   : NUMBER OF UNKNOWN IN THE SYSTEM    I
C      MATCOD   : MIXTURE CODE IN REGION             I(NREGIO)
C      VOLUME   : VOLUME OF REGION                   R(NREGIO)
C      KEYFLX   : FLUX ELEMENTS IN UNKNOWN SYSTEM    I(NREGIO)
C      FUNKNO   : UNKNOWN VECTOR SOLVED FOR          R(NUNKNO)
C      SUNKNO   : SOURCE FOR SYSTEM AT INPUT         R(NUNKNO)
C               : RESIDUAL VECTOR AT OUTPUT          R(NUNKNO)
C      TITRE    : TITLE                              C*72
C
C---------------------------    TRFICS    -----------------------------
C
      IMPLICIT    NONE
      INTEGER     IOUT
      CHARACTER   NAMSBR*6
      PARAMETER  (IOUT=6,NAMSBR='TRFICF')
C----
C  ROUTINE PARAMETERS
C----
      INTEGER     IPSYS,IPTRK,IPBTF,IPRNTF,IDIR,NREGIO,NUNKNO
      CHARACTER   TITRE*72
      INTEGER     MATCOD(NREGIO),KEYFLX(NREGIO)
      REAL        VOLUME(NREGIO),FUNKNO(NUNKNO),SUNKNO(NUNKNO)
C----
C  MEMORY ALLOCATION
C----
      INTEGER     IBASE(1)
      REAL        RBASE
      COMMON      RBASE(1)
      EQUIVALENCE(RBASE(1),IBASE(1))
      INTEGER     IFUNKN
C----
C  LOCAL PARAMETERS
C----
      INTEGER     IUN
C----
C  ALLOCATE MEMORY FOR DUMMY SOLUTION VECTOR AND SOLVE TRANSPORT EQN.
C----
      CALL SETARA(RBASE,NUNKNO,IFUNKN)
      CALL TRFICF(IPSYS ,IPTRK ,IPBTF ,     0,IDIR  ,NREGIO,
     >            NUNKNO,MATCOD,VOLUME,KEYFLX,
     >            RBASE(IFUNKN),SUNKNO,TITRE)
C----
C  COMPUTE RESIDUAL VECTOR
C----
      DO 100 IUN=1,NUNKNO
        SUNKNO(IUN)=FUNKNO(IUN)-RBASE(IFUNKN+IUN-1)
 100  CONTINUE
      CALL RLSARA(RBASE(IFUNKN))
C----
C  PRINT RESIDUAL VECTOR IF REQUIRED
C----
      IF(IPRNTF .GE. 3) THEN
        WRITE(IOUT,6000) NAMSBR
        WRITE(IOUT,6001)
     >    (SUNKNO(IUN),IUN=1,NUNKNO)
      ENDIF
      RETURN
C----
C  FORMATS
C----
 6000 FORMAT(1X,A6,' R E S I D U A L  V E C T O R   :')
 6001 FORMAT(1P,6(5X,E15.7))
      END
