*DECK XDRLPR
      SUBROUTINE XDRLPR(NPROC ,MINLEG,MAXLEG,IORD  ,NGROUP,INDPRO,
     >                  ITYPRO,XSREC ,SCAT  )
C
C------------------------------  XDRLGS  ------------------------------
C
C  PROGRAMME STATISTICS:
C     NAME     : XDRLGS
C     ENTRY    : XDRLGS
C     USE      : GET/SAVE XS FROM/ON IPLIB
C     MODIFIED : 97-08-17
C     AUTHOR   : G. MARLEAU
C
C  ROUTINE PARAMETERS:
C   INPUT
C     NPROC  : NUMBER OF TERMS TO PROCESS           I
C     MINLEG : MIMIMUM LEGENDRE ORDER TO PROCESS    I
C              FOR SCATTERING
C     MAXLEG : MIMIMUM LEGENDRE ORDER TO PROCESS    I
C              FOR SCATTERING
C     IORD   : ORDER                                I
C              = 1 CONSTANT
C              = 2 LINEAR
C              = 3 QUADRATIC
C     NGROUP : NUMBER OF GROUPS                     I
C     INDPRO : VECTOR FOR CROSS SECTION TO PROCESS  I(NPROC)
C              = 0 -> DO NOT PROCESS
C              > 0 -> PROCESS
C     ITYPRO : VECTOR FOR CROSS SECTION PROCESSED   I(NPROC)
C              PROCESSED
C              = 0 -> ABSENT  (NOT PROCESSED)
C              > 0 -> PRESENT (PROCESSED)
C     XSREC  : CROSS SECTION RECORDS                R(NGROUP,NPROC)
C              DEFAULT CROSS SECTIONS FOR
C              IRPROC=1,NDPROC
C              SCATTERING CROSS SECTION OF
C              ORDER MINLEG TO MAXLEG FOR
C              IRPROC=NDPROC+MINLEG+1,NDPROC+MAXLEG+1
C     SCAT   : COMPLETE SCATTERING MATRIX           R(NGROUP,
C              SCAT(JG,IG) IS FROM IG TO JG           NGROUP,
C              FOR ORDER MINLEG TO MAXLEG     MAXLEG-MINLEG+1)
C
C------------------------------  XDRLGS  ------------------------------
C
      INTEGER          NPROC ,MINLEG,MAXLEG,IORD  ,
     >                 NGROUP,INDPRO(NPROC),ITYPRO(NPROC)
      REAL             XSREC(NGROUP,NPROC),
     >                 SCAT(NGROUP,NGROUP,MAXLEG-MINLEG+1)
C----
C  LOCAL PARAMETERS
C  NDPROC = NUMBER OF DEFAULT CROSS SECTIONS = 20
C  NAMDXS = NAME OF NDPROC DEFAULT XS
C  SCATTERING CROSS SECTIONS START AT NDPROC+1 WITH
C  NAME NAMSCT='SIGS'//NAMLEG AND NAMSCT='SCAT'//NAMLEG
C  WITH NAMLEG DEFINED BY
C  WRITE(NAMLEG ,'(I2)') ILEG
C  FOR ILEG=0 TO NDPROC-NPROC-1
C----
      PARAMETER       (NDPROC=20,IOUT=6)
      CHARACTER        NAMDXS(NDPROC)*6,NAMLEG*2,NORD*6
      SAVE             NAMDXS
      DATA    NAMDXS  /'TOTAL ','TRANC ','NUSIGF','NFTOT ','CHI   ',
     >                 'NU    ','NG    ','NHEAT ','N2N   ','N3N   ',
     >                 'N4N   ','NP    ','NA    ','GOLD  ','ABS   ',
     >                 'NWT0  ','STRD  ','STRD X','STRD Y','STRD Z'/
C----
C  READ/INITIALIZE STATE VECTOR
C----
      IF(IORD.EQ.1) THEN
        NORD='      '
        IODIV=1
      ELSE IF(IORD.EQ.2) THEN
        NORD='   LIN'
        IODIV=2
      ELSE IF(IORD.EQ.3) THEN
        NORD='   QUA'
        IODIV=4
      ENDIF
C----
C  PRINT DEFAULT XS REQUIRED
C----
      DO 100 IXSR=1,NDPROC
        IF(INDPRO(IXSR).EQ.1) THEN
          IXSTN=MOD(ITYPRO(IXSR)/IODIV,2)
          IF(IXSTN.NE.0) THEN
            WRITE(IOUT,6000) NAMDXS(IXSR),NORD
            WRITE(IOUT,6010) (XSREC(IGR,IXSR),IGR=1,NGROUP)
          ENDIF
        ENDIF
 100  CONTINUE
C----
C  PRINT SCATTERING MATRIX
C----
      IL=0
      DO 110 ILEG=MINLEG+1,MAXLEG+1
        IL=IL+1
        IXSR=NDPROC+ILEG
        IF(INDPRO(IXSR).EQ.1) THEN
          IXSTN=MOD(ITYPRO(IXSR)/IODIV,2)
          IF(IXSTN.NE.0) THEN
            WRITE(NAMLEG,'(I2)') ILEG-1
            WRITE(IOUT,6000) 'SIGS'//NAMLEG,NORD
            WRITE(IOUT,6010) (XSREC(IGR,IXSR),IGR=1,NGROUP)
C----
C  SCAT(IGTO,IGFROM) REPRESENT SCATTERING CROSS SECTION
C  FROM GROUP "IGFROM" TO GROUP "IGTO"
C----
            WRITE(IOUT,6000) 'SCAT'//NAMLEG,NORD
            DO 120 IGFROM=1,NGROUP
              WRITE(IOUT,6001) IGFROM
              WRITE(IOUT,6010) (SCAT(IGTO,IGFROM,IL),IGTO=1,NGROUP)
 120        CONTINUE
          ENDIF
        ENDIF
 110  CONTINUE
C----
C  FORMAT
C----
 6000 FORMAT(' CROSS SECTION TYPE = ',2A6)
 6001 FORMAT(' SCATTERING FROM GROUP = ',I10)
 6010 FORMAT(1P,5E16.7)
      END
