*DECK XDRNED
      SUBROUTINE XDRNED(NPROC ,MINLEG,MAXLEG,ILEAKS ,NED   ,HVECT ,
     >                  IVECT ,INDPRO)
C
C-------------------------- XDRNED   ----------------------------------
C
C  PROGRAMME STATISTICS:
C     NAME     : LIBNED
C     ENTRY    : LIBNED
C     USE      : SET UP INDPRO FOR CROSS SECTION TO READ ON IPLIB
C                SEE XDRLGS FOR MORE INFORMATION
C     MODIFIED : 97-06-17
C     AUTHOR   : G. MARLEAU
C
C  ROUTINE PARAMETERS:
C   INPUT
C     NPROC  : NUMBER OF TERMS TO PROCESS           I
C     MINLEG : MIMIMUM LEGENDRE ORDER TO PROCESS    I
C              FOR SCATTERING
C     MAXLEG : MIMIMUM LEGENDRE ORDER TO PROCESS    I
C              FOR SCATTERING
C     ILEAKS : LEAK CALCULATION                     I
C              = 2 STRD
C              = 3 STRDX, STRDY and STRDZ
C     NED    : NUMBER OF EXTRA VECTOR EDITS         I
C     HVECT  : NAMES OF THE EXTRA VECTOR EDITS      C(NED)*6
C   OUTPUT
C     IVECT  : POINTER TO ADDITIONAL XS POSSIBLE    I(NED)
C     INDPRO : VECTOR FOR CROSS SECTION TO PROCESS  I(NPROC)
C              = 0 -> DO NOT PROCESS
C              > 0 -> PROCESS
C
C--------------------------  XDRNED  ----------------------------------
C
      INTEGER          NPROC ,MINLEG,MAXLEG,ILEAKS,NED,IVECT(NED),
     >                 INDPRO(NPROC)
      CHARACTER        HVECT(NED)*6
C----
C  LOCAL PARAMETERS
C  NDPROC = NUMBER OF DEFAULT CROSS SECTIONS = 20
C  NAMDXS = NAME OF NDPROC DEFAULT XS
C  SCATTERING CROSS SECTIONS START AT NDPROC+1 WITH
C  NAME NAMSCT='SIGS'//NAMLEG AND NAMSCT='SCAT'//NAMLEG
C  WITH NAMLEG DEFINED BY
C  WRITE(NAMLEG ,'(I2)') ILEG
C  FOR ILEG=0 TO NDPROC-NPROC-1
C----
      PARAMETER       (NDPROC=20,IOUT=6)
      CHARACTER        NAMDXS(NDPROC)*6
      SAVE             NAMDXS
      DATA    NAMDXS  /'TOTAL ','TRANC ','NUSIGF','NFTOT ','CHI   ',
     >                 'NU    ','NG    ','NHEAT ','N2N   ','N3N   ',
     >                 'N4N   ','NP    ','NA    ','GOLD  ','ABS   ',
     >                 'NWT0  ','STRD  ','STRD X','STRD Y','STRD Z'/
C----
C  SCAN FOR ADDITIONAL AND STANDARD CROSS SECTIONS TO BE SAVED
C----
      CALL XDRSET(IVECT,NED,0)
      CALL XDRSET(INDPRO,NPROC,0)
      NEDOTH=NED
      DO 100 IED=1,NED
        IF(HVECT(IED).EQ.'      ') THEN
          NEDOTH=NEDOTH-1
        ELSE
          DO 110 IXSR=1,NDPROC
            IF(HVECT(IED).EQ.NAMDXS(IXSR)) THEN
              NEDOTH=NEDOTH-1
              IVECT(IED)=IXSR
              INDPRO(IXSR)=1
              GO TO 115
            ENDIF
 110      CONTINUE
 115      CONTINUE
        ENDIF
 100  CONTINUE
      IF(NEDOTH.GE.1) THEN
        WRITE(IOUT,9000)
        DO 120 IED=1,NED
          IF(IVECT(IED).EQ.0.AND.
     >       HVECT(IED).NE.'      ') THEN
            WRITE(IOUT,9001) HVECT(IED)
          ENDIF
 120    CONTINUE
        WRITE(IOUT,9002)
      ENDIF
      DO 130 IXSR=1,7
        INDPRO(IXSR)=1
 130  CONTINUE
      INDPRO(16)=1
      IF(ILEAKS.EQ.2) THEN
        INDPRO(17)=1
      ELSE IF(ILEAKS.EQ.3) THEN
        INDPRO(18)=1
        INDPRO(19)=1
        INDPRO(20)=1
      ENDIF
      DO 140 IXSR=NDPROC+MINLEG+1,NDPROC+MAXLEG+1
        INDPRO(IXSR)=1
 140  CONTINUE
      RETURN
C----
C  FORMAT
C----
 9000 FORMAT(' XDRNED: ****** WARNING ******')
 9001 FORMAT(' INVALID CROSS SECTION TYPE : ',A6)
 9002 FORMAT(' *****************************')
      END
