*DECK XL3MAC
      SUBROUTINE XL3MAC(IPMACR,IPSYS,NGROUP,NBMIX,ITRANC,
     >                  XSSIGT,XSSIGW,XSSIG1,IPRNTM)
C
C---------------------------  XL3MAC  ---------------------------------
C
C 1- PROGRAMME STATISTICS:
C
C     NAME     :  XL3MAC
C     USE      :  GET MACROLIB TRANSPORT CROSS-SECTIONS
C     MODIFY   :  R.ROY (00-03-05: DECLARE ALL VARIABLE TYPES)
C     AUTHOR   :  R.ROY (96-04-03)
C
C 2- ROUTINE PARAMETERS:
C   INPUT
C     IPMACR   : POINTER TO THE MACROLIB                 I
C     IPSYS    : POINTER TO THE SYSTEM                   I
C     NGROUP   : NUMBER OF GROUPS TREATED                I
C     NBMIX    : NUMBER OF MIXTURES CONSIDERED           I
C     ITRANC   : TYPE OF TRANSPORT CORRECTIONS           I
C     IPRNTM   : PRINT OPTION FOR CROSS-SECTIONS         I
C   OUTPUT
C     XSSIGT   : GROUP TOTAL CROSS SECTION         R(NBMIX+1,NGROUP)
C     XSSIGW   : WITHIN GROUP SCATTERING           R(NBMIX+1,NGROUP)
C   WORK SPACE
C     XSSIG1   : SIG1 CROSS SECTION                      R(NBMIX+1)
C
C 3- INTERNAL PARAMETERS:
C     IUNOUT   : OUTPUT UNIT = 6                         I
C     ILCMUP   : GO UP LCM INDEX = 1                     I
C     ILCMDN   : GO DOWN LCM INDEX = 2                   I
C     CGRPNM   : GROUP NAME                              C*12
C
C---------------------------   XL3MAC  --------------------------------
C
      IMPLICIT    NONE
      INTEGER     IUNOUT,ILCMUP,ILCMDN
      PARAMETER  (IUNOUT=6,ILCMUP=1,ILCMDN=2)
      CHARACTER   CGRPNM*12
      INTEGER     IPSYS,IPMACR,IPRNTM,NGROUP,NBMIX,ITRANC,IGR,
     >            ILCMLN,IMX,ITYLCM
      REAL        XSSIGT(0:NBMIX,NGROUP),XSSIGW(0:NBMIX,NGROUP),
     >            XSSIG1(0:NBMIX)
C----
C  READ X-SECTIONS AND COMPUTE TRANSPORT CORRECTED X-SECTIONS
C----
      IF(IPRNTM.GE.1) THEN
        IF(ITRANC.NE.0) THEN
          WRITE(IUNOUT,6100)
        ELSE
          WRITE(IUNOUT,6101)
        ENDIF
      ENDIF
      DO 150 IGR=1,NGROUP
        WRITE(CGRPNM,'(5HGROUP,I3,1H/,I3)') IGR,NGROUP
        CALL LCMSIX(IPMACR,CGRPNM,ILCMUP)
        CALL LCMSIX(IPSYS,CGRPNM,ILCMUP)
        CALL LCMLEN(IPMACR,'TOTAL',ILCMLN,ITYLCM)
        IF(ILCMLN.GT.0) THEN
          CALL LCMGET(IPMACR,'TOTAL',XSSIGT(1,IGR))
          XSSIGT(0,IGR)=0.0
        ELSE
          CALL LCMLIB(IPMACR)
          CALL XABORT('XL3MAC: READ ERROR ON LCM RECORD= TOTAL')
        ENDIF
        DO 110 IMX=0,NBMIX
 110    XSSIGW(IMX,IGR)=0.0
        CALL LCMLEN(IPMACR,'SIGW 0',ILCMLN,ITYLCM)
        IF(ILCMLN.GT.0) THEN
          CALL LCMGET(IPMACR,'SIGW 0',XSSIGW(1,IGR))
        ENDIF
        IF( ITRANC.NE.0 )THEN
          CALL LCMLEN(IPMACR,'TRANC',ILCMLN,ITYLCM)
          IF(ILCMLN.GT.0) THEN
            CALL LCMGET(IPMACR,'TRANC',XSSIG1(1))
            DO 120 IMX=1,NBMIX
              XSSIGT(IMX,IGR)=XSSIGT(IMX,IGR)-XSSIG1(IMX)
              XSSIGW(IMX,IGR)=XSSIGW(IMX,IGR)-XSSIG1(IMX)
 120        CONTINUE
          ENDIF
        ENDIF
        IF(IPRNTM.GE.3) THEN
          WRITE(IUNOUT,6002)  IGR
          WRITE(IUNOUT,6003) (IMX,XSSIGT(IMX,IGR),XSSIGW(IMX,IGR),
     >    IMX=1,NBMIX)
        ENDIF
        CALL LCMPUT(IPSYS,'DRAGON-TXSC',(NBMIX+1),2,XSSIGT(0,IGR))
        CALL LCMPUT(IPSYS,'DRAGON-S0XSC',(NBMIX+1),2,XSSIGW(0,IGR))
        CALL LCMSIX(IPSYS,' ',ILCMDN)
        CALL LCMSIX(IPMACR,' ',ILCMDN)
 150  CONTINUE
      RETURN
C
C------ FORMATS
C
 6002 FORMAT(//30X,' G R O U P : ',I5//
     >30X,' TOTAL MACROSCOPIC CROSS SECTIONS PER MIXTURE '/)
 6003 FORMAT(3(1X,'MIXTURE',4X,'TOTAL',11X,'SIGW',3X)/
     >1P,3(1X,I4,3X,E12.5,3X,E12.5))
 6100 FORMAT(//' USE TRANSPORT CORRECTED CROSS-SECTIONS')
 6101 FORMAT(//' DO *NOT* USE TRANSPORT CORRECTED CROSS-SECTIONS')
      END
