      SUBROUTINE LCMADD(IPLIS1,IPLIS2)
*
*-----------------------------------------------------------------------
*
* ADD THE FLOATING POINT INFORMATION CONTAINED IN THE ACTIVE DIRECTORIES
* OF TWO LINKED LISTS OR XSM FILES POINTED BY IPLIS1 AND IPLIS2 AND
* STORE THE RESULT IN THE LINKED LIST OR XSM FILE POINTED BY IPLIS2.
*
* INPUT PARAMETERS:
*  IPLIS1 : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*  IPLIS2 : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*
* OUTPUT PARAMETER:
*  IPLIS2 : ADDRESS OF THE LINKED LIST OR HANDLE TO THE XSM FILE.
*
*------------------------------------- AUTHOR: A. HEBERT ; 02/11/93 ----
*
      CHARACTER NAMT*12,HSMG*131,CTMP1*4,CTMP2*4,NAME*12,NAMLCM*12,
     1 MYNAM1*12,MYNAM2*12
      REAL RR1(8),RR2(8)
      DOUBLE PRECISION DD1(4),DD2(4)
      INTEGER IBASE(1)
      LOGICAL LCM1,LCM2,LBASE(1)
      COMMON BASE(1)
      EQUIVALENCE (BASE(1),IBASE(1),LBASE(1)),(RR1(1),DD1(1)),
     1 (RR2(1),DD2(1))
*
      IF(IPLIS1.EQ.IPLIS2) THEN
         WRITE(HSMG,'(46HLCMADD: TWO LINKED LISTS OR XSM FILES HAVE THE,
     1   14H SAME HANDLE =,I10,1H.)') IPLIS1
         CALL XABORT(HSMG)
      ENDIF
      CALL LCMVAL(IPLIS1,' ')
      CALL LCMVAL(IPLIS2,' ')
      IFILE=KDROPN('DUMMYSQ',0,2,0,0)
      IF(IFILE.LE.0) CALL XABORT('LCMADD: KDROPN FAILURE.')
      CALL LCMEXP(IPLIS1,0,IFILE,1,1)
      REWIND(IFILE)
      READ(IFILE) JLEVEL,NAMT,ITY1,ILON1
      IF(JLEVEL.NE.1) CALL XABORT('LCMADD: INVALID EXPORT FILE.')
      ILEVEL=1
   10 IF(ITY1.EQ.3) ILON1=(ILON1+3)/4
      IF((ITY1.EQ.4).OR.(ITY1.EQ.6)) ILON1=2*ILON1
      DO 20 I=1,ILEVEL-JLEVEL
      CALL LCMSIX(IPLIS2,' ',2)
   20 CONTINUE
      ILEVEL=JLEVEL
      CALL LCMLEN(IPLIS2,NAMT,ILON2,ITY2)
      NAME=' '
      CALL LCMNXT(IPLIS1,NAME,MYNAM1,NAMLCM,LCM1)
      NAME=' '
      CALL LCMNXT(IPLIS2,NAME,MYNAM2,NAMLCM,LCM2)
      IF((ILON1.NE.ILON2).OR.(ITY1.NE.ITY2)) THEN
         WRITE(HSMG,'(20HLCMADD: TWO BLOCKS '',A12,6H'' OF '',A12,
     1   7H'' AND '',A12,23H'' ARE OF UNEQUAL TYPE (,2I4,8H) OR LEN,
     2   5HGTH (,2I7,2H).)') NAMT,MYNAM1,MYNAM2,ITY1,ITY2,ILON1,ILON2
         CALL XABORT(HSMG)
      ENDIF
      IF(ITY1.EQ.0) THEN
*        DIRECTORY DATA.
         ILEVEL=ILEVEL+1
         CALL LCMSIX(IPLIS2,NAMT,1)
      ELSE
         CALL SETARA(BASE,ILON1,IAS1)
         IF(LCM2) THEN
            IAS2=LCMIOF(IPLIS2,NAMT)
         ELSE
            CALL SETARA(BASE,ILON2,IAS2)
            CALL LCMGET(IPLIS2,NAMT,BASE(IAS2))
         ENDIF
         IF(ITY1.EQ.1) THEN
*           INTEGER DATA.
            DO 25 I=1,1+(ILON1-1)/8
            IOFSET=IAS1+(I-1)*8-1
            READ(IFILE) (IBASE(IOFSET+J),J=1,MIN(8,ILON1-(I-1)*8))
   25       CONTINUE
            DO 30 I=1,ILON1
            IF(IBASE(IAS1+I-1).NE.IBASE(IAS2+I-1)) THEN
               WRITE(HSMG,'(39HLCMADD: INCONSISTENT INTEGER DATA ON TH,
     1         27HE TWO DIRECTORIES. RECORD='',A12,1H'')') NAMT
               CALL XABORT(HSMG)
            ENDIF
   30       CONTINUE
         ELSE IF((ITY1.EQ.2).OR.(ITY1.EQ.6)) THEN
*           SINGLE PRECISION OR COMPLEX DATA.
            DO 35 I=1,1+(ILON1-1)/8
            IOFSET=IAS1+(I-1)*8-1
            READ(IFILE) (BASE(IOFSET+J),J=1,MIN(8,ILON1-(I-1)*8))
   35       CONTINUE
            DO 40 I=1,ILON1
   40       BASE(IAS2+I-1)=BASE(IAS1+I-1)+BASE(IAS2+I-1)
            IF(LCM2) THEN
               CALL LCMPOF(IPLIS2,NAMT,ILON1,ITY1,IAS2)
            ELSE
               CALL LCMPUT(IPLIS2,NAMT,ILON1,ITY1,BASE(IAS2))
            ENDIF
         ELSE IF(ITY1.EQ.3) THEN
*           CHARACTER*4 DATA.
            DO 45 I=1,1+(ILON1-1)/8
            IOFSET=IAS1+(I-1)*8-1
            READ(IFILE) (BASE(IOFSET+J),J=1,MIN(8,ILON1-(I-1)*8))
   45       CONTINUE
            DO 50 I=1,ILON1
              WRITE(CTMP1,'(A4)') BASE(IAS1+I-1)
              WRITE(CTMP2,'(A4)') BASE(IAS2+I-1)
              IF(CTMP1.NE.CTMP2) THEN
               WRITE(HSMG,'(39HLCMADD: INCONSISTENT CHARACTER DATA ON ,
     1         29HTHE TWO DIRECTORIES. RECORD='',A12,1H'')') NAMT
               CALL XABORT(HSMG)
              ENDIF
   50       CONTINUE
         ELSE IF(ITY1.EQ.4) THEN
*           DOUBLE PRECISION DATA.
            DO 80 IL=1,1+(ILON1-1)/8
            DO 60 I=1,MIN(8,ILON1-(IL-1)*8)
   60       RR2(I)=BASE(IAS2+(IL-1)*8+I-1)
            READ(IFILE) (DD1(I),I=1,MIN(4,ILON1/2-(IL-1)*4))
            DO 70 I=1,MIN(4,ILON1/2-(IL-1)*4)
   70       DD2(I)=DD1(I)+DD2(I)
            DO 80 I=1,MIN(8,ILON1-(IL-1)*8)
   80       BASE(IAS2+(IL-1)*8+I-1)=RR2(I)
            IF(LCM2) THEN
               CALL LCMPOF(IPLIS2,NAMT,ILON1,4,IAS2)
            ELSE
               CALL LCMPUT(IPLIS2,NAMT,ILON1,4,BASE(IAS2))
            ENDIF
        ELSE IF(ITY1.EQ.5) THEN
*           LOGICAL DATA.
            DO 85 I=1,1+(ILON1-1)/8
            IOFSET=IAS1+(I-1)*8-1
            READ(IFILE) (LBASE(IOFSET+J),J=1,MIN(8,ILON1-(I-1)*8))
   85       CONTINUE
            DO 90 I=1,ILON1
            IF(LBASE(IAS1+I-1).NEQV.LBASE(IAS2+I-1)) THEN
               WRITE(HSMG,'(39HLCMADD: INCONSISTENT LOGICAL DATA ON TH,
     1         27HE TWO DIRECTORIES. RECORD='',A12,1H'')') NAMT
               CALL XABORT(HSMG)
            ENDIF
   90       CONTINUE
         ELSE
            CALL XABORT('LCMADD: INVALID DATA TYPE.')
         ENDIF
         IF(.NOT.LCM2) CALL RLSARA(BASE(IAS2))
         CALL RLSARA(BASE(IAS1))
      ENDIF
      READ(IFILE,END=130) JLEVEL,NAMT,ITY1,ILON1
      GO TO 10
*
  130 DO 140 I=1,ILEVEL-1
      CALL LCMSIX(IPLIS2,' ',2)
  140 CONTINUE
      IRC=KDRCLS(IFILE,2)
      IF(IRC.LT.0) CALL XABORT('LCMADD: KDRCLS FAILURE.')
      RETURN
      END
