      SUBROUTINE XSMLEN(IPLIST,NAMP,ILONG,ITYPE)
*
*-----------------------------------------------------------------------
*
* RETURN THE LENGTH AND TYPE OF A BLOCK. RETURN 0 IF THE BLOCK DOES NOT
* EXISTS.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE HANDLE TO THE XSM FILE.
*   NAMP  : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*   ILONG : NUMBER OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*           ILONG=-1 IS RETURNED FOR A DIRECTORY.
*           ILONG=0 IF THE BLOCK DOES NOT EXISTS.
*   ITYPE : TYPE OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*           0: DIRECTORY                1: INTEGER
*           2: SINGLE PRECISION         3: CHARACTER*4
*           4: DOUBLE PRECISION         5: LOGICAL
*           6: COMPLEX                  7: UNDEFINED
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      PARAMETER (IOFMAX=30)
      INTEGER PFXSM
      CHARACTER*(*) NAMP
      CHARACTER NAMT*12,HNAME*12,HSMG*131,MYNAME*12,CMT(IOFMAX)*12
      PARAMETER (IHEAD=0,IHNAM=1,IMODIF=4,IIFILE=5,INMT=6,ILINK=7,
     1 IIROOT=8,IIOFS=9,IJLON=9+IOFMAX,IJTYP=9+2*IOFMAX,
     2 IIDIR=9+3*IOFMAX,IIOFT=10+3*IOFMAX,IIMPF=11+3*IOFMAX,
     3 IMYNAM=12+3*IOFMAX,ICMT=15+3*IOFMAX)
      COMMON IBASE(1)
*
      PFXSM=IPLIST
      WRITE(HNAME,'(3A4)') (IBASE(PFXSM+IHNAM+I),I=0,2)
      IF(IBASE(PFXSM+IHEAD).NE.200) THEN
         WRITE(HSMG,'(22HXSMLEN: THE XSM FILE '',A12,14H'' HAVE THE WRO,
     1   10HNG HEADER.)') HNAME
         CALL XABORT(HSMG)
      ENDIF
      NAMT=NAMP
      ILONG=0
      ITYPE=7
      DO 10 J=1,IBASE(PFXSM+INMT)
      WRITE(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   10 CONTINUE
      WRITE(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
      CALL XSMREP(NAMT,1,IBASE(PFXSM+IIFILE),IBASE(PFXSM+IMODIF),CMT,
     1 IBASE(PFXSM+INMT),IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),
     2 MYNAME,IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),
     3 IBASE(PFXSM+IJTYP),IBASE(PFXSM+IIDIR),III)
      READ(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
      DO 20 J=1,IBASE(PFXSM+INMT)
      READ(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   20 CONTINUE
      IF(III.GT.0) THEN
*        THE BLOCK EXISTS.
         ILONG=IBASE(PFXSM+IJLON+III-1)
         ITYPE=IBASE(PFXSM+IJTYP+III-1)
      ENDIF
      RETURN
      END
