      SUBROUTINE XSMPUT(IPLIST,NAMP,ILONG,ITYPE,DATA1)
*
*-----------------------------------------------------------------------
*
* COPY A BLOCK FROM MEMORY INTO THE XSM FILE.
*
* INPUT PARAMETERS:
*  IPLIST : ADDRESS OF THE HANDLE TO THE XSM FILE.
*   NAMP  : CHARACTER*12 NAME OF THE CURRENT BLOCK.
*   ILONG : NUMBER OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*   ITYPE : TYPE OF INFORMATION ELEMENTS STORED IN THE CURRENT BLOCK.
*           0: DIRECTORY                1: INTEGER
*           2: SINGLE PRECISION         3: CHARACTER*4
*           4: DOUBLE PRECISION         5: LOGICAL
*           6: COMPLEX                  7: UNDEFINED
*   DATA1 : INFORMATION ELEMENTS. DIMENSION DATA1(ILONG)
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      PARAMETER (IOFMAX=30)
      INTEGER PFXSM
      CHARACTER*(*) NAMP
      CHARACTER NAMT*12,HNAME*12,HSMG*131,MYNAME*12,CMT(IOFMAX)*12
      DIMENSION DATA1(*)
      PARAMETER (IWRD=3,KLONG=5+IWRD+(3+IWRD)*IOFMAX)
*     KLONG=LENGTH OF A DIRECTORY EXTENT IN MEMORY.
      PARAMETER (IHEAD=0,IHNAM=1,IMODIF=4,IIFILE=5,INMT=6,ILINK=7,
     1 IIROOT=8,IIOFS=9,IJLON=9+IOFMAX,IJTYP=9+2*IOFMAX,
     2 IIDIR=9+3*IOFMAX,IIOFT=10+3*IOFMAX,IIMPF=11+3*IOFMAX,
     3 IMYNAM=12+3*IOFMAX,ICMT=15+3*IOFMAX)
      LOGICAL LBASE(1)
      COMMON IBASE(1)
      EQUIVALENCE (IBASE(1),LBASE(1))
*
* COPY A BLOCK FROM MEMORY INTO THE XSM FILE.
      PFXSM=IPLIST
      WRITE(HNAME,'(3A4)') (IBASE(PFXSM+IHNAM+I),I=0,2)
      IF(IBASE(PFXSM+IIMPF).EQ.2) THEN
         WRITE(HSMG,'(22HXSMPUT: THE XSM FILE '',A12,14H'' IS OPEN IN R,
     1   14HEAD-ONLY MODE.)') HNAME
         CALL XABORT(HSMG)
      ELSE IF((ITYPE.LE.0).OR.(ITYPE.GE.8)) THEN
         WRITE(HSMG,'(29HXSMPUT: INVALID TYPE NUMBER (,I3,10H) FOR XSM ,
     1   6HFILE '',A12,2H''.)') ITYPE,HNAME
         CALL XABORT(HSMG)
      ELSE IF(IBASE(PFXSM+IHEAD).NE.200) THEN
         WRITE(HSMG,'(22HXSMPUT: THE XSM FILE '',A12,14H'' HAVE THE WRO,
     1   10HNG HEADER.)') HNAME
         CALL XABORT(HSMG)
      ENDIF
      NAMT=NAMP
      DO 10 J=1,IBASE(PFXSM+INMT)
      WRITE(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   10 CONTINUE
      WRITE(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
      CALL XSMREP(NAMT,2,IBASE(PFXSM+IIFILE),LBASE(PFXSM+IMODIF),CMT,
     1 IBASE(PFXSM+INMT),IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),
     2 MYNAME,IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),
     3 IBASE(PFXSM+IJTYP),IBASE(PFXSM+IIDIR),III)
      READ(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
      DO 20 J=1,IBASE(PFXSM+INMT)
      READ(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   20 CONTINUE
      IF(III.GT.0) THEN
*        THE BLOCK ALREADY EXISTS. REPLACE IT.
         LBASE(PFXSM+IMODIF)=.TRUE.
         IF(ILONG.GT.IBASE(PFXSM+IJLON+III-1)) THEN
            IBASE(PFXSM+IIOFS+III-1)=IBASE(PFXSM+IIOFT)
            IBASE(PFXSM+IIOFT)=IBASE(PFXSM+IIOFT)+ILONG
         ENDIF
         IBASE(PFXSM+IJLON+III-1)=ILONG
         IBASE(PFXSM+IJTYP+III-1)=ITYPE
         CALL KDIPUT(IBASE(PFXSM+IIFILE),DATA1,IBASE(PFXSM+IIOFS+III-1),
     1   ILONG,IRC)
         IF(IRC.NE.0) GO TO 150
         RETURN
      ELSE
*        THE BLOCK DOES NOT ALREADY EXISTS. CREATE IT.
         IF(IBASE(PFXSM+INMT).EQ.IOFMAX) THEN
*           THE ACTIVE DIRECTORY IS FULL. CREATE AN EXTENT.
            IPOS=IBASE(PFXSM+ILINK)
            IBASE(PFXSM+ILINK)=IBASE(PFXSM+IIOFT)
            IF(LBASE(PFXSM+IMODIF)) THEN
               DO 30 J=1,IBASE(PFXSM+INMT)
               WRITE(CMT(J),'(3A4)') (IBASE(PFXSM+ICMT+(J-1)*3+I),I=0,2)
   30          CONTINUE
               WRITE(MYNAME,'(3A4)') (IBASE(PFXSM+IMYNAM+I),I=0,2)
               CALL XSMDIR(2,IBASE(PFXSM+IIFILE),CMT,IBASE(PFXSM+INMT),
     1         IBASE(PFXSM+ILINK),IBASE(PFXSM+IIROOT),MYNAME,
     2         IBASE(PFXSM+IIOFS),IBASE(PFXSM+IJLON),IBASE(PFXSM+IJTYP),
     3         IBASE(PFXSM+IIDIR))
            ELSE
               CALL KDIPUT(IBASE(PFXSM+IIFILE),IBASE(PFXSM+ILINK),
     1         IBASE(PFXSM+IIDIR)+3,1,IRC)
               IF(IRC.NE.0) GO TO 150
            ENDIF
            IBASE(PFXSM+IIDIR)=IBASE(PFXSM+ILINK)
            IBASE(PFXSM+ILINK)=IPOS
            IBASE(PFXSM+IIOFT)=IBASE(PFXSM+IIOFT)+KLONG
            IBASE(PFXSM+INMT)=0
         ENDIF
         IBASE(PFXSM+INMT)=IBASE(PFXSM+INMT)+1
         NMT=IBASE(PFXSM+INMT)
         READ(NAMT,'(3A4)') (IBASE(PFXSM+ICMT+(NMT-1)*3+I),I=0,2)
         IBASE(PFXSM+IJLON+NMT-1)=ILONG
         IBASE(PFXSM+IJTYP+NMT-1)=ITYPE
         IBASE(PFXSM+IIOFS+NMT-1)=IBASE(PFXSM+IIOFT)
         CALL KDIPUT(IBASE(PFXSM+IIFILE),DATA1,IBASE(PFXSM+IIOFS+NMT-1),
     1   ILONG,IRC)
         IF(IRC.NE.0) GO TO 150
         LBASE(PFXSM+IMODIF)=.TRUE.
         IBASE(PFXSM+IIOFT)=IBASE(PFXSM+IIOFT)+ILONG
      ENDIF
      RETURN
*
  150 WRITE(HSMG,'(24HXSMPUT: KDIPUT ERROR NB.,I6,14H ON XSM FILE '',
     1 A12,2H''.)') IRC,HNAME
      CALL XABORT(HSMG)
      END
