      SUBROUTINE XSMREP(NAMT,IND,IFILE,MODIF,CMT,NMT,LINK,IROOT,MYNAME,
     1 IOFSET,JLONG,JTYPE,IDIR,III)
*
*-----------------------------------------------------------------------
*
* FIND A BLOCK (RECORD OR DIRECTORY) POSITION IN THE ACTIVE DIRECTORY
* AND RELATED EXTENTS.
*
* INPUT PARAMETERS:
*  NAMT   : CHARACTER*12 NAME OF THE REQUIRED BLOCK.
*  IND    : =1 SEARCH NAMT ; =2 SEARCH AND POSITIONNING IN AN EMPTY
*           SLOT OF THE ACTIVE DIRECTORY IF NAMT DOES NOT EXISTS.
*  IFILE  : UNIT NUMBER OF THE XSM FILE.
*  MODIF  : =.TRUE. IF THE ACTIVE DIRECTORY EXTENT HAVE BEEN MODIFIED.
*  CMT    : LIST OF CHARACTER*12 NAMES OF EACH BLOCK (RECORD OR
*           DIRECTORY) THAT BELONG TO THE ACTIVE DIRECTORY EXTENT.
*  NMT    : NUMBER OF BLOCKS STORED ON THE ACTIVE DIRECTORY EXTENT.
*  LINK   : OFFSET OF THE NEXT DIRECTORY EXTENT.
*  IROOT  : OFFSET OF ANY PARENT DIRECTORY EXTENT.
*  MYNAME : CHARACTER*12 NAME OF THE ACTIVE DIRECTORY. MYNAME='/' FOR
*           THE ROOT LEVEL.
*  IOFSET : OFFSET LIST (POSITION OF THE FIRST ELEMENT OF EACH BLOCK
*           THAT BELONG TO THE ACTIVE DIRECTORY EXTENT).
*  JLONG  : LENGTH OF EACH RECORD (JLONG=0 FOR A DIRECTORY) THAT BELONG
*           TO THE ACTIVE DIRECTORY EXTENT.
*  JTYPE  : TYPE OF EACH BLOCK THAT BELONG TO THE ACTIVE DIRECTORY
*           EXTENT.
*  IDIR   : OFFSET OF THE ACTIVE DIRECTORY EXTENT.
*
* OUTPUT PARAMETER:
*  III    : RETURN CODE. =0 IF THE BLOCK NAMED NAMT DOES NOT EXISTS;
*           =POSITION IN THE ACTIVE DIRECTORY EXTENT IF NAMT EXTSTS.
*
*------------------------------------- AUTHOR: A. HEBERT ; 30/09/86 ----
*
      PARAMETER (IOFMAX=30)
      CHARACTER*(*) NAMT,CMT(*),MYNAME
      LOGICAL MODIF
      DIMENSION IOFSET(*),JLONG(*),JTYPE(*)
*
      IPOS=-1
      IF (NMT.LT.IOFMAX) IPOS=IDIR
      IF (NMT.EQ.0) GO TO 50
      DO 10 I=1,NMT
      IF (NAMT.EQ.CMT(I)) THEN
*        THE BLOCK ALREADY EXISTS.
         III=I
         RETURN
      ENDIF
   10 CONTINUE
*
*     THE BLOCK NAMT DOES NOT EXISTS IN THE ACTIVE DIRECTORY EXTENT. WE
*     SEARCH IN OTHER EXTENTS THAT BELONG TO THE ACTIVE DIRECTORY.
      IF (IDIR.NE.LINK) THEN
*        RECOVER A NEW DIRECTORY EXTENT.
         ISTART=LINK
         IF (MODIF) THEN
            CALL XSMDIR(2,IFILE,CMT,NMT,LINK,IROOT,MYNAME,IOFSET,JLONG,
     1      JTYPE,IDIR)
            MODIF=.FALSE.
         ENDIF
         IDIR=ISTART
   30    CALL XSMDIR(1,IFILE,CMT,NMT,LINK,IROOT,MYNAME,IOFSET,JLONG,
     1   JTYPE,IDIR)
         IF (NMT.LT.IOFMAX) IPOS=IDIR
         DO 40 I=1,NMT
         IF (NAMT.EQ.CMT(I)) THEN
*           THE BLOCK NAMT WAS FOUND IN THE ACTIVE DIRECTORY EXTENT.
            III=I
            RETURN
         ENDIF
   40    CONTINUE
         IF (LINK.EQ.ISTART) GO TO 50
         IDIR=LINK
         GO TO 30
      ENDIF
   50 III=0
      IF (IND.EQ.1) RETURN
*
* POSITIONNING IN AN EXTENT WITH EMPTY SLOTS.
      IF ((IPOS.GE.0).AND.(IPOS.NE.IDIR)) THEN
*        AN EXTENT WITH AN EMPTY SLOT WAS FOUND.
         IDIR=IPOS
         CALL XSMDIR(1,IFILE,CMT,NMT,LINK,IROOT,MYNAME,IOFSET,JLONG,
     1   JTYPE,IDIR)
      ENDIF
      RETURN
      END
