*DECK ALDLSV
      SUBROUTINE ALDLSV (NG,L4,MU1,ASS,F,T)
*
*-----------------------------------------------------------------------
*
* SOLUTION OF *NG* SYMMETRIC LINEAR SYSTEMS WHERE THE COEFFICIENT MATRIX
* HAVE BEEN FACTORIZED BY A PRECEDING CALL TO ALDLFV.
*
* INPUT PARAMETERS:
*    NG : NUMBER OF SYSTEM TO SOLVE.
*    L4 : ORDER OF THE COEFFICIENT MATRIX.
*   MU1 : POSITION OF EACH DIAGONAL ELEMENT IN VECTOR ASS.
*         DIMENSION MU1(L4)
*   ASS : LDL(T) FACTORS OF THE COEFFICIENT MATRIX IN COMPRESSED
*         DIAGONAL STORAGE MODE. DIMENSION ASS(NG,MU1(L4)-MU1(1)+1)
*     F : RIGHT-HAND SIDES OF LINEAR SYSTEMS. DIMENSION F(NG,L4)
*     T : WORKING-SPACE VECTOR. DIMENSION T(NG)
*
* OUTPUT PARAMETER:
*     F : SOLUTION OF LINEAR SYSTEM.S DIMENSION F(NG,L4)
*
*-------------------------------------- AUTHOR: A. HEBERT ; 15/09/89 ---
*-------------------------------------- MODIFY: R. ROY ;    17/09/96 ---
*
      IMPLICIT NONE
      INTEGER NG,L4,MU1(*)
      INTEGER K,K1,K2,KJ,I,IG
      DOUBLE PRECISION ASS(NG,*),F(NG,*),T(NG)
      IF( L4.NE.1 )THEN
         K1= MU1(1)+1
         DO 20 I=2,L4
            K2= MU1(I)
            KJ= I-K2+K1
            DO 5 IG= 1, NG
               T(IG)=-F(IG,I)
    5       CONTINUE
            DO 10 K=K1,K2-1
               DO 15 IG= 1, NG
                  T(IG)=T(IG)+F(IG,KJ)*ASS(IG,K)
   15          CONTINUE
               KJ=KJ+1
   10       CONTINUE
            K1=K2+1
            DO 25 IG= 1, NG
               F(IG,I)=-T(IG)
   25       CONTINUE
   20    CONTINUE
C
         DO 30 I=1,L4
         DO 30 IG= 1, NG
           F(IG,I)=F(IG,I)*ASS(IG,MU1(I))
   30    CONTINUE
C
         K2= MU1(L4)
         DO 50 I=L4,2,-1
            DO 35 IG=1,NG
               T(IG)=-F(IG,I)
   35       CONTINUE
            K1= MU1(I-1)+1
            KJ= I-K2+K1
            DO 40 K=K1,K2-1
               DO 45 IG=1,NG
                  F(IG,KJ)=F(IG,KJ)+ASS(IG,K)*T(IG)
   45          CONTINUE
               KJ=KJ+1
   40       CONTINUE
         K2=K1-1
   50    CONTINUE
      ELSE
C
         DO 60 IG= 1,NG
            F(IG,1)=F(IG,1)*ASS(IG,MU1(1))
   60    CONTINUE
      ENDIF
      RETURN
      END
