*DECK ALPOLY
      SUBROUTINE ALPOLY(B,NOR,ROOTS,DENOM,COEF)
*
*-----------------------------------------------------------------------
*
* FIND THE PARTIAL FRACTION REPRESENTATION OF A POLYNOMIAL.
*
* INPUT PARAMETERS:
*  B      : POLYNOMIAL COEFFICIENTS OF THE DENOMINATOR OF THE PADE
*           APPROXIMATION. B(0) IS THE LINEAR TERM.
*           DOUBLE PRECISION B(0:NOR)
*  NOR    : POLYNOMIAL ORDER
*  ROOTS  : ROOTS. COMPLEX DOUBLE PRECISION ROOTS(2,NOR)
*
* OUTPUT PARAMETER:
*  DENOM  : COMPLEX ROOTS
*  COEF   : COMPLEX EXPANSION COEFFICIENTS
*
*-----------------------------------------------------------------------
*
      IMPLICIT         NONE
      INTEGER          NOR
      DOUBLE PRECISION B(0:NOR),ROOTS(2,NOR+1)
      COMPLEX          DENOM(NOR+1),COEF(NOR+1)
*----
*  LOCAL VARIABLES
*----
      INTEGER          NMAX,NORIN,IREAL,IMAGI,I,J,NORP1
      PARAMETER       (NMAX=11,NORIN=(NMAX-1)/2,IREAL=1,IMAGI=2)
      DOUBLE PRECISION DCTMP(2,0:NORIN),DD(2),DCINV(2),DCPRO(2),SGN
*----
*  TRANSFER DOUBLE COMPLEX ROOT TO COMPLEX ROOT
*  AND COMPUTE COMPLEX COEFFICIENT
*----
      NORP1=NOR+1
      DO 100 I=1,NORP1
*----
*  DCTMP(J)=ROOTS**(J)
*----
        DCTMP(IREAL,0)=1.0D0
        DCTMP(IMAGI,0)=0.0D0
        DO 110 J=1,NOR
          DCTMP(IREAL,J)=DCTMP(IREAL,J-1)*ROOTS(IREAL,I)-
     >                   DCTMP(IMAGI,J-1)*ROOTS(IMAGI,I)
          DCTMP(IMAGI,J)=DCTMP(IREAL,J-1)*ROOTS(IMAGI,I)+
     >                   DCTMP(IMAGI,J-1)*ROOTS(IREAL,I)
 110    CONTINUE
        DD(IREAL)=DCTMP(IREAL,NOR)
        DD(IMAGI)=DCTMP(IMAGI,NOR)
        SGN=1.0D0
        DO 120 J=NOR,1,-1
          SGN=-SGN
          DD(IREAL)=DD(IREAL)+SGN*B(J-1)*DCTMP(IREAL,J-1)
          DD(IMAGI)=DD(IMAGI)+SGN*B(J-1)*DCTMP(IMAGI,J-1)
 120    CONTINUE
        DO 130 J=1,NORP1
          IF(J.NE.I) THEN
            DCINV(IREAL)=ROOTS(IREAL,I)-ROOTS(IREAL,J)
            DCINV(IMAGI)=ROOTS(IMAGI,I)-ROOTS(IMAGI,J)
            CALL DCADIV(DCINV,DCINV)
            DCPRO(IREAL)=DD(IREAL)*DCINV(IREAL)-
     >                   DD(IMAGI)*DCINV(IMAGI)
            DCPRO(IMAGI)=DD(IREAL)*DCINV(IMAGI)+
     >                   DD(IMAGI)*DCINV(IREAL)
            DD(IREAL)=DCPRO(IREAL)
            DD(IMAGI)=DCPRO(IMAGI)
          ENDIF
 130    CONTINUE
        DENOM(I)=CMPLX(REAL(ROOTS(IREAL,I)),REAL(ROOTS(IMAGI,I)))
        COEF(I)=CMPLX(REAL(DD(IREAL)),REAL(DD(IMAGI)))
 100  CONTINUE
      RETURN
      END
